Package: SpatialExperiment
Version: 1.16.0
Title: S4 Class for Spatially Resolved -omics Data
Description: Defines an S4 class for storing data from spatial -omics experiments. 
    The class extends SingleCellExperiment to 
    support storage and retrieval of additional information from spot-based and 
    molecule-based platforms, including spatial coordinates, images, and 
    image metadata. A specialized constructor function is included for data 
    from the 10x Genomics Visium platform.
Authors@R: c(
    person("Dario", "Righelli", role=c("aut", "cre"), 
        email="dario.righelli@gmail.com"), 
    person("Davide", "Risso", role=c("aut"), 
        email="risso.davide@gmail.com"), 
    person("Helena L.", "Crowell", role=c("aut"), 
        email="helena.crowell@uzh.ch"), 
    person("Lukas M.", "Weber", role=c("aut"), 
        email="lukas.weber.edu@gmail.com"),
    person("Nicholas J.", "Eagles", role=c("ctb"),
        email="nickeagles77@gmail.com"))
URL: https://github.com/drighelli/SpatialExperiment
BugReports: https://github.com/drighelli/SpatialExperiment/issues
License: GPL-3
Encoding: UTF-8
biocViews: DataRepresentation, DataImport, Infrastructure,
        ImmunoOncology, GeneExpression, Transcriptomics, SingleCell,
        Spatial
Depends: methods, SingleCellExperiment
Imports: rjson, grDevices, magick, utils, S4Vectors,
        SummarizedExperiment, BiocGenerics, BiocFileCache
Suggests: knitr, rmarkdown, testthat, BiocStyle, BumpyMatrix,
        DropletUtils
VignetteBuilder: knitr
RoxygenNote: 7.2.3
git_url: https://git.bioconductor.org/packages/SpatialExperiment
git_branch: RELEASE_3_20
git_last_commit: 8798cb0
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 02:59:07 UTC; biocbuild
Author: Dario Righelli [aut, cre],
  Davide Risso [aut],
  Helena L. Crowell [aut],
  Lukas M. Weber [aut],
  Nicholas J. Eagles [ctb]
Maintainer: Dario Righelli <dario.righelli@gmail.com>

Package: SpatialExperiment
Version: 1.22.0
Title: S4 Class for Spatially Resolved -omics Data
Description: Defines an S4 class for storing data from spatial -omics experiments. 
    The class extends SingleCellExperiment to 
    support storage and retrieval of additional information from spot-based and 
    molecule-based platforms, including spatial coordinates, images, and 
    image metadata. A specialized constructor function is included for data 
    from the 10x Genomics Visium platform.
Authors@R: c(
    person("Dario", "Righelli", role=c("aut", "cre"), 
        email="dario.righelli@gmail.com",
        comment=c(ORCID="0000-0003-1504-3583")),
    person("Davide", "Risso", role=c("aut"), 
        email="risso.davide@gmail.com",
        comment=c(ORCID="0000-0001-8508-5012")),
    person("Helena L.", "Crowell", role=c("aut"), 
        email="helena.crowell@cnag.eu",
        comment=c(ORCID="0000-0002-4801-1767")), 
    person("Lukas M.", "Weber", role=c("aut"), 
        email="lmweb012@gmail.com",
        comment=c(ORCID="0000-0002-3282-1730")), 
    person("Nicholas J.", "Eagles", role=c("ctb"),
        email="nickeagles77@gmail.com"))
URL: https://github.com/drighelli/SpatialExperiment
BugReports: https://github.com/drighelli/SpatialExperiment/issues
License: GPL-3
Encoding: UTF-8
biocViews: DataRepresentation, DataImport, Infrastructure,
        ImmunoOncology, GeneExpression, Transcriptomics, SingleCell,
        Spatial
Depends: R (>= 4.1.0), methods, SingleCellExperiment
Imports: rjson, grDevices, magick, utils, S4Vectors,
        SummarizedExperiment, BiocGenerics, BiocFileCache
Suggests: knitr, rmarkdown, testthat, BiocStyle, BumpyMatrix,
        DropletUtils, VisiumIO
VignetteBuilder: knitr
RoxygenNote: 7.3.1
git_url: https://git.bioconductor.org/packages/SpatialExperiment
git_branch: RELEASE_3_23
git_last_commit: 90e092a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:52:41 UTC; biocbuild
Author: Dario Righelli [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-1504-3583>),
  Davide Risso [aut] (ORCID: <https://orcid.org/0000-0001-8508-5012>),
  Helena L. Crowell [aut] (ORCID:
    <https://orcid.org/0000-0002-4801-1767>),
  Lukas M. Weber [aut] (ORCID: <https://orcid.org/0000-0002-3282-1730>),
  Nicholas J. Eagles [ctb]
Maintainer: Dario Righelli <dario.righelli@gmail.com>

# SpatialExperiment

[![R build status](https://github.com/drighelli/SpatialExperiment/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/drighelli/SpatialExperiment/actions)

`SpatialExperiment` is an R/Bioconductor S4 class for storing data from spatial -omics experiments. The class extends the `SingleCellExperiment` class for single-cell data to support storage and retrieval of additional information from spot-based and molecule-based platforms, including spatial coordinates, images, and image metadata. A specialized constructor function is included for data from the 10x Genomics Visium platform.

The `SpatialExperiment` package is available from [Bioconductor](https://bioconductor.org/packages/SpatialExperiment).

A vignette containing examples and documentation is available from [Bioconductor](https://bioconductor.org/packages/SpatialExperiment), and additional details are provided in our [paper](https://doi.org/10.1093/bioinformatics/btac299).

The following schematic illustrates the `SpatialExperiment` class structure.

<img src="vignettes/SPE.png" width="800"/>


## Installation

The current release version of the `SpatialExperiment` package can be installed from Bioconductor as follows. This is the recommended approach for most users.

```
install.packages("BiocManager")
BiocManager::install("SpatialExperiment")
```

The latest development version can be installed from the [development version of Bioconductor](https://contributions.bioconductor.org/use-devel.html) or from GitHub (which may also require some dependency packages to be installed manually).

```
remotes::install_github("drighelli/SpatialExperiment")
```


## Citation

Righell D.\*, Weber L.M.\*, Crowell H.L.\*, Pardo B., Collado-Torres L., Ghazanfar S., Lun A.T.L., Hicks S.C.<sup>+</sup>, and Risso D.<sup>+</sup> (2022). *SpatialExperiment: infrastructure for spatially-resolved transcriptomics data in R using Bioconductor.* [Bioinformatics](https://doi.org/10.1093/bioinformatics/btac299), 38(11), 3128-3131.

Data present in this directory are divided in two sections:
- seqFish data
    - provided from https://github.com/BIRSBiointegration/Hackathon/tree/master/seqFISH
        in the occasion of the BIRS Hackathon workshop.
        All the data were already preprocessed
- 10x_visium data
    - provided data are part of the 10x Genomics visium website, datasets section.
        They are provided as they are present at https://support.10xgenomics.com/spatial-gene-expression/datasets/1.1.0/V1_Adult_Mouse_Brain_Coronal_Section_1

#' @name SpatialExperiment
#' 
#' @title The SpatialExperiment class
#' 
#' @aliases
#' SpatialExperiment
#' SpatialExperiment-class
#' 
#' @description
#' The \code{SpatialExperiment} class is designed to represent spatially
#' resolved transcriptomics (ST) data. It inherits from the
#' \code{\link{SingleCellExperiment}} class and is used in the same manner. In
#' addition, the class supports storage of spatial information via
#' \code{\link{spatialCoords}} and storage of images via \code{\link{imgData}}.
#' 
#' @param ... Arguments passed to the \code{\link{SingleCellExperiment}}
#'   constructor to fill the slots of the base class.
#' @param sample_id A \code{character} sample identifier, which matches the
#'   \code{sample_id} in \code{\link{imgData}}. The \code{sample_id} will also
#'   be stored in a new column in \code{\link{colData}}, if not already present.
#'   Default = \code{sample01}.
#' @param spatialCoordsNames A \code{character} vector of column names from
#'   \code{\link{colData}} containing spatial coordinates, which will be
#'   accessible with \code{\link{spatialCoords}}. Alternatively, the
#'   \code{spatialCoords} argument may be provided. If both are provided,
#'   \code{spatialCoordsNames} is given precedence, and a warning is returned.
#'   Default = \code{c("x", "y")}.
#' @param spatialCoords A numeric matrix containing columns of spatial
#'   coordinates, which will be accessible with \code{\link{spatialCoords}}.
#'   Alternatively, \code{spatialCoordsNames} may be provided. If both are
#'   provided, \code{spatialCoordsNames} is given precedence, and a warning is
#'   returned.
#' @param scaleFactors Optional scale factors associated with the image(s). This
#'   can be provided as a numeric value, numeric vector, list, or file path to a
#'   JSON file for the 10x Genomics Visium platform. For 10x Genomics Visium,
#'   the correct scale factor will automatically be selected depending on the
#'   resolution of the image from \code{imageSources}. Default = \code{1}.
#' @param imgData Optional \code{\link{DataFrame}} containing the image data.
#'   Alternatively, this can be built from the arguments \code{imageSources} and
#'   \code{image_id} (see Details).
#' @param imageSources Optional file path(s) or URL(s) for one or more image
#'   sources.
#' @param image_id Optional character vector (same length as
#'   \code{imageSources}) containing unique image identifiers.
#' @param loadImage Logical indicating whether to load image into memory.
#'   Default = \code{FALSE}.
#' @param spatialDataNames (Deprecated) A \code{character} vector of column
#'   names from \code{\link{colData}} to include in \code{\link{spatialData}}.
#'   Alternatively, the \code{spatialData} argument may be provided. If both are
#'   provided, \code{spatialDataNames} is given precedence, and a warning is
#'   returned. (Note: \code{spatialData} and \code{spatialDataNames} have been
#'   deprecated; \code{colData} and \code{spatialCoords} should be used for all
#'   columns. The arguments have been retained for backward compatibility but
#'   may be removed in the future.)
#' @param spatialData (Deprecated) A \code{\link{DataFrame}} containing columns
#'   to store in \code{\link{spatialData}}, which must contain at least the
#'   columns of spatial coordinates. Alternatively, \code{spatialDataNames} may
#'   be provided. If both are provided, \code{spatialDataNames} is given
#'   precedence, and a warning is returned. (Note: \code{spatialData} and
#'   \code{spatialDataNames} have been deprecated; \code{colData} and
#'   \code{spatialCoords} should be used for all columns. The arguments have
#'   been retained for backward compatibility but may be removed in the future.)
#' 
#' @details
#' In this class, rows represent genes, and columns represent spots (for
#' spot-based ST platforms) or cells (for molecule-based ST platforms). As for
#' \code{\link{SingleCellExperiment}}, \code{counts} and \code{logcounts} can be
#' stored in the \code{\link{assays}} slot, and row and column metadata in
#' \code{\link{rowData}} and \code{\link{colData}}. For molecule-based ST data,
#' the additional measurements per molecule per cell can be stored in a
#' \code{BumpyMatrix}-formatted \code{assay} named \code{\link{molecules}}.
#' 
#' The additional arguments in the constructor documented above (e.g.
#' \code{spatialCoords}, \code{imgData}, and others) represent the extensions to
#' the \code{\link{SingleCellExperiment}} class to store associated spatial and
#' imaging information for ST data.
#' 
#' The constructor expects \code{colData} to contain a column named
#' \code{sample_id}. If this is not present, it will assign the value from the
#' \code{sample_id} argument. If the \code{imgData} argument is provided, the
#' constructor expects the \code{\link{imgData}} \code{\link{DataFrame}} to
#' already be built. Otherwise, it will build it from the \code{imageSources}
#' and (optional) \code{image_id} arguments. If \code{image_id} is not provided,
#' this will be assumed from \code{sample_id} and \code{imageSources} instead.
#' To combine multiple samples within a single object, see
#' \code{\link{combine}}.
#' 
#' For 10x Genomics Visium datasets, the function \code{\link{read10xVisium}}
#' can be used to load data and create a \code{SpatialExperiment} object
#' directly from Space Ranger output files.
#' 
#' @seealso
#' \code{?"\link{SpatialExperiment-methods}"}, which includes:
#' \code{\link{spatialCoords}}, \code{\link{spatialCoordsNames}},
#' \code{\link{imgData}}, \code{\link{scaleFactors}}
#' 
#' \code{?"\link{SpatialExperiment-assays}"}, which includes:
#' \code{\link{molecules}}
#' 
#' \code{?"\link{SpatialExperiment-colData}"}
#' 
#' \code{?"\link{SpatialExperiment-combine}"}
#' 
#' \code{?"\link{SpatialExperiment-subset}"}
#' 
#' \code{?"\link{SpatialExperiment-misc}"}
#' 
#' \code{\link{readImgData}}
#' 
#' \code{?"\link{imgData-methods}"}
#' 
#' \code{\link{SpatialImage}}
#' 
#' \code{\link{read10xVisium}}
#' 
#' @author Dario Righelli and Helena L. Crowell
#' 
#' @return A \code{SpatialExperiment} object.
#' 
#' @examples
#' #########################################################
#' # Example 1: Spot-based ST (10x Visium) using constructor
#' #########################################################
#' 
#' dir <- system.file(
#'     file.path("extdata", "10xVisium", "section1", "outs"),
#'     package = "SpatialExperiment")
#' 
#' # read in counts
#' fnm <- file.path(dir, "raw_feature_bc_matrix")
#' sce <- DropletUtils::read10xCounts(fnm)
#' 
#' # read in image data
#' img <- readImgData(
#'     path = file.path(dir, "spatial"),
#'     sample_id="foo")
#' 
#' # read in spatial coordinates
#' fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
#' xyz <- read.csv(fnm, header = FALSE,
#'     col.names = c(
#'         "barcode", "in_tissue", "array_row", "array_col",
#'         "pxl_row_in_fullres", "pxl_col_in_fullres"))
#'     
#' # construct observation & feature metadata
#' rd <- S4Vectors::DataFrame(
#'     symbol = rowData(sce)$Symbol)
#'   
#' # construct 'SpatialExperiment'
#' (spe <- SpatialExperiment(
#'     assays = list(counts = assay(sce)),
#'     rowData = rd,
#'     colData = DataFrame(xyz),
#'     spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
#'     imgData = img,
#'     sample_id = "foo"))
#'     
#' #############################################################
#' # Example 2: Spot-based ST (10x Visium) using 'read10xVisium'
#' #############################################################
#' 
#' # see ?read10xVisium for details
#' example(read10xVisium)
#' 
#' ##############################
#' # Example 3: Molecule-based ST
#' ##############################
#' 
#' # create simulated data
#' n <- 1000; ng <- 50; nc <- 20
#' # sample xy-coordinates in [0,1]
#' x <- runif(n)
#' y <- runif(n)
#' # assign each molecule to some gene-cell pair
#' gs <- paste0("gene", seq(ng))
#' cs <- paste0("cell", seq(nc))
#' gene <- sample(gs, n, TRUE)
#' cell <- sample(cs, n, TRUE)
#' # construct data.frame of molecule coordinates
#' df <- data.frame(gene, cell, x, y)
#' 
#' # (assure gene & cell are factor so that
#' # missing observations aren't dropped)
#' df$gene <- factor(df$gene, gs)
#' df$cell <- factor(df$cell, cs)
#' 
#' # construct BumpyMatrix
#' mol <- BumpyMatrix::splitAsBumpyMatrix(
#'     df[, c("x", "y")],
#'     row = df$gene, column = df$cell)
#'
#' # get count matrix
#' y <- with(df, table(gene, cell))
#' y <- as.matrix(unclass(y))
#' 
#' # construct SpatialExperiment
#' (spe_mol <- SpatialExperiment(
#'     assays = list(
#'         counts = y, 
#'         molecules = mol)))
NULL

#' @importFrom S4Vectors DataFrame
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @export
SpatialExperiment <- function(..., 
    sample_id="sample01",
    spatialCoordsNames=NULL,
    spatialCoords=NULL,
    scaleFactors=1,
    imageSources=NULL,
    image_id=NULL,
    loadImage=FALSE,
    imgData=NULL,
    spatialDataNames=NULL,
    spatialData=NULL) {
    
    sce <- SingleCellExperiment(...)
    spe <- .sce_to_spe(sce=sce, 
        sample_id=sample_id,
        spatialCoordsNames=spatialCoordsNames,
        spatialCoords=spatialCoords,
        scaleFactors=scaleFactors,
        imageSources=imageSources,
        image_id=image_id,
        loadImage=loadImage,
        imgData=imgData,
        spatialDataNames=spatialDataNames,
        spatialData=spatialData)
    return(spe)
}

#' @importFrom methods new
#' @importFrom S4Vectors DataFrame
#' @importFrom SingleCellExperiment int_metadata<-
.sce_to_spe <- function(sce,
    sample_id="sample01", 
    spatialCoordsNames=NULL,
    spatialCoords=NULL,
    scaleFactors=1,
    imageSources=NULL,
    image_id=NULL,
    loadImage=TRUE,
    imgData=NULL,
    spatialDataNames=NULL,
    spatialData=NULL) {
    
    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    
    if (is.null(sce$sample_id)) {
        stopifnot(
            is.character(sample_id),
            any(length(sample_id) == c(1, ncol(sce))))
        if (ncol(sce) == 0) 
            sample_id <- character()
        sce$sample_id <- sample_id
    } else {
        if (!is.character(sce$sample_id))
            sce$sample_id <- as.character(sce$sample_id)
        sample_id <- unique(sce$sample_id)
    }
    
    if (!is.null(spatialData) || !is.null(spatialDataNames)) {
      .msg_spatialData()
    }
    
    spe <- new("SpatialExperiment", sce)

    # in the following code chunk, we give precedence 
    # to spatialData/CoordsNames over spatialData/Coords
    #   where spatialDataNames should be in colData,
    #   and spatialCoordsNames can be in both colData and spatialData
    # if both spatialData/Coords and -Names are supplied
    #   we give an informative warning notifying the user
    #   that spatialData/CoordsNames will be used 
    
    msg <- function(.) message(sprintf(                
        "Both '%s' and '%sNames'  have been supplied;\nusing '%s'. ", ., ., .),
        "Set either to NULL to suppress this message.")
    
    if (!is.null(spatialCoordsNames)) {
        stopifnot(is.character(spatialCoordsNames),
            all(spatialCoordsNames %in% names(colData(spe)))
            || all(spatialCoordsNames %in% names(spatialData)))
        if (!is.null(spatialCoords))
            msg("spatialCoords")
        if (all(spatialCoordsNames %in% names(colData(spe)))) {
            i <- spatialCoordsNames
            j <- setdiff(names(colData(spe)), i)
            spatialCoords(spe) <- as.matrix(colData(spe)[i])
            colData(spe) <- colData(spe)[j]
        } else {
            i <- spatialCoordsNames
            j <- setdiff(names(spatialData), i)
            spatialCoords(spe) <- as.matrix(spatialData[i])
            spatialData <- spatialData[j]
        }
    } else if (!is.null(spatialCoords)) {
        stopifnot(
            is.matrix(spatialCoords),
            is.numeric(spatialCoords),
            nrow(spatialCoords) == ncol(spe))
        spatialCoords(spe) <- spatialCoords
    } else {
        spatialCoords(spe) <- NULL
    }

    if (!is.null(spatialDataNames)) {
        stopifnot(
            is.character(spatialDataNames), 
            spatialDataNames %in% names(colData(spe)))
        if (!is.null(spatialData)) 
            msg("spatialData")
        i <- spatialDataNames
        j <- setdiff(names(colData(spe)), i)
        spd <- colData(spe)[i]
        colData(spe) <- colData(spe)[j]
        spatialData(spe) <- spd
    } else if (!is.null(spatialData)) {
        stopifnot(
            is(spatialData, "DFrame"),
            nrow(spatialData) == ncol(spe))
        spatialData(spe) <- spatialData
    } else {
        spatialData(spe) <- NULL
    }

    if (!is.null(imgData)) {
        stopifnot(imgData$sample_id %in% spe$sample_id)
        imgData(spe) <- imgData
    } else if (!is.null(imageSources) ){
        if (is.null(image_id)) {
            image_id <- sub("(.*)\\..*$", "\\1", basename(imageSources))
            image_id <- paste0(sample_id, "_", image_id, seq_along(imageSources))
        } else {
            stopifnot(length(image_id) != length(imageSources))
        }
        for (i in seq_along(imageSources)) {
            scaleFactor <- .get_scaleFactor(scaleFactors, imageSources[i])
            spe <- addImg(spe, 
                imageSource=imageSources[i], scaleFactor=scaleFactor, 
                sample_id=sample_id[i], image_id=image_id[i], load=loadImage)
        }
    } else {
        imgData(spe) <- NULL
    }
    return(spe)
}

#' @importFrom rjson fromJSON
.get_scaleFactor <- function(scaleFactors, imageSource=NULL) {
    
    scf <- scaleFactors
    if (is.numeric(scf))
        return(scf)
    if (!is.list(scf)) {
        if (!(is.character(scaleFactors) && grepl("\\.json$", scaleFactors)))
            stop("scaleFactors should be numeric, a list or JSON file.")
        scf <- fromJSON(file=scaleFactors)
    }
    if (!is.null(imageSource)) {
        img_fnm <- basename(imageSource)
        if (grepl("lowres", img_fnm)) {
            scf <- scf$tissue_lowres_scalef
        } else if (grepl("hires", img_fnm)) {
            scf <- scf$tissue_lowres_scalef
        } else {
            stop("Couldn't match input imageSources and scaleFactors; please",
                " provide a numeric value or a list of scaleFactors instead.")
        }
    }
    return(scf)
}

# note that, in order to enforce invalid replacements,
# the tests below purposefully use
#   @colData<- instead of colData<-
#   in_metadata$imgData<- instead of imgData<-
#   int_colData$spatialCoords <- instead of spatialCoords<-
#   int_metadata$spatialDataNames instead of spatialDataNames<-

test_that("colData", {
    # initialize mock SPE
    img <- system.file(
        "extdata", "10xVisium", "section1", "outs", "spatial", 
        "tissue_lowres_image.png", package="SpatialExperiment")
    spe <- SpatialExperiment(
        assays=diag(n <- 10),
        colData=DataFrame(a=seq(n)),
        sample_id="foo")
    spe <- addImg(spe, 
        imageSource=img, 
        scaleFactor=1, 
        sample_id="foo",
        image_id="foo",
        load=FALSE)
    # complete removal of colData
    tmp <- spe
    tmp@colData <- make_zero_col_DFrame(n)
    expect_error(validObject(tmp))
    # removal of sample_ids
    tmp <- spe
    tmp@colData$sample_id <- NULL
    expect_error(validObject(tmp))
    # mismatch with sample_id in imgData
    tmp <- spe
    tmp@colData$sample_id <- "x"
    expect_error(validObject(tmp))
})

test_that("SpatialDataNames", {
    # initialize mock SPE
    spe <- SpatialExperiment(
        assays=diag(n <- 10),
        colData=DataFrame(a=seq(n), b=seq(n)))
    # valid replacements
    int_metadata(spe)$spatialDataNames <- "a"
    expect_true(validObject(spe)) 
    # invalid replacements
    int_metadata(spe)$spatialDataNames <- "c"
    expect_error(validObject(spe)) 
})

test_that("spatialCoords", {
    # initialize mock SPE
    spe <- SpatialExperiment(
        assays=diag(n <- 10))
    # invalid replacements
    foo <- list(
        NULL,
        rep(1, n),
        rep("", n),
        factor(seq(n)),
        matrix("", n, 2),
        data.frame(seq(n)),
        DataFrame(seq(n)))
    for (. in foo) {
        int_colData(spe)$spatialCoords <- .
        expect_error(validObject(spe)) 
    }
    # valid replacements
    foo <- list(
        matrix(1, n),
        matrix(1, n, 2),
        matrix(NA_real_, n),
        matrix(NA_integer_, n))
    for (. in foo) {
        int_colData(spe)$spatialCoords <- .
        expect_true(validObject(spe)) 
    }
})

test_that("imgData", {
    # initialize mock SPE
    spe <- SpatialExperiment(
        assays=diag(n <- 10))
    # complete removal of imgData
    int_metadata(spe)$imgData <- NULL
    expect_error(validObject(spe))
})

example(read10xVisium, echo = FALSE)

test_that("empty constructor", {
    spe <- SpatialExperiment()
    expect_is(imgData(spe), "DFrame")
    expect_true(isEmpty(imgData(spe)))
    expect_identical(spatialDataNames(spe), character())
    expect_is(spatialData(spe), "DFrame")
    expect_true(isEmpty(spatialData(spe)))
    expect_equal(dim(spatialData(spe)), c(ncol(spe), 0))
    expect_null(spatialCoordsNames(spe))
    expect_is(spatialCoords(spe), "matrix")
    expect_equal(dim(spatialCoords(spe)), c(ncol(spe), 0))
})

test_that("spatialCoordsNames = character in colData", {
    cd <- DataFrame(x=numeric(), y=numeric())
    spe <- SpatialExperiment(colData=cd, spatialCoordsNames=names(cd))
    expect_identical(spatialCoordsNames(spe), names(cd))
    expect_identical(spatialCoords(spe), as.matrix(cd))  
})

test_that("spatialDataNames = character in colData", {
    cd <- DataFrame(x=numeric(), y=numeric())
    spe <- SpatialExperiment(colData=cd, spatialDataNames=names(cd))
    expect_identical(spatialDataNames(spe), names(cd))
    expect_identical(spatialData(spe), cd)
})

test_that("spatialData/CoordsNames = character in colData", {
    cd <- DataFrame(x=numeric(), y=numeric(), z=numeric())
    spe <- SpatialExperiment(
        colData=cd, 
        spatialDataNames="z",
        spatialCoordsNames=c("x", "y"))
    expect_identical(spatialDataNames(spe), "z")
    expect_identical(spatialCoordsNames(spe), c("x", "y"))
    expect_true(!any(c("x", "y") %in% names(colData(spe))))
})

test_that("spatialCoords = numeric matrix", {
    y <- diag(n <- 10)
    mat <- matrix(0, n, m <- 2)
    spe <- SpatialExperiment(assays = y, spatialCoords = mat)
    expect_is(spatialCoords(spe), "matrix")
    expect_identical(spatialCoords(spe), mat)
    expect_null(spatialCoordsNames(spe))
    
    colnames(mat) <- seq(m)
    spe <- SpatialExperiment(assays = y, spatialCoords = mat)
    expect_is(spatialCoords(spe), "matrix")
    expect_identical(spatialCoords(spe), mat)
    expect_identical(spatialCoordsNames(spe), colnames(mat))
})

test_that("spatialData = DFrame", {
    mat <- matrix(0, n <- 10, m <- 5)
    expect_error(SpatialExperiment(spatialData = mat))
    y <- diag(n)
    df <- DataFrame(mat)
    names(df) <- letters[seq(m)]
    spe <- SpatialExperiment(assays = y, spatialData = df)
    expect_is(spatialData(spe), "DFrame")
    expect_identical(spatialData(spe), df)
    expect_identical(spatialDataNames(spe), names(df))
})

test_that("message when spatialData & -Names are supplied", {
    cd <- DataFrame(x=numeric(), y=numeric())
    expect_message(
        spe <- SpatialExperiment(
            colData=cd, 
            spatialData=cd, 
            spatialDataNames=names(cd)))
    expect_identical(spe, 
        SpatialExperiment(
            colData=cd, 
            spatialDataNames=names(cd)))
})

test_that("message when spatialCoords & -Names are supplied", {
    cd <- DataFrame(x=numeric(), y=numeric())
    expect_message(
        spe <- SpatialExperiment(
            colData=cd, 
            spatialCoords=cd, 
            spatialCoordsNames=names(cd)))
    expect_identical(spe, 
        SpatialExperiment(
            colData=cd, 
            spatialCoordsNames=names(cd)))
})

gs <- paste0("gene", seq_len(ng <- 200))
cs <- paste0("cell", seq_len(nc <- 100))
y <- matrix(runif(ng*nc), ng, nc, dimnames=list(gs, cs))

sample_id <- paste0("sample", c(1, 2))
cd <- DataFrame(sample_id=sample(sample_id, nc, TRUE))

image_id <- paste0("image", c(1, 2))
spi <- SpatialImage(as.raster(0))
id <- DataFrame(sample_id, image_id, data=I(list(spi)), scaleFactor=1)

test_that("input sample_ids are used if is.null(x$sample_id)", {
    sce <- SingleCellExperiment(assays=list(counts=y))
    spe <- .sce_to_spe(sce, sample_id="foo")
    expect_true(all(spe$sample_id == "foo"))
})

test_that("input sample_id is ignored if !is.null(x$sample_id)", {
    sce <- SingleCellExperiment(assays=list(counts=y), colData=cd)
    spe <- .sce_to_spe(sce, sample_id="foo")
    expect_true(all(spe$sample_id == sce$sample_id))
})

test_that("'sample_id's must be character of length 1 or ncol(.)", {
    sce <- SingleCellExperiment(assays=list(counts=y))
    spe <- .sce_to_spe(sce, sample_id=cd$sample_id)
    expect_identical(spe$sample_id, cd$sample_id)
    expect_error(.sce_to_spe(sce, sample_id=1))
    expect_error(.sce_to_spe(sce, sample_id=c("a", "b")))
})

test_that(".sce_to_spe()", {
    sce <- SingleCellExperiment(
        assays=list(counts=y),
        colData=cd)
    spe <- .sce_to_spe(sce)
    expect_is(spe, "SpatialExperiment")
    expect_is(imgData(spe), "DFrame")
    expect_true(isEmpty(imgData(spe)))
    expect_is(spatialData(spe), "DFrame")
    expect_true(isEmpty(spatialData(spe)))
    expect_identical(colData(spe), colData(sce))
    
    spe <- .sce_to_spe(sce, imgData=id)
    expect_identical(imgData(spe), id)
})

test_that("scaleFactors should be numeric, a named list or JSON file", {
    sce <- SingleCellExperiment(assays=list(counts=y), colData=cd)
    dir <- system.file(
        file.path("extdata", "10xVisium", "section1", "outs", "spatial"),
        package="SpatialExperiment")
    sf_fn <- file.path(dir, "scalefactors_json.json")
    img_fn <- file.path(dir, "tissue_lowres_image.png")
    
    expect_error(.sce_to_spe(sce, imageSources=img_fn, scaleFactors="x"))
    expect_error(.sce_to_spe(sce, imageSources=img_fn, scaleFactors=list()))
    
    expect_silent(.sce_to_spe(sce, imageSources=img_fn, scaleFactors=1))
    expect_silent(.sce_to_spe(sce, imageSources=img_fn, scaleFactors=sf_fn))
    expect_silent(.sce_to_spe(sce, imageSources=img_fn, 
        scaleFactors=list(tissue_lowres_scalef=1)))
})

test_that("deprecated spatialData/Names returns message", {
    expect_message(spatialData(spe))
    expect_message(spatialDataNames(spe))
    expect_message(SpatialExperiment(spatialData = DataFrame()))
    cd <- DataFrame(x = numeric(), y = numeric())
    expect_message(SpatialExperiment(colData = cd, spatialDataNames = names(cd)))
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(cache = TRUE, autodep = TRUE, cache.lazy = FALSE)

## ----echo=FALSE, out.width = "100%", fig.cap="Overview of the SpatialExperiment class structure."----
knitr::include_graphics("SPE.png")

## ----message = FALSE----------------------------------------------------------
library(SpatialExperiment)
example(read10xVisium, echo = FALSE)
spe

## -----------------------------------------------------------------------------
head(spatialCoords(spe))

## -----------------------------------------------------------------------------
spatialCoordsNames(spe)

## -----------------------------------------------------------------------------
imgData(spe)

## -----------------------------------------------------------------------------
(spi <- getImg(spe))
identical(spi, imgData(spe)$data[[1]])

## ----fig.small = TRUE---------------------------------------------------------
plot(imgRaster(spe))

## ----fig.small = TRUE, eval = TRUE--------------------------------------------
url <- "https://i.redd.it/3pw5uah7xo041.jpg"
spe <- addImg(spe, 
    sample_id = "section1", 
    image_id = "pomeranian",
    imageSource = url, 
    scaleFactor = NA_real_, 
    load = TRUE)
img <- imgRaster(spe, 
    sample_id = "section1", 
    image_id = "pomeranian")
plot(img)

## -----------------------------------------------------------------------------
imgData(spe <- rmvImg(spe, "section1", "pomeranian"))

## -----------------------------------------------------------------------------
n <- length(z <- letters)
y <- matrix(nrow = n, ncol = n)
cd <- DataFrame(x = seq(n), y = seq(n), z)

spe1 <- SpatialExperiment(
    assay = y, 
    colData = cd, 
    spatialCoordsNames = c("x", "y"))

## -----------------------------------------------------------------------------
xy <- as.matrix(cd[, c("x", "y")])

spe2 <- SpatialExperiment(
    assay = y, 
    colData = cd["z"], 
    spatialCoords = xy)

## -----------------------------------------------------------------------------
identical(spe1, spe2)

## -----------------------------------------------------------------------------
spe <- SpatialExperiment(
    assays = y)
isEmpty(spatialCoords(spe))

## ----results = "hide"---------------------------------------------------------
n <- 10; m <- 20
y <- matrix(nrow = n, ncol = m)
cd <- DataFrame(x = seq(m), y = seq(m))
xy <- matrix(nrow = m, ncol = 2)
colnames(xy) <- c("x", "y")

SpatialExperiment(
    assay = y, 
    colData = cd,
    spatialCoordsNames = c("x", "y"),
    spatialCoords = xy)

## -----------------------------------------------------------------------------
dir <- system.file(
   file.path("extdata", "10xVisium", "section1", "outs"),
   package = "SpatialExperiment")

# read in counts
fnm <- file.path(dir, "raw_feature_bc_matrix")
sce <- DropletUtils::read10xCounts(fnm)

# read in image data
img <- readImgData(
    path = file.path(dir, "spatial"),
    sample_id = "foo")

# read in spatial coordinates
fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
xyz <- read.csv(fnm, header = FALSE,
    col.names = c(
        "barcode", "in_tissue", "array_row", "array_col",
        "pxl_row_in_fullres", "pxl_col_in_fullres"))

# construct observation & feature metadata
rd <- S4Vectors::DataFrame(
    symbol = rowData(sce)$Symbol)

# construct 'SpatialExperiment'
(spe <- SpatialExperiment(
    assays = list(counts = assay(sce)),
    rowData = rd, 
    colData = DataFrame(xyz), 
    spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
    imgData = img,
    sample_id = "foo"))

## -----------------------------------------------------------------------------
dir <- system.file(
    file.path("extdata", "10xVisium"),
    package = "SpatialExperiment")

sample_ids <- c("section1", "section2")
samples <- file.path(dir, sample_ids, "outs")

(spe10x <- read10xVisium(samples, sample_ids,
    type = "sparse", data = "raw",
    images = "lowres", load = FALSE))

## -----------------------------------------------------------------------------
samples2 <- file.path(dir, sample_ids)

(spe10x2 <- read10xVisium(samples2, sample_ids,
    type = "sparse", data = "raw",
    images = "lowres", load = FALSE))

## ----message = FALSE, warning = FALSE-----------------------------------------
n <- 1e3  # number of molecules
ng <- 50  # number of genes
nc <- 20  # number of cells
# sample xy-coordinates in [0, 1]
x <- runif(n)
y <- runif(n)
# assign each molecule to some gene-cell pair
gs <- paste0("gene", seq(ng))
cs <- paste0("cell", seq(nc))
gene <- sample(gs, n, TRUE)
cell <- sample(cs, n, TRUE)
# assure gene & cell are factors so that
# missing observations aren't dropped
gene <- factor(gene, gs)
cell <- factor(cell, cs)
# construct data.frame of molecule coordinates
df <- data.frame(gene, cell, x, y)
head(df)

## ----message = FALSE, warning = FALSE-----------------------------------------
# construct 'BumpyMatrix'
library(BumpyMatrix)
mol <- splitAsBumpyMatrix(
    df[, c("x", "y")], 
    row = gene, col = cell)

## ----message = FALSE, warning = FALSE-----------------------------------------
# get count matrix
y <- with(df, table(gene, cell))
y <- as.matrix(unclass(y))
y[1:5, 1:5]
# construct SpatialExperiment
spe <- SpatialExperiment(
    assays = list(
        counts = y, 
        molecules = mol))
spe

## ----message = FALSE, warning = FALSE-----------------------------------------
molecules(spe)

## -----------------------------------------------------------------------------
sub <- spe10x[, spe10x$sample_id == "section1"]

## -----------------------------------------------------------------------------
sub <- spe10x[, colData(spe10x)$in_tissue]
sum(colData(spe10x)$in_tissue) == ncol(sub)

## -----------------------------------------------------------------------------
spe1 <- spe2 <- spe
spe3 <- cbind(spe1, spe2)
unique(spe3$sample_id)

## -----------------------------------------------------------------------------
# make sample identifiers unique
spe1 <- spe2 <- spe
spe1$sample_id <- paste(spe1$sample_id, "A", sep = ".")
spe2$sample_id <- paste(spe2$sample_id, "B", sep = ".")

# combine into single object
spe3 <- cbind(spe1, spe2)

## ----error=TRUE---------------------------------------------------------------
new <- spe3$sample_id
new[1] <- "section2.A"
spe3$sample_id <- new
new[1] <- "third.one.of.two"
spe3$sample_id <- new

## -----------------------------------------------------------------------------
# backup original sample IDs
tmp <- spe$sample_id
# try to remove sample IDs
spe$sample_id <- NULL
# sample IDs remain unchanged
identical(tmp, spe$sample_id)

## -----------------------------------------------------------------------------
# extract first image
spi <- getImg(spe10x)
# apply counter-/clockwise rotation
spi1 <- rotateImg(spi, -90)
spi2 <- rotateImg(spi, +90)
# visual comparison
par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))

## -----------------------------------------------------------------------------
# specify sample & image identifier
sid <- "section1"
iid <- "lowres"
# counter-clockwise rotation
tmp <- rotateImg(spe10x, 
    sample_id = sid, 
    image_id = iid,
    degrees = -90)
# visual comparison
par(mfrow = c(1, 2))
plot(imgRaster(spe10x, sid, iid))
plot(imgRaster(tmp, sid, iid))

## -----------------------------------------------------------------------------
# extract first image
spi <- getImg(spe10x)
# mirror horizontally/vertically
spi1 <- mirrorImg(spi, "h")
spi2 <- mirrorImg(spi, "v")
# visual comparison
par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))

## -----------------------------------------------------------------------------
# specify sample & image identifier
sid <- "section2"
iid <- "lowres"
# mirror horizontally
tmp <- mirrorImg(spe10x, 
    sample_id = sid, 
    image_id = iid,
    axis = "h")
# visual comparison
par(mfrow = c(1, 2))
plot(imgRaster(spe10x, sid, iid))
plot(imgRaster(tmp, sid, iid))

## ----tidy = TRUE--------------------------------------------------------------
sessionInfo()

#' @name SpatialExperiment-assays
#' 
#' @title Methods for named assays
#' 
#' @aliases
#' molecules
#' molecules<-
#' molecules,SpatialExperiment-method
#' molecules<-,SpatialExperiment-method
#' 
#' @description
#' The \code{\link{SpatialExperiment}} class provides methods for getting or
#' setting named \code{\link{assays}}. For example, \code{molecules(spe)} will
#' get or set an \code{assay} named \code{molecules} from object \code{spe},
#' equivalent to \code{assay(spe, i = "molecules")}. This provides a convenient
#' interface for users and encourages standardization of assay names across
#' packages.
#' 
#' @section Available methods:
#' In the following code, \code{spe} is a \code{\link{SpatialExperiment}}
#' object, \code{value} is a \code{BumpyMatrix}-like object with the same
#' dimensions as \code{spe}, and \code{...} are further arguments passed to
#' \code{\link{assay}} (for the getter) or \code{\link{assay<-}} (for the
#' setter).
#' 
#' \describe{
#' \item{\code{molecules(x, ...)}, \code{molecules(x, ...) <- value}:}{
#' Get or set an assay named \code{molecules}, which is usually assumed to be a
#' \code{BumpyMatrix}-formatted object containing spatial coordinates (and any
#' other information) of the individual molecules per gene per cell.
#' }
#' }
#' 
#' @author Dario Righelli
#' 
#' @seealso
#' \code{\link{assay}} and \code{\link{assay<-}}
#' 
#' @examples
#' example(SpatialExperiment)
#' molecules(spe_mol)
NULL

#' @importFrom SummarizedExperiment assay
GET_FUN <- function(exprs_values, ...) {
    (exprs_values) # To ensure evaluation
    function(x, ...) {
        assay(x, i=exprs_values, ...)
    }
}

#' @importFrom SummarizedExperiment assay<-
SET_FUN <- function(exprs_values, ...) {
    (exprs_values) # To ensure evaluation
    function(x, ..., value) {
        assay(x, i=exprs_values, ...) <- value
        return(x)
    }
}

#' @export
setMethod("molecules", "SpatialExperiment", GET_FUN("molecules"))

#' @export
setReplaceMethod("molecules", c("SingleCellExperiment", "ANY"), SET_FUN("molecules"))

#' @rdname SpatialExperiment-methods
#' @importFrom SingleCellExperiment int_metadata
#' @export
setMethod("imgData", "SpatialExperiment", function(x) int_metadata(x)$imgData)

#' @rdname SpatialExperiment-methods
#' @importFrom S4Vectors DataFrame
#' @importFrom SingleCellExperiment int_metadata<-
#' @export
setReplaceMethod("imgData",
    c("SpatialExperiment", "DataFrame"),
    function(x, value) {
        if (!isEmpty(value)) {
            msg <- .imgData_validity(value)
            if (!is.null(msg))
                stop(msg)
        }
        int_metadata(x)$imgData <- value
        return(x)
    })

#' @rdname SpatialExperiment-methods
#' @importFrom S4Vectors DataFrame
#' @export
setReplaceMethod("imgData",
    c("SpatialExperiment", "NULL"),
    function(x, value) {
        value <- DataFrame()
        `imgData<-`(x, value)
    })

#' @name SpatialImage-class
#' @title The \code{SpatialImage} class
#' 
#' @aliases
#' SpatialImage
#' VirtualSpatialImage-class
#' LoadedSpatialImage-class
#' StoredSpatialImage-class
#' RemoteSpatialImage-class
#' dim,VirtualSpatialImage-method
#' dim,StoredSpatialImage-method
#' imgRaster 
#' imgRaster,LoadedSpatialImage-method
#' imgRaster,StoredSpatialImage-method
#' imgRaster,RemoteSpatialImage-method
#' imgRaster<- 
#' imgRaster<-,LoadedSpatialImage-method 
#' imgSource 
#' imgSource,LoadedSpatialImage-method
#' imgSource,StoredSpatialImage-method
#' imgSource,RemoteSpatialImage-method
#' imgSource<-
#' imgSource<-,StoredSpatialImage,character-method
#' imgSource<-,RemoteSpatialImage,character-method
#' coerce,VirtualSpatialImage,LoadedSpatialImage-method
#' coerce,RemoteSpatialImage,StoredSpatialImage-method
#' rotateImg
#' rotateImg,VirtualSpatialImage-method
#' rotateImg,LoadedSpatialImage-method
#' mirrorImg
#' mirrorImg,VirtualSpatialImage-method
#' mirrorImg,LoadedSpatialImage-method
#' 
#' @description 
#' The \code{SpatialImage} class hierarchy provides representations of images
#' from a variety of sources. It is used by the \linkS4class{SpatialExperiment}
#' class to manage the loading of images across multiple studies.
#' 
#' @section Constructor:
#' \code{SpatialImage(x, is.url)} will return a \code{SpatialImage} object.
#' The class of the object depends on the type of \code{x}:
#' \itemize{
#' \item If \code{x} is a raster object, a \code{LoadedSpatialImage} is 
#'   returned. This represents an image that is fully realized into memory, 
#'   where the raster representation is stored inside the output object.
#' \item If \code{x} is a string and \code{is.url=TRUE} or it starts with 
#'   \code{"http://"}, \code{"http://"} or \code{"ftp://"}, 
#'   a \code{RemoteSpatialImage} is returned. This represents an image 
#'   that is remotely hosted and retrieved only on request.
#' \item If \code{x} is a string and \code{is.url=TRUE} or it does not 
#'   start with a URL-like prefix, a \code{StoredSpatialImage} is returned.
#'   This represents an image that is stored in a local file 
#'   and is loaded into memory only on request.
#' }
#'
#' @section Getting the raster image:
#' For a \code{SpatialImage} object \code{x}, \code{imgRaster(x, ...)} 
#' will return a raster object (see \code{?\link{as.raster}}).
#' This is effectively a matrix of RGB colors for each pixel in the image.
#'
#' For a \code{StoredSpatialImage} object \code{x}, additional arguments 
#' in \code{...} are passed to \code{\link{image_read}}.
#' This controls how the image is read into memory.
#'
#' For a \code{RemoteSpatialImage} object \code{x}, the image file is first
#' downloaded before the raster is returned. Here, \code{...} may contain an
#' extra \code{cache} argument, which should be a \code{BiocFileCache} object 
#' (from the \pkg{BiocFileCache} package) specifying the file cache location. 
#' The default location is determined by 
#' \code{options("SpatialExperiment.remote.cache.path")},
#' otherwise it defaults to a subdirectory in the R temporary directory.
#' Any further named arguments in \code{...} are passed to \code{image_read}.
#'
#' \code{as.raster(x, ...)} is the same as \code{imgRaster(x, ...)}.
#'
#' @section In-memory caching:
#' For \code{StoredSpatialImage} and \code{RemoteSpatialImage} objects, 
#' loading the image with \code{imgRaster} will automatically 
#' store the loaded raster object in an in-memory cache.
#' Any subsequent \code{imgRaster} call will retrieve the raster 
#' from the cache, avoiding costly retrieval from the file system.
#'
#' The cache policy is to evict the least recently used images when 
#' a new image would be added that exceeds the maximum cache size.
#' If the new image by itself exceeds the maximum cache size, all images are 
#' evicted from the cache to trigger garbage collection and free up memory.
#'
#' By default, the maximum size of the cache is 4 GB. This can be 
#' modified by setting \code{options("SpatialExperiment.cache.size")} 
#' to some number of bytes, e.g., \code{2^32}.
#' 
#' @section Transformations:
#' Two basic image transformations are currently 
#' supported for any \code{SpatialImage} \code{x}, namely,
#' \code{rotateImg(x, degrees)} for clockwise (\code{degrees > 0}) and 
#' counter-clockwise (\code{degrees < 0}) rotation, and 
#' \code{mirrorImg(x, axis)} for horizontal (\code{axis = "h"}) and 
#' vertical (\code{axis = "v"}) mirroring.
#' 
#' Note that, both \code{rotateImg()} and \code{mirrorImg()} operate
#' on the \code{raster} matrix of the input \code{SpatialImage}. 
#' Thus, any \code{SpatialImage} will automatically be coerced 
#' into a \code{LoadedSpatialImage} upon rotation/mirroring.
#' 
#' @section Other methods:
#' \code{dim(x)} will return an integer vector of length 2, 
#' containing the width and height of the image in pixels.
#' Note that this calls \code{imgRaster} under the hood and thus 
#' may interact with the file and memory caches as described above.
#'
#' For any \code{SpatialImage x}, \code{as(x, "LoadedSpatialImage")} will
#' create a \code{LoadedSpatialImage} containing an in-memory raster object.
#'
#' For a \code{RemoteSpatialImage x}, \code{as(x, "StoredSpatialImage")} will
#' create a \code{StoredSpatialImage} pointing to the file cache location.
#'
#' @author Aaron Lun
#'
#' @examples
#' path <- system.file(
#'   "extdata", "10xVisium", "section1", "outs", "spatial", 
#'   "tissue_lowres_image.png", package="SpatialExperiment")
#'
#' spi <- SpatialImage(path)
#' plot(imgRaster(spi))
#'
#' # the following operations all use the cache 
#' # so there is no need to reload the image
#' nrow(spi)
#' ncol(spi)
#' plot(as.raster(spi)) 
#'
#' # coercing to an explicitly in-memory raster
#' spi <- as(spi, "LoadedSpatialImage")
#' plot(as.raster(spi))
#' 
#' ###################
#' # transformations #
#' ###################
#' 
#' # (counter-)clockwise rotation
#' spi1 <- rotateImg(spi, degrees = +90)
#' spi2 <- rotateImg(spi, degrees = -90)
#' 
#' par(mfrow = c(1, 3))
#' plot(as.raster(spi))
#' plot(as.raster(spi1))
#' plot(as.raster(spi2))
#' 
#' # horizontal/vertical mirroring
#' spi1 <- mirrorImg(spi, axis = "h")
#' spi2 <- mirrorImg(spi, axis = "v")
#' 
#' par(mfrow = c(1, 3))
#' plot(as.raster(spi))
#' plot(as.raster(spi1))
#' plot(as.raster(spi2))
#' 
NULL

#' @importFrom grDevices is.raster
#' @export
SpatialImage <- function(x, is.url=NULL) {
    if (is(x, "VirtualSpatialImage")) {
        x
    } else if (is.raster(x)) {
        new("LoadedSpatialImage", image=x)
    } else if (is.character(x)) {
        if (is.null(is.url)) {
            is.url <- grepl("^(https?|ftp)://", x)
        }
        if (is.url) {
            new("RemoteSpatialImage", url=x)
        } else {
            new("StoredSpatialImage", path=normalizePath(x))
        }
    } else {
        stop("unknown input type for 'x'")
    }
}

# getters ----------------------------------------------------------------------

#' @export
setMethod("imgRaster", "LoadedSpatialImage", function(x) x@image)

#' @export
#' @importFrom magick image_read image_destroy
setMethod("imgRaster", 
    "StoredSpatialImage", 
    function(x, ...) {
        path <- normalizePath(x@path)
        FUN <- function() {
            img <- image_read(path, ...)
            on.exit(image_destroy(img))
            as.raster(img)
        }        
        .get_from_cache(path, FUN)
    })

#' @export
#' @importFrom magick image_read image_destroy
setMethod("imgRaster", 
    "RemoteSpatialImage", 
    function(x, cache=NULL, ...) {
        URL <- x@url
        FUN <- function() {
            path <- .remote_file_cache(URL, cache)
            img <- image_read(path, ...)
            on.exit(image_destroy(img))
            as.raster(img)
        }        
        .get_from_cache(URL, FUN)
    })

#' @export
setMethod("imgSource", 
    "LoadedSpatialImage", 
    function(x, path=FALSE) {
        NA_character_
    })

#' @export
setMethod("imgSource", 
    "StoredSpatialImage", 
    function(x, path=FALSE) {
        x@path
    })

#' @export
setMethod("imgSource", 
    "RemoteSpatialImage", 
    function(x, path=FALSE) {
        if (path) {
            .remote_file_cache(x@url, cache=NULL)
        } else {
            x@url
        }
    })

#' @export
setMethod("dim",
    "VirtualSpatialImage",
    function(x) {
        dim(imgRaster(x))
    })

#' @export
#' @importFrom magick image_read image_info
setMethod("dim",
    "StoredSpatialImage",
    function(x) {
        src <- imgSource(x)
        src <- normalizePath(src)
        img <- .get_from_cache(src, NULL)
        if (!is.null(img)) return(dim(img))
        img <- image_read(src)
        tib <- image_info(img)
        c(tib$height, tib$width)
    })

# setters ----------------------------------------------------------------------

#' @export
setReplaceMethod("imgRaster",
    c("LoadedSpatialImage", "ANY"),
    function(x, value) {
        x@image <- value
        return(x)
    })

#' @export
setReplaceMethod("imgSource", 
    c("StoredSpatialImage", "character"), 
    function(x, value) {
        .path_validity(value)
        x@path <- value
        return(x) 
    })

#' @export
setReplaceMethod("imgSource", 
    c("RemoteSpatialImage", "character"), 
    function(x, value) { 
        .url_validity(value)
        x@url <- value
        return(x) 
    })

# coercion ---------------------------------------------------------------------

#' @export
#' @method as.raster VirtualSpatialImage
as.raster.VirtualSpatialImage <- function(x, ...) imgRaster(x, ...)

setAs("VirtualSpatialImage", 
    "LoadedSpatialImage", 
    function(from) {
        img <- imgRaster(from)
        new("LoadedSpatialImage", image=img)
    }
)

setAs("RemoteSpatialImage", 
    "StoredSpatialImage", 
    function(from) {
        path <- .remote_file_cache(from@url, cache=NULL)
        new("StoredSpatialImage", path=path)
    }
)

# transformations --------------------------------------------------------------

#' @export
setMethod("rotateImg", 
    "LoadedSpatialImage", 
    function(x, degrees=90) {
        r <- imgRaster(x)
        r <- .rotate(r, degrees)
        imgRaster(x) <- r
        return(x)
    })

#' @export
setMethod("rotateImg", 
    "VirtualSpatialImage", 
    function(x, degrees=90) {
        x <- as(x, "LoadedSpatialImage")
        rotateImg(x, degrees)
    })

#' @export
setMethod("mirrorImg", 
    "LoadedSpatialImage", 
    function(x, axis=c("h", "v")) {
        axis <- match.arg(axis)
        r <- imgRaster(x)
        r <- .mirror(r, axis)
        imgRaster(x) <- r
        return(x)
    })

#' @export
setMethod("mirrorImg", 
    "VirtualSpatialImage", 
    function(x, axis=c("h", "v")) {
        x <- as(x, "LoadedSpatialImage")
        mirrorImg(x, axis)
    })

# This tests the SpatialImage architecture.
# library(testthat); library(SpatialExperiment); source("test_spatial_image.R")

path <- system.file("extdata", "10xVisium", "section1", "outs", "spatial", 
    "tissue_lowres_image.png", package="SpatialExperiment")

test_that("SpatialImage constructors and basic methods work as expected", {
    fspi <- SpatialImage(path)
    expect_s4_class(fspi, "StoredSpatialImage")

    img <- imgRaster(fspi)
    expect_s3_class(img, "raster")
    expect_identical(dim(fspi), dim(img))

    lspi <- as(fspi, "LoadedSpatialImage")
    expect_s4_class(lspi, "LoadedSpatialImage")

    img2 <- imgRaster(lspi)
    expect_identical(img, img2)
    expect_identical(dim(lspi), dim(fspi))
})

test_that("SpatialImage in-memory caching works as expected", {
    SpatialExperiment:::.flush_cache()
    cache <- SpatialExperiment:::image.cache
    expect_identical(cache$cached, list())

    # Creation doesn't trigger the cache.
    fspi <- SpatialImage(path)
    expect_identical(cache$cached, list())

    # Loads an image into the cache.
    img <- imgRaster(fspi)
    expect_identical(length(cache$cached), 1L)

    # Just uses whatever's in the cache, rather than reloading.
    cache$cached[[1]] <- cache$cached[[1]][1:10,1:10]
    dims <- dim(fspi)
    expect_identical(dims, c(10L, 10L))

    # Rotation of last-used image works as expected.
    img2 <- img[1:500,1:500]
    cache$cached <- c(cache$cached, list(A=img2, B=img2, C=img2))
    dummy <- imgRaster(fspi)
    expect_identical(
        normalizePath(names(cache$cached), mustWork=FALSE), 
        normalizePath(c(LETTERS[1:3], path), mustWork=FALSE))

    # LRU eviction policy works as intended.
    SpatialExperiment:::.flush_cache()
    oldo <- options("SpatialExperiment.cache.size"=as.double(object.size(img)))

    cache$cached <- list(A=img2, B=img2, C=img2)
    img <- imgRaster(fspi)
    expect_identical(
        normalizePath(names(cache$cached), mustWork=FALSE), 
        normalizePath(path, mustWork=FALSE))

    options(oldo)
})

test_that("SpatialImage URL caching works as expected", {
    SpatialExperiment:::.flush_cache()
    val <- tempfile()
    oldc <- options("SpatialExperiment.remote.cache.path"=val)

    tst <- "https://jeroen.github.io/images/frink.png" # same as that in ?image_read.
    rspi <- SpatialImage(tst)
    expect_false(dir.exists(val))

    img <- imgRaster(rspi)
    expect_true(dir.exists(val))
    expect_s3_class(img, "raster")

    cache <- SpatialExperiment:::image.cache
    expect_identical(names(cache$cached), tst)

    options(oldc)
})

#' @rdname SpatialExperiment
#' @exportClass SpatialExperiment SpatialExperiment
#' @importFrom SingleCellExperiment SingleCellExperiment
setClass("SpatialExperiment",
    contains="SingleCellExperiment")

#' @export
#' @importClassesFrom S4Vectors Annotated
setClass("VirtualSpatialImage", 
    contains=c("VIRTUAL", "Annotated"))

#' @export
setClass("LoadedSpatialImage", 
    contains="VirtualSpatialImage", 
    slots=c(image="ANY"))

#' @export
setClass("StoredSpatialImage", 
    contains="VirtualSpatialImage", 
    slots=c(path="character"))

#' @export
setClass("RemoteSpatialImage", 
    contains="VirtualSpatialImage", 
    slots=c(url="character"))

#' @name SpatialExperiment-colData
#' 
#' @title SpatialExperiment colData
#' 
#' @aliases colData colData<- 
#' 
#' @description
#' The \code{\link{SpatialExperiment}} class provides a modified \code{colData}
#' setter, which ensures that the \code{SpatialExperiment} object remains valid.
#' 
#' @details
#' The \code{colData} setter performs several checks to ensure validity. If the
#' replacement \code{colData} does not contain a \code{sample_id} column, the
#' existing \code{sample_id}s will be retained. If the replacement
#' \code{colData} contains \code{sample_id}s, a check is performed to ensure the
#' number of unique \code{sample_id}s is the same, i.e. a one-to-one mapping is
#' possible. If the replacement is \code{NULL}, the \code{sample_id}s are
#' retained. In addition, checks are performed against the \code{sample_id}s in
#' \code{\link{imgData}}.
#' 
#' @param x a \code{\link{SpatialExperiment}}
#' @param value a \code{\link[S4Vectors]{DataFrame}}
#' 
#' @return a \code{\link{SpatialExperiment}} object with updated \code{colData}
#' 
#' @examples
#' example(read10xVisium)
#' 
#' # empty replacement retains sample identifiers
#' colData(spe) <- NULL
#' names(colData(spe))
#' 
#' # replacement of sample identifiers
#' # requires one-to-one mapping
#' 
#' ## invalid replacement
#' 
#' tryCatch(
#'   spe$sample_id <- seq(ncol(spe)),
#'   error = function(e) message(e)) 
#'   
#' ## valid replacement  
#'   
#' old <- c("section1", "section2")
#' new <- c("sample_A", "sample_B")
#' idx <- match(spe$sample_id, old)
#' 
#' tmp <- spe
#' tmp$sample_id <- new[idx]
#' table(spe$sample_id, tmp$sample_id)
NULL

# the following overwrites 'SummarizedExperiment's 'colData' 
# replacement method to assure the 'SpatialExperiment' remains valid
# - in case of an invalid replacement, we throw a warning 
#   (not an error) and return the (unmodified) input object
# - in case of replacement by NULL

#' @rdname SpatialExperiment-colData
#' @importFrom S4Vectors DataFrame
#' @importFrom SummarizedExperiment colData colData<-
#' @export
setReplaceMethod("colData",
    c("SpatialExperiment", "DataFrame"),
    function(x, value) {
        # store original 'colData'
        old <- colData(x)
        
        # do the replacement
        se <- as(x, "SummarizedExperiment")
        colData(se) <- value
        new <- colData(se)
        
        if (!is.null(new$sample_id)) {
            # check that 'sample_id's remain valid & update 'imgData' accordingly
            ns_old <- length(sids_old <- unique(old$sample_id))
            ns_new <- length(sids_new <- unique(new$sample_id))
            if (ns_old != ns_new) {
                stop(sprintf(
                    "Number of unique 'sample_id's is %s, but %s %s provided.\n",
                    ns_old, ns_new, ifelse(ns_new > 1, "were", "was")))
            } else if (sum(table(old$sample_id, new$sample_id) != 0) != ns_old) {
                stop("New 'sample_id's must map uniquely")
            } else if (!is.null(imgData(x))) {
                m <- match(imgData(x)$sample_id, sids_old)
                imgData(x)$sample_id <- sids_new[m]
            }    
        } else {
            # if none provided, retain original sample_id field
            value$sample_id <- old$sample_id
        }
        BiocGenerics:::replaceSlots(x, colData=value, check=FALSE)
    }
)

#' @rdname SpatialExperiment-colData
#' @importFrom SummarizedExperiment colData colData<-
#' @export
setReplaceMethod("colData",
    c("SpatialExperiment", "NULL"),
    function(x, value) {
        spatialDataNames(x) <- NULL
        value <- colData(x)["sample_id"]
        colData(x) <- value
        return(x)
    }
)

# SpatialExperiment validity ---------------------------------------------------

#' @importFrom SingleCellExperiment int_colData
.spatialCoords_validity <- function(x, msg=NULL) {
    y <- int_colData(x)$spatialCoords
    if (is.null(y)) {
        msg <- c(msg, "no 'spatialCoords' field in 'int_colData'")
    } else if (!(is.matrix(y) && is.numeric(y))) {
        msg <- c(msg, paste(
            "'spatialCoords' field in 'int_colData'",
            "should be a numeric matrix"))
    }
    return(msg)
}

.spatialData_validity <- function(x, msg=NULL) {
    y <- colData(x)[int_metadata(x)$spatialDataNames]
    if (!is.null(y) && !is(y, "DFrame")) {
        msg <- c(msg, paste(
            "'spatialData' field in 'int_colData'",
            "should be a 'DFrame'"))
    }
    return(msg)
}

.colData_validity <- function(obj, msg=NULL) {
    df <- colData(obj)
    if (is.null(df$sample_id)) { 
        msg <- c(msg, "no 'sample_id' field in 'colData'")
    } else {
        if (!is.null(imgData(obj))) {
            sids <- unique(df$sample_id)
            isids <- unique(imgData(obj)$sample_id)
            # it's allowed to have samples with missing images but not 
            # vice versa, i.e. all imgData samples must be in colData
            if (!all(isids %in% sids)) {
                msg <- c(msg, paste(
                    "sample_id(s) don't match",
                    "between colData and imgData"))
            }
        }
    }
    return(msg)
}

#' @importFrom methods is
.imgData_validity <- function(obj, msg=NULL) {
    if (is(obj, "SpatialExperiment")) {
        df <- int_metadata(obj)$imgData
    } else {
        df <- obj
    }
    
    if (is.null(df)) {
        msg <- c(msg, "no 'imgData' field in 'int_metadata'")
    } else if (!is(df, "DFrame")) {
        msg <- c(msg, "'imgData' field in 'int_metadata' should be a 'DFrame'")
    }
    
    if (isEmpty(df))
        return(msg)
    
    nms <- c("sample_id", "image_id", "data", "scaleFactor")
    if (!identical(nms, names(df)))
        msg <- c(msg, paste(
            "'imgData' field in 'int_metadata' should have columns:",
            paste(sQuote(nms), collapse = ", ")))
    
    is_list <- is.list(df$data)
    is_vsi <- \(.) is(., "VirtualSpatialImage")
    all_vsi <- all(vapply(df$data, is_vsi, logical(1)))
    if (!(is_list && all_vsi))
        msg <- c(msg, paste(
            "'data' field in 'int_metadata' field 'imgData'",
            "should be a list of 'SpatialImage' objects"))
    
    if (!is.numeric(df$scaleFactor))
        msg <- c(msg, paste(
            "'scaleFactor' column in 'int_metadata'",
            "field 'imgData' should be 'numeric'"))
    
    return(msg)
}

.spe_validity <- function(object) {
    msg <- NULL
    msg <- .colData_validity(object, msg)
    msg <- .imgData_validity(object, msg)
    msg <- .spatialData_validity(object, msg)
    msg <- .spatialCoords_validity(object, msg)
    #msg <- .spatialDataNames_validity(object, msg)
    if (length(msg)) return(msg)
    return(TRUE)
}

#' @importFrom S4Vectors setValidity2
setValidity2("SpatialExperiment", .spe_validity)

# SpatialImage validity --------------------------------------------------------

.path_validity <- function(x) {
    is_valid <- all(c(
        length(x) == 1,
        is.character(x),
        file.exists(x),
        # TODO: any other possible image formats? 
        grepl("(\\.png|\\.jpg|\\.tif)$", x)))
    
    if (!is_valid)
        stop("'path' should be a length-one character",
            " string specifiying an image file (.png, .jpg or .tif)")
    return(TRUE)
}

# TODO: better way to check for URL validity without extra dependencies?

.url_validity <- function(x, t=1) {
    pat <- "^(www\\.|http(s)?://)"
    if (!grepl(pat, x))
        return(FALSE)
    
    suppressWarnings({
        con <- url(x)
        err <- try(open.connection(con, open="rt", timeout=t), silent=TRUE)
        try(close.connection(con), silent=TRUE)
        if (is.null(err))
            return(TRUE)
        stop("cannot connect to specified 'url'")
    })
}

.remote_file_cache <- function(URL, cache) 
{
    # perhaps can be more tolerant of missing a BiocFileCache installation?
    if (is.null(cache)) {
        args <- list(ask=FALSE)
        cache.dir <- getOption("SpatialExperiment.remote.cache.path", NULL)
        if (!is.null(cache.dir))
            args$cache <- cache.dir
        cache <- do.call(BiocFileCache::BiocFileCache, args)
    }
    BiocFileCache::bfcrpath(cache, URL)
}

image.cache <- new.env()
image.cache$cached <- list()

#' @importFrom utils head tail object.size
.get_from_cache <- function(ID, FUN) 
{
    img <- image.cache$cached[[ID]]
    if (!is.null(img)) {
        # if we get the image, we rotate it to the end of the cache so that it
        # is less likely to be evicted; we aim to preserve frequently used images
        IDs <- c(setdiff(names(image.cache$cached), ID), ID)
        image.cache$cached <- image.cache$cached[IDs]
    } else if (!is.null(FUN)) {
        img <- FUN()
        current <- as.double(object.size(img))
        
        # adding the image. Evicting old images until space is available
        used <- lapply(image.cache$cached, FUN=function(x) as.double(object.size(x)))
        used2 <- c(used, current)
        cum.used <- rev(cumsum(rev(used2)))
        
        # default to unlimited cache to mimic autoloading
        keep <- cum.used <= getOption("SpatialExperiment.cache.size", 2^32)
        image.cache$cached <- image.cache$cached[head(keep, -1)]
        if (tail(keep, 1))
            image.cache$cached[[ID]] <- img
    }
    img
}

.flush_cache <- function() 
{
    # currently for use in tests only,
    # but may possibly want to export
    image.cache$cached <- list()
}

# (counter-)clockwise 90 degree rotation
.rotate <- function(x, degrees) {
    # 'degrees' should be a single numeric divisible by 90
    stopifnot(
        length(degrees) == 1,
        is.numeric(degrees), 
        degrees %% 90 == 0)
    s <- sign(degrees)
    f <- ifelse(s == 1, 
        \(x) t(apply(x, 2, rev)), # clockwise
        \(x) apply(x, 1, rev))    # counter-clockwise
    n <- abs(degrees / 90)
    for (i in seq_len(n)) 
        x <- f(x)
    as.raster(x)
}

# flip over horizontal/vertical axis
.mirror <- function(x, axis) {
    x <- if (axis == "h") {
        apply(x, 2, rev)
    } else {
        t(apply(x, 1, rev))
    }
    as.raster(x)
}

# dim ----

test_that("dim,Stored-/LoadedSpatialImage is instant", {
    src <- system.file(
        "extdata", "10xVisium", "section1", "outs", "spatial", 
        "tissue_lowres_image.png", package="SpatialExperiment")
    spi <- SpatialImage(src)
    src <- normalizePath(src)
    # dim,VirtualSPI affects cache
    selectMethod("dim", "VirtualSpatialImage")(spi)
    expect_true(!is.null(image.cache$cached[[src]]))
    # dim,StoredSPI does not
    .flush_cache(); dim(spi)
    expect_true(is.null(image.cache$cached[[src]]))
})

# getters ----
url <- "https://i.redd.it/3pw5uah7xo041.jpg"
spi <- new("RemoteSpatialImage", url=url)
    
test_that("imgSource returns NA for LoadedSpI (irrespective of 'path')", {
    x <- as(spi, "LoadedSpatialImage")
    expect_true(is.na(imgSource(x, path=FALSE)))
    expect_true(is.na(imgSource(x, path=TRUE)))
})

test_that("imgSource,path=FALSE/TRUE returns URL/path for RemoteSpI", {
    expect_identical(imgSource(spi, path=FALSE), url)
    x <- imgSource(spi, path=TRUE)
    expect_is(x, "character")
    expect_true(file.exists(x))
})

test_that("imgSource returns path for StoredSpI (irrespective of 'path')", {
    x <- as(spi, "StoredSpatialImage")
    expect_identical(
        imgSource(x, path=FALSE),
        imgSource(x, path=TRUE))
})

# utils ----
.mockRaster <- function(n, m) {
    x <- runif(n*m)
    y <- matrix(x, n, m)
    as.raster(y)
}
.mockSPI <- function(n, m) {
    r <- .mockRaster(n, m)
    new("LoadedSpatialImage", image=r)
}
.mockSPE <- function(n, m, N) {
    l <- replicate(N, .mockSPI(n, m))
    sample_id <- paste0("sample", seq_len(N))
    image_id <- paste0("image", seq_len(N))
    cd <- DataFrame(sample_id)
    df <- DataFrame(sample_id, image_id, data=I(l), scaleFactor=seq_len(N))
    SpatialExperiment(colData=cd, imgData=df)
}

# params----
n <- 10 # number of rows / height
m <- 20 # number of columns / width
N <- 3  # number of images in SpE

# rotate----
test_that(".rotate/rotateImg(),degrees=0 does nothing", {
    # raster as input
    r <- .mockRaster(n, m)
    s <- .rotate(r, 0)
    expect_identical(r, s)
    # SpI as input
    i <- .mockSPI(n, m)
    j <- rotateImg(i, 0)
    expect_identical(i, j)
    # SpE as input
    x <- .mockSPE(n, m, N)
    y <- rotateImg(x, TRUE, TRUE, 0)
    expect_identical(x, y)
    
})
test_that(".rotate/rotateImg(),degrees>0 rotates right/clockwise", {
    .test <- function(x, y) {
        expect_identical(dim(x), rev(dim(y)))
        expect_identical(c(x[1, ]), c(y[, n]))
    }
    # raster as input
    r <- .mockRaster(n, m)
    s <- .rotate(r, 90)
    .test(r, s)
    # SpI as input
    i <- .mockSPI(n, m)
    j <- rotateImg(i, 90)
    .test(imgRaster(i), imgRaster(j))
    # SpE as input
    # first only
    sid <- iid <- NULL
    x <- .mockSPE(n, m, N)
    y <- rotateImg(x, sid, iid, 90)
    .test(imgRaster(x, sid, iid), imgRaster(y))
    expect_identical(
        getImg(x, TRUE, TRUE)[-1],
        getImg(y, TRUE, TRUE)[-1])
    # all images
    sid <- iid <- TRUE
    x <- .mockSPE(n, m, N)
    y <- rotateImg(x, sid, iid, 90)
    mapply(
        function(u, v) .test(u, v),
        u = imgRaster(x, sid, iid),
        v = imgRaster(y, sid, iid))
})
test_that(".rotate/.rotateImg(),degrees<0 rotates left/counter-clockwise", {
    .test <- function(x, y) {
        expect_identical(dim(x), rev(dim(y)))
        expect_identical(c(x[1, ]), rev(y[, 1]))
    }
    # raster as input
    r <- .mockRaster(n, m)
    s <- .rotate(r, -90)
    .test(r, s)
    # SpI as input
    i <- .mockSPI(n, m)
    j <- rotateImg(i, -90)
    .test(imgRaster(i), imgRaster(j))
    # first only
    sid <- iid <- NULL
    x <- .mockSPE(n, m, N)
    y <- rotateImg(x, sid, iid, -90)
    .test(imgRaster(x, sid, iid), imgRaster(y))
    expect_identical(
        getImg(x, TRUE, TRUE)[-1],
        getImg(y, TRUE, TRUE)[-1])
    # all images
    sid <- iid <- TRUE
    x <- .mockSPE(n, m, N)
    y <- rotateImg(x, sid, iid, -90)
    mapply(
        function(u, v) .test(u, v),
        u = imgRaster(x, sid, iid),
        v = imgRaster(y, sid, iid))
})
test_that("rotateImg() w/o imgData passes", {
    x <- .mockSPE(n, m, N)
    imgData(x) <- NULL
    expect_silent(y <- rotateImg(x))
    expect_identical(x, y)
})

# mirror ----
test_that(".mirror/mirrorImg(),axis='h' flips horizontally", {
    .test <- function(x, y) {
        expect_identical(dim(x), dim(y))
        expect_identical(c(x[1, ]), c(y[n, ]))
    }
    # raster as input
    r <- .mockRaster(n, m)
    s <- .mirror(r, "h")
    .test(r, s)
    # SpI as input
    i <- .mockSPI(n, m)
    j <- mirrorImg(i, "h")
    .test(imgRaster(i), imgRaster(j))
    # SpE as input
    # first only
    sid <- iid <- NULL
    x <- .mockSPE(n, m, N)
    y <- mirrorImg(x, sid, iid, "h")
    .test(imgRaster(x, sid, iid), imgRaster(y))
    expect_identical(
        getImg(x, TRUE, TRUE)[-1],
        getImg(y, TRUE, TRUE)[-1])
    # all images
    sid <- iid <- TRUE
    x <- .mockSPE(n, m, N)
    y <- mirrorImg(x, sid, iid, "h")
    mapply(
        function(u, v) .test(u, v),
        u = imgRaster(x, sid, iid),
        v = imgRaster(y, sid, iid))
})
test_that(".mirror/mirrorImg(),axis='v' flips vertically", {
    .test <- function(x, y) {
        expect_identical(dim(x), dim(x))
        expect_identical(c(x[1, ]), rev(y[1, ]))
    }
    # raster as input
    r <- .mockRaster(n, m)
    s <- .mirror(r, "v")
    .test(r, s)
    # SpI as input
    i <- .mockSPI(n, m)
    j <- mirrorImg(i, "v")
    .test(imgRaster(i), imgRaster(j))
    # SpE as input
    # first only
    sid <- iid <- NULL
    x <- .mockSPE(n, m, N)
    y <- mirrorImg(x, sid, iid, "v")
    .test(imgRaster(x, sid, iid), imgRaster(y))
    expect_identical(
        getImg(x, TRUE, TRUE)[-1],
        getImg(y, TRUE, TRUE)[-1])
    # all images
    sid <- iid <- TRUE
    x <- .mockSPE(n, m, N)
    y <- mirrorImg(x, sid, iid, "v")
    mapply(
        function(u, v) .test(u, v),
        u = imgRaster(x, sid, iid),
        v = imgRaster(y, sid, iid))
})
test_that("mirrorImg() w/o imgData passes", {
    x <- .mockSPE(n, m, N)
    imgData(x) <- NULL
    expect_silent(y <- mirrorImg(x))
    expect_identical(x, y)
})

# helper to get the row index/indices of image(s) with matching
# 'sample_id' & 'image_id' from the 'imgData' field in 'int_metadata'
# - TRUE returns all available entries
# - NULL return first available entry
# - character string returns matching entry(ies)
.get_img_idx <- function(x, sample_id=NULL, image_id=NULL) {
    img <- imgData(x)
    for (i in c("sample_id", "image_id")) {
        j <- get(i)
        if (is.factor(j) || is.numeric(j))
            assign(i, as.character(j))
        if (!(is.null(j) || j %in% img[[i]] ||
            length(j) == 1 && is.logical(j)))
            stop(sprintf(c(
                "'%s' invalid; should be NULL, TRUE/FALSE,",
                " or matching entries in imgData(.)$%s"), i))
    }
    if (is.character(sample_id) && is.character(image_id)) {
        sid <- img$sample_id == sample_id
        iid <- img$image_id == image_id
    } else if (isTRUE(sample_id) && isTRUE(image_id)) {
        sid <- iid <- !logical(nrow(img))
    } else if (is.null(sample_id) && is.null(image_id)) {
        sid <- iid <- diag(nrow(img))[1, ]
    } else if (is.character(sample_id) && isTRUE(image_id)) {
        sid <- img$sample_id == sample_id
        iid <- !logical(nrow(img))
    } else if (is.character(image_id) && isTRUE(sample_id)) {
        iid <- img$image_id == image_id
        sid <- !logical(nrow(img))
    } else if (is.character(sample_id) && is.null(image_id)) {
        sid <- img$sample_id == sample_id
        iid <- diag(nrow(img))[which(sid)[1], ]
    } else if (is.character(image_id) && is.null(sample_id)) {
        iid <- img$image_id == image_id
        sid <- diag(nrow(img))[which(iid)[1], ]
    } else if (isTRUE(sample_id) && is.null(image_id)) {
        iid <- match(unique(img$sample_id), img$sample_id)
        iid <- colSums(diag(nrow(img))[iid, , drop=FALSE])
        sid <- !logical(nrow(img))
    } else if (isTRUE(image_id) && is.null(sample_id)) {
        sid <- match(unique(img$image_id), img$image_id)
        sid <- colSums(diag(nrow(img))[sid, , drop=FALSE])
        iid <- !logical(nrow(img))
    }
    if (!any(idx <- sid & iid)) 
        stop("No 'imgData' entry(ies) matched the specified", 
            sprintf(" 'image_id = %s' and 'sample_id = %s'", 
                dQuote(image_id), dQuote(sample_id)))
    return(which(idx))
}

#' @importFrom grDevices as.raster
#' @importFrom magick image_read
#' @importFrom S4Vectors DataFrame
.get_imgData <- function(img, scaleFactor, sample_id, image_id, load=TRUE) {
    is_path <- tryCatch(
        error=function(e) e, 
        .path_validity(img))
    
    is_url <- tryCatch(
        error=function(e) e, 
        .url_validity(img))
    
    if (!(isTRUE(is_path) || isTRUE(is_url)))
        stop("Image should be supplied as a length-one character",
            " string specifiying an image file (.png or .jpg),",
            " or a valid URL to source from")
    
    if (load) {
        img <- image_read(img)
        img <- as.raster(img)
    } 
    spi <- SpatialImage(img)
    DataFrame(
        sample_id, 
        image_id,
        data=I(list(spi)),
        scaleFactor=scaleFactor)
}

#' @name imgData-methods
#' @title Methods for handling image-related data
#' 
#' @aliases 
#' getImg addImg rmvImg
#' getImg,SpatialExperiment-method
#' addImg,SpatialExperiment-method
#' rmvImg,SpatialExperiment-method
#' imgRaster,SpatialExperiment-method
#' imgSource,SpatialExperiment-method
#' rotateImg,SpatialExperiment-method
#' mirrorImg,SpatialExperiment-method
#' 
#' @description 
#' The set of functions described below is designed to handle 
#' the image-related data stored inside a \code{SpatialExperiment}'s 
#' \code{imgData} \code{int_metadata} field. These include:
#' 
#' \itemize{
#' \item \code{getImg}, \code{addImg}, \code{rmvImg}
#'   to retrieve/add/remove an image entry to/from 
#'   the \code{imgData} \code{DataFrame}
#' \item \code{imgSource}, \code{imgRaster}
#'   to retrieve the path/URL and \code{raster} object,
#'   respectively, associated with an image or set of images
#' }
#' 
#' @param x a \code{\link{SpatialExperiment}}
#' @param sample_id character string, \code{TRUE} or \code{NULL} specifying 
#'   sample/image identifier(s); here, \code{TRUE} is equivalent to all 
#'   samples/images and \code{NULL} specifies the first available entry (see details)
#' @param image_id see \code{sample_id}
#' @param imageSource 
#'   a character string specifying an image file name 
#'   (.png, .jpg or .tif) or URL to source the image from
#' @param scaleFactor 
#'   single numeric scale factor used to rescale spatial 
#'   coordinates according to the image's resolution
#' @param load logical; should the image(s) be 
#'   loaded into memory as a \code{raster} object?
#'   if \code{FALSE}, will store the path/URL instead
#' @param degrees single numeric 
#'   in +/-[0,90,...,360] specifying how many degrees to rotate.
#'   A negative/positive value corresponds to counter-/clockwise rotation
#' @param axis character string specifying whether to mirror 
#'   horizontally (\code{"h"}) or vertically (\code{"v"})
#' @param path logical; for \code{RemoteSpatialImage}s, TRUE 
#'   returns the path to the image's cached file, and FALSE its URL. 
#'   For \code{Stored/LoadedSpatialImage}s, a path/NA is returned, 
#'   irrespective of \code{path}.
#' 
#' @return 
#' \code{getImg()} returns a single or list of \code{SpatialImage}(s).
#' 
#' \code{add/rmvImg()} return a \code{\link{SpatialExperiment}} 
#' with modified \code{imgData}; specifically, they create/remove 
#' an image entry (row) in the \code{imgData} \code{DataFrame}.
#' 
#' \code{imgRaster/Source()} access relevant data in the 
#' \code{SpatialImage}(s) stored inside the \code{imgData}'s \code{data} 
#' field. Depending on whether or not multiple entries are accessed,
#' a character string or vector is returned by \code{imgSource()}, and a 
#' single or list of \code{raster} object(s) is returned by \code{imgRaster()}.
#' 
#' \code{rotate/mirrorImg()} return a \code{Loaded\link{SpatialImage}}
#' with modified a \code{raster} matrix.
#'   
#' @examples
#' example(read10xVisium)
#' 
#' # 'SpatialImage' accession
#' (spi <- getImg(spe))
#' plot(imgRaster(spi))
#' 
#' # remove an image
#' imgData(spe)
#' spe <- rmvImg(spe,
#'   sample_id = "section1",
#'   image_id = "lowres")
#' imgData(spe)
#' 
#' # add an image
#' url <- "https://i.redd.it/3pw5uah7xo041.jpg"
#' spe <- addImg(spe,
#'   sample_id = "section1",
#'   image_id = "pomeranian",
#'   imageSource = url,
#'   scaleFactor = NA_real_,
#'   load = FALSE)
#' 
#' # extract image
#' img <- imgRaster(spe,
#'   sample_id = "section1",
#'   image_id = "pomeranian")
#' plot(img)
#' 
#' ###################
#' # transformations #
#' ###################
#' 
#' # clockwise rotation
#' spe1 <- rotateImg(spe, 
#'   degrees = 90) # first image
#'   
#' spe2 <- rotateImg(spe, 
#'   sample_id = TRUE,
#'   image_id = TRUE, 
#'   degrees = 90) # all images
#' 
#' par(mfrow = c(1, 3))
#' plot(imgRaster(spe))
#' plot(imgRaster(spe1))
#' plot(imgRaster(spe2))
#' 
#' # horizontal/vertical mirroring
#' spe1 <- mirrorImg(spe, axis = "h")
#' spe2 <- mirrorImg(spe, axis = "v")
#' 
#' par(mfrow = c(1, 3))
#' plot(imgRaster(spe))
#' plot(imgRaster(spe1))
#' plot(imgRaster(spe2))
#'   
#' @author Helena L. Crowell
NULL

# getImg -----------------------------------------------------------------------

#' @rdname imgData-methods
#' @importFrom S4Vectors isEmpty
#' @export
setMethod("getImg", "SpatialExperiment",
    function(x, sample_id=NULL, image_id=NULL) {
        if (isEmpty(imgData(x))) return(NULL)
        spi <- imgData(x)$data
        idx <- .get_img_idx(x, sample_id, image_id)
        if (length(idx) == 1) spi[[idx]] else spi[idx]
    })

# addImg -----------------------------------------------------------------------

#' @rdname imgData-methods
#' @export
setMethod("addImg", "SpatialExperiment",
    function(x, imageSource, scaleFactor, sample_id, image_id, load=TRUE) {
        # check validity of input arguments
        stopifnot(
            is.numeric(scaleFactor), 
            length(scaleFactor) == 1,
            
            is.character(sample_id), 
            length(sample_id) == 1, 
            sample_id %in% x$sample_id,
            
            is.character(image_id), 
            length(image_id) == 1,
            
            is.logical(load), 
            length(load) == 1)
        
        is_path <- tryCatch(
            error=function(e) e, 
            .path_validity(imageSource))
        
        is_url <- tryCatch(
            error=function(e) e, 
            .url_validity(imageSource))
        
        if (!(isTRUE(is_path) || isTRUE(is_url)))
            stop("Invalid 'imageSource'; should be an",
                " image file name (.png or .jpg) or", 
                " URL to source the image from")
        
        # check that image entry doesn't already exist
        idx <- tryCatch(
            error=function(e) e,
            .get_img_idx(x, sample_id, image_id))
        
        if (!inherits(idx, "error"))
            stop("'imgData' already contains an entry with", 
                sprintf(
                    " 'image_id = %s' and 'sample_id = %s'", 
                    dQuote(image_id), dQuote(sample_id)))
        
        # get & add valid 'imgData' entry
        df <- .get_imgData(imageSource, scaleFactor, sample_id, image_id, load)
        imgData(x) <- rbind(imgData(x), df)
        return(x)
    })

# rmvImg -----------------------------------------------------------------------

#' @rdname imgData-methods
#' @export
setMethod("rmvImg", "SpatialExperiment",
    function(x, sample_id=NULL, image_id=NULL) {
        idx <- .get_img_idx(x, sample_id, image_id)
        imgData(x) <- imgData(x)[-idx, , drop=FALSE]
        return(x)
    })

# getters ----------------------------------------------------------------------

#' @rdname imgData-methods
#' @export
setMethod("imgSource", "SpatialExperiment", 
    function(x, sample_id=NULL, image_id=NULL, path=FALSE) {
        spi <- getImg(x, sample_id, image_id)
        if (is.null(spi)) {
            NULL
        } else {
            if (!is.list(spi)) spi <- list(spi)
            vapply(spi, \(.) imgSource(., path), character(1)) 
        }
    })

#' @rdname imgData-methods
#' @export
setMethod("imgRaster", "SpatialExperiment", 
    function(x, sample_id=NULL, image_id=NULL) {
        spi <- getImg(x, sample_id, image_id)
        if (is.null(spi)) {
            NULL
        } else if (is.list(spi)) {
            lapply(spi, imgRaster) 
        } else {
            imgRaster(spi)
        }
    })

# transformations --------------------------------------------------------------

#' @rdname imgData-methods
#' @export
setMethod("rotateImg", "SpatialExperiment",
    function(x, sample_id=NULL, image_id=NULL, degrees=90) {
        old <- getImg(x, sample_id, image_id)
        if (!is.null(old)) {
            if (!is.list(old)) old <- list(old)
            new <- lapply(old, rotateImg, degrees=degrees) 
            idx <- .get_img_idx(x, sample_id, image_id)
            imgData(x)$data[idx] <- new
        }
        return(x)
    })

#' @rdname imgData-methods
#' @export
setMethod("mirrorImg", "SpatialExperiment",
    function(x, sample_id=NULL, image_id=NULL, axis=c("h", "v")) {
        old <- getImg(x, sample_id, image_id)
        if (!is.null(old)) {
            if (!is.list(old)) old <- list(old)
            new <- lapply(old, mirrorImg, axis=axis) 
            idx <- .get_img_idx(x, sample_id, image_id)
            imgData(x)$data[idx] <- new
        }
        return(x)
    })

#' @name SpatialExperiment-rotate-mirror
#' 
#' @inherit SpatialExperiment-methods title
#' 
#' @aliases
#' rotateCoords
#' mirrorCoords
#' rotateObject
#' mirrorObject
#' 
#' @description
#' The \code{\link{SpatialExperiment}} class provides methods to rotate and
#' mirror \code{\link{SpatialExperiment}} objects and their
#' \code{spatialCoords}.
#' 
#' @param degrees single numeric 
#'   in +/-[0,90,...,360] specifying how many degrees to rotate.
#'   A negative/positive value corresponds to counter-/clockwise rotation.
#'   Applicable for \code{rotateCoords} and \code{rotateObject} methods.
#' @param axis character string specifying whether to mirror 
#'   horizontally (\code{"h"}) or vertically (\code{"v"}). Applicable for
#'   \code{mirrorCoords} and \code{mirrorObject} methods.
#' @param warn Logical value indicating whether to print a warning about
#'   mismatches between coordinates and images, possible with the spatialCoords
#'   transformation methods \code{rotateCoords} and \code{mirrorCoords}.
#' @inheritParams SpatialExperiment-methods
#' 
#' @details
#' Additional details for each type of data attribute are provided below.
#' 
#' @section spatialCoords transformation methods:
#' \describe{
#' \item{\code{rotateCoords(x, sample_id, degrees, warn)}: }{
#'   Apply a rotation to the \code{spatialCoords} of \code{x}, potentially
#'   subsetted to sample \code{sample_id} (or without subsetting if
#'   \code{sample_id} is \code{NULL}), by the specified number of \code{degrees}
#'   clockwise. Warn about mismatches with images if \code{warn}.}
#' \item{\code{mirrorCoords(x, sample_id, axis, warn)}: }{
#'   Reflect the \code{spatialCoords} of \code{x} across either the horizontal
#'   or vertical axis, specified by supplying "h" or "v" to the \code{axis}
#'   argument, respectively. Subset \code{x} to just the sample
#'   \code{sample_id}, if not \code{NULL}. Warn about mismatches with images if
#'   \code{warn}.}
#' }
#'
#' @section SpatialExperiment transformation wrapper methods:
#' \describe{
#' \item{\code{rotateObject(x, sample_id, image_id, degrees)}: }{
#'   Apply a rotation to the \code{\link{spatialCoords}} and
#'   \code{\link{imgData}} of
#'   \code{x}, potentially subsetted to sample \code{sample_id} (or without
#'   subsetting if \code{sample_id} is \code{NULL}), by the specified number of
#'   \code{degrees} clockwise. Wrapper around \code{rotateCoords} and
#'   \code{rotateImg}.}
#' \item{\code{mirrorObject(x, sample_id, image_id, axis)}: }{
#'   Reflect the \code{\link{spatialCoords}} and \code{\link{imgData}} of \code{x} across
#'   either the horizontal or vertical axis, specified by supplying "h" or "v"
#'   to the \code{axis} argument, respectively. Subset \code{x} to just the
#'   sample \code{sample_id}, if not \code{NULL}. Wrapper around
#'   \code{mirrorCoords} and \code{mirrorImg}.}
#' }
#' 
#' @inherit SpatialExperiment-methods return
#' 
#' @author Nicholas J. Eagles
#' 
#' @examples
#' example(read10xVisium)
#' 
#' # rotateCoords(), mirrorCoords(), rotateObject(), and mirrorObject() return a
#' # SpatialExperiment, potentially subsetted by sample.
#'
#' # Subset to just "section1"; rotate coordinates 90 degrees clockwise followed
#' # by a reflection across the vertical axis
#' spe_coords <- rotateCoords(spe, sample_id = "section1", degrees = 90)
#' spe_coords <- mirrorCoords(spe_coords, axis = "v")
#'
#' # Subset to just "section2"; transform both the imgData() and spatialCoords()
#' # by a 180-degree rotation then reflection across the vertical axis
#' spe_wrapper <- rotateObject(spe, sample_id = "section2", degrees = 180)
#' spe_wrapper <- mirrorObject(spe_wrapper, axis = "v")
NULL

# rotate/mirrorCoords ----------------------------------------------------------

#' @rdname SpatialExperiment-rotate-mirror
#' @export
setMethod(
    "rotateCoords",
    "SpatialExperiment",
    function(x, sample_id = NULL, degrees = 90, warn = TRUE) {
        # 'degrees' should be a single numeric divisible by 90
        stopifnot(
            length(degrees) == 1,
            is.numeric(degrees),
            degrees %% 90 == 0
        )
        
        #   Subset by 'sample_id', if supplied
        if (is.null(sample_id)) {
            #   Ensure that we only have one scaleFactor across the whole
            #   SpatialExperiment
            if (length(unique(scaleFactors(x))) != 1) {
                stop(
                    paste0(
                        "Rotations of spatialCoords of multiple samples with ",
                        "different 'scaleFactors' is not currently supported."
                    )
                )
            }
        } else {
            #   Ensure the sample is present in the object
            if (!(sample_id %in% colData(x)$sample_id)) {
                stop(
                    paste0(
                        "'", sample_id, "' is not a sample in",
                        "'colData(x)$sample_id': cannot subset."
                    )
                )
            }
            
            #   Subset
            x <- x[, colData(x)$sample_id == sample_id]
        }
        
        if (warn) {
            warning(
                paste0(
                    "Invoking 'rotateCoords' or 'rotateImg' independently may ",
                    "result in mismatches between coordinates and images. ",
                    "Please use 'rotateObject' to ensure consistency."
                )
            )
        }

        #   Convert degrees to radians. Note that positive angles represent
        #   counter-clockwise rotations
        radians <- degrees * pi / 180
        
        #   Determine the matrix by which left-multiplication represents
        #   rotation. Then apply rotation about the origin
        rotation_mat <- matrix(
            c(
                cos(radians), sin(radians), -1 * sin(radians), cos(radians)
            ),
            nrow = 2
        )
        new_coords <- rotation_mat %*% t(spatialCoords(x))
        
        #   Get the dimensions of the "rectangle" containing the set of
        #   spatialCoords within the object
        dim_max <- dim(imgRaster(x)) / scaleFactors(x)[1]
        
        #   Return the "rectangle" such that its top-left corner is at the spot
        #   where its previous top-left corner was
        if (degrees %% 360 == 90) {
            new_coords <- new_coords + c(dim_max[1], 0)
        } else if (degrees %% 360 == 180) {
            new_coords <- new_coords + rev(dim_max)
        } else if (degrees %% 360 == 270) {
            new_coords <- new_coords + c(0, dim_max[2])
        }
        
        #   Ensure we have integer values for coordinates, and the correct
        #   dimnames
        new_coords <- matrix(
            as.integer(round(t(new_coords))),
            ncol = 2,
            dimnames = dimnames(spatialCoords(x))
        )
        
        #   Return a copy of the SpatialExperiment with the new coordinates
        spatialCoords(x) <- new_coords
        return(x)
    }
)

#' @rdname SpatialExperiment-rotate-mirror
#' @export
setMethod(
    "mirrorCoords",
    "SpatialExperiment",
    function(x, sample_id = NULL, axis = c("h", "v"), warn = TRUE) {
        #   Subset by 'sample_id', if supplied
        if (!is.null(sample_id)) {
            #   Ensure the sample is present in the object
            if (!(sample_id %in% colData(x)$sample_id)) {
                stop(
                    paste0(
                        "'", sample_id, "' is not a sample in",
                        "'colData(x)$sample_id': cannot subset."
                    )
                )
            }
            
            #   Subset
            x <- x[, colData(x)$sample_id == sample_id]
        }
        
        #   Parse 'axis' into a numeric vector, since the mirror operation will
        #   be performed by multiplication
        if (axis == "h") {
            refl_vec <- c(1, -1)
        } else if (axis == "v") {
            refl_vec <- c(-1, 1)
        } else if (is.null(axis)) {
            refl_vec <- c(1, 1)
        } else {
            stop(paste("Invalid 'axis' argument:", axis))
        }

        if (warn) {
            warning(
                paste0(
                    "Invoking 'mirrorCoords' or 'mirrorImg' independently may ",
                    "result in mismatches between coordinates and images. ",
                    "Please use 'mirrorObject' to ensure consistency."
                )
            )
        }
        
        #   Get the dimensions of the "rectangle" containing the set of
        #   spatialCoords within the object
        dim_max <- dim(imgRaster(x)) / scaleFactors(x)[1]

        #   Perform mirror
        new_coords <- refl_vec * t(spatialCoords(x))
        
        #   Return "rectangle" to its original location depending on the axis
        if (axis == "v") {
            new_coords <- new_coords + c(dim_max[2], 0)
        } else if (axis == "h") {
            new_coords <- new_coords + c(0, dim_max[1])
        }

        #   Ensure we have integer values for coordinates, and the correct
        #   dimnames
        new_coords <- matrix(
            as.integer(round(t(new_coords))),
            ncol = 2,
            dimnames = dimnames(spatialCoords(x))
        )
        
        #   Return a copy of the SpatialExperiment with the new coordinates
        spatialCoords(x) <- new_coords
        return(x)
    }
)

# rotate/mirrorObject ----------------------------------------------------------

#' @rdname SpatialExperiment-rotate-mirror
#' @export
setMethod(
    "rotateObject",
    "SpatialExperiment",
    function(x, sample_id = NULL, image_id = NULL, degrees = 90) {
        #   imgData
        x <- rotateImg(x, sample_id, image_id, degrees)
        
        #   spatialCoords
        x <- rotateCoords(x, sample_id, degrees, FALSE)
        
        return(x)
    }
)

#' @rdname SpatialExperiment-rotate-mirror
#' @export
setMethod(
    "mirrorObject",
    "SpatialExperiment",
    function(x, sample_id = NULL, image_id = NULL, axis = c("h", "v")) {
        #   imgData
        x <- mirrorImg(x, sample_id, image_id, axis)
        
        #   spatialCoords
        x <- mirrorCoords(x, sample_id, axis, FALSE)
        
        return(x)
    }
)

#' @name SpatialExperiment-methods
#' 
#' @title Methods for spatial attributes
#' 
#' @aliases
#' spatialData spatialData<-
#' spatialDataNames spatialDataNames<-
#' spatialCoords spatialCoords<-
#' spatialCoordsNames spatialCoordsNames<-
#' imgData imgData<-
#' scaleFactors
#' 
#' @description
#' The \code{\link{SpatialExperiment}} class provides a family of methods to get
#' and set spatial data attributes in \code{\link{SpatialExperiment}} objects.
#' Spatial attributes include \code{spatialCoords}, \code{imgData}, and
#' \code{scaleFactors}, as well as methods to rotate and mirror
#' SpatialExperiment objects and their spatial coordinates.
#' 
#' @param x A \code{\link{SpatialExperiment}} object.
#' @param value Replacement value for replacement methods.
#' @param sample_id Logical value or character vector specifying sample
#'   identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all samples).
#' @param image_id Logical value or character vector specifying image
#'   identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all images).
#' @param name The name of the \code{colData} column to extract.
#' 
#' @details
#' Additional details for each type of data attribute are provided below.
#' 
#' Note: \code{\link{spatialData}} and \code{\link{spatialDataNames}}
#' (previously used to store a subset of columns from \code{\link{colData}})
#' have been deprecated. All columns should be stored in either
#' \code{\link{spatialCoords}} (numeric matrix containing spatial coordinates)
#' or \code{\link{colData}} (all other columns). The
#' \code{spatialData}/\code{spatialDataNames} functionality has been retained
#' for backward compatibility but may be removed in the future.
#' 
#' See \code{\link{rotateCoords}}, \code{\link{mirrorCoords}},
#' \code{\link{rotateObject}}, or \code{\link{mirrorObject}} for details on
#' methods to rotate and mirror SpatialExperiment objects and their
#' \code{spatialCoords}.
#' 
#' @section spatialData and spatialCoords methods:
#' \describe{
#' \item{\code{spatialData(x) <- value}: }{
#'   The \code{spatialData} setter expects a \code{DataFrame}. 
#'   If the input does not contain an \code{in_tissue} column, 
#'   this will be included with a default value of \code{1}.}
#' \item{\code{spatialCoords(x)}: }{
#'   Getter for numeric matrix of spatial coordinates.}
#' \item{\code{spatialCoords(x) <- value}: }{
#'   Setter for numeric matrix of spatial coordinates.}
#' }
#' 
#' @section spatialDataNames and spatialCoordsNames methods:
#' \describe{
#' \item{\code{spatialDataNames(x)}: }{
#'   Returns the names of the \code{colData} associated with the 
#'   spatial information, which are stored in the \code{int_metadata}.}
#' \item{\code{spatialDataNames(x) <- value}: }{
#'   Setter to replace column names
#'   in the \code{spatialData} \code{DataFrame}.}
#' \item{\code{spatialCoordsNames(x)}: }{
#'   Returns the defined names of the
#'   spatial coordinates (e.g. \code{c("x", "y")}).}
#' \item{\code{spatialCoordsNames(x) <- value}: }{
#'   Setter to define the names of the spatial coordinate columns.}
#' }
#' 
#' @section imgData methods:
#' \describe{
#' \item{\code{imgData(x)}: }{
#'   Getter to return the \code{imgData} \code{DataFrame}.}
#' \item{\code{imgData(x) <- value}: }{
#'   Setter to provide a \code{DataFrame} object as 
#'   \code{imgData} of the \code{SpatialExperiment} object.}
#' }
#' 
#' @section Other methods:
#' \describe{
#' \item{\code{scaleFactors(x, sample_id, image_id)}: }{
#'   Getter to return the scale factors associated with the 
#'   \code{sample_id}(s) and \code{image_id}(s) provided. 
#'   This is related to the stored image(s) in the \code{SpatialExperiment} 
#'   \code{imgData} structure. See argument descriptions for further details.}
#' }
#' 
#' @return Return value varies depending on method, as described below.
#' 
#' @examples
#' example(read10xVisium)
#' 
#' # spatialCoords returns a numeric matrix
#' head(spatialCoords(spe))
#' 
#' # change spatial coordinate names
#' spatialCoordsNames(spe)
#' spatialCoordsNames(spe) <- c("x", "y")
#' head(spatialCoords(spe))
#' 
#' # imgData and scale factors
#' imgData(spe)
#' scaleFactors(spe)
#' 
#' # tabulate number of spots mapped to tissue
#' cd <- colData(spe)
#' table(
#'   in_tissue = cd$in_tissue, 
#'   sample_id = cd$sample_id)
NULL

# spatialData ------------------------------------------------------------------

#' @rdname SpatialExperiment-methods
#' @importFrom SummarizedExperiment colData
#' @export
setMethod("spatialData", 
    "SpatialExperiment",
    function(x) {
        colData(x)[spatialDataNames(x)]
    }
)

#' @rdname SpatialExperiment-methods
#' @importFrom SummarizedExperiment colData colData<-
#' @export
setReplaceMethod("spatialData", 
    c("SpatialExperiment", "DFrame"),
    function(x, value) {
        stopifnot(nrow(value) == ncol(x))
        out <- colData(x)
        old <- names(out)
        new <- names(value)
        dup <- intersect(old, new)
        if (length(dup) > 0) {
            out[dup] <- value
            value <- value[setdiff(new, dup)]
        }
        out <- cbind(out, value)
        colData(x) <- out
        spatialDataNames(x) <- new
        return(x)
    }
)

#' @rdname SpatialExperiment-methods
#' @importFrom S4Vectors make_zero_col_DFrame
#' @export
setReplaceMethod("spatialData", 
    c("SpatialExperiment", "NULL"),
    function(x, value) {
        `spatialDataNames<-`(x, value)
    }
)

# spatialDataNames -------------------------------------------------------------

#' @rdname SpatialExperiment-methods
#' @importFrom S4Vectors metadata
#' @export
setMethod("spatialDataNames", 
    "SpatialExperiment", 
    function(x) {
        .msg_spatialData()
        int_metadata(x)$spatialDataNames
    }
)

#' @rdname SpatialExperiment-methods
#' @importFrom SummarizedExperiment colData
#' @importFrom SingleCellExperiment int_metadata<-
#' @export
setReplaceMethod("spatialDataNames", 
    c("SpatialExperiment", "character"),
    function(x, value) {
        stopifnot(value %in% names(colData(x)))
        int_metadata(x)$spatialDataNames <- value
        return(x)
    }
)

#' @rdname SpatialExperiment-methods
#' @export
setReplaceMethod("spatialDataNames",
    c("SpatialExperiment", "NULL"),
    function(x, value) {
        value <- character()
        `spatialDataNames<-`(x, value)
    }
)

# spatialCoords ----------------------------------------------------------------

#' @rdname SpatialExperiment-methods
#' @importFrom SingleCellExperiment int_colData<-
#' @export
setMethod("spatialCoords", 
    "SpatialExperiment",
    function(x) int_colData(x)$spatialCoords)

#' @rdname SpatialExperiment-methods
#' @importFrom SingleCellExperiment int_colData<-
#' @export
setReplaceMethod("spatialCoords", 
    c("SpatialExperiment", "matrix"),
    function(x, value) {
        stopifnot(
            is.numeric(value),
            nrow(value) == ncol(x))
        int_colData(x)$spatialCoords <- value
        return(x)
    }
)

#' @rdname SpatialExperiment-methods
#' @export
setReplaceMethod("spatialCoords", 
    c("SpatialExperiment", "NULL"),
    function(x, value) {
        value <- matrix(numeric(), ncol(x), 0)
        `spatialCoords<-`(x, value)
    }
)

# spatialCoordsNames -----------------------------------------------------------

#' @rdname SpatialExperiment-methods
#' @importFrom SingleCellExperiment int_colData
#' @export
setMethod("spatialCoordsNames", 
    "SpatialExperiment", 
    function(x) colnames(int_colData(x)$spatialCoords))

#' @rdname SpatialExperiment-methods
#' @importFrom SingleCellExperiment int_colData<-
#' @export
setReplaceMethod("spatialCoordsNames", 
    c("SpatialExperiment", "character"), 
    function(x, value) {
        colnames(int_colData(x)$spatialCoords) <- value
        return(x)
    }
)

#' @rdname SpatialExperiment-methods
#' @export
setReplaceMethod("spatialCoordsNames", 
    c("SpatialExperiment", "NULL"), 
    function(x, value) {
        value <- character()
        `spatialCoordsNames<-`(x, value)
    }
)

# scaleFactors -----------------------------------------------------------------

#' @rdname SpatialExperiment-methods
#' @export
setMethod("scaleFactors", 
    "SpatialExperiment",
    function(x, sample_id=TRUE, image_id=TRUE) {
        stopifnot(!is.null(imgData(x)))
        idx <- .get_img_idx(x, sample_id, image_id)
        imgData(x)$scaleFactor[idx]
    }
)

# utils ------------------------------------------------------------------------

# message for deprecation of spatialData/Names
.msg_spatialData <- function() {
    message(paste0(
        "Note: spatialData and spatialDataNames have been deprecated; all ", 
        "columns should be stored in colData and spatialCoords"))
}

#' @export
#' @importFrom utils .DollarNames
.DollarNames.SpatialExperiment <- function(x, pattern = "")
    grep(pattern, names(colData(x)), value = TRUE)

#' @rdname SpatialExperiment-methods
#' @aliases $,SpatialExperiment-method
#' @exportMethod $
setMethod("$", "SpatialExperiment", function(x, name) {
    colData(x)[[name]]
})

#' @name SpatialExperiment-misc
#' 
#' @title Miscellaneous SpatialExperiment methods
#' 
#' @description
#' Miscellaneous methods for the \code{\link{SpatialExperiment}} class and its
#' descendants that do not fit into any other documentation category such as,
#' for example, show methods.
#' 
#' @param object a \code{\link{SpatialExperiment}} object
#' 
#' @return Returns NULL
#' 
#' @author Dario Righelli and Helena L. Crowell
#' 
#' @examples
#' example(read10xVisium)
#' spe
NULL

# SpatialExperiment show method ------------------------------------------------

#' @importFrom S4Vectors coolcat
#' @importFrom methods callNextMethod
.spe_show <- function(object) {
    callNextMethod()
    coolcat("spatialCoords names(%d) : %s\n", spatialCoordsNames(object))
    coolcat("imgData names(%d): %s\n", names(imgData(object)))
}

#' @rdname SpatialExperiment-misc
setMethod("show", "SpatialExperiment", .spe_show)

# SpatialImage show method -----------------------------------------------------

#' @name SpatialImage-misc
#' @title Miscellaneous \code{SpatialImage} methods
#' 
#' @description
#' Miscellaneous methods for the \code{\link{SpatialImage}} class that do not
#' fit into any other documentation category such as, for example, show methods.
#' 
#' @param object a \code{SpatialImage} object
#' 
#' @return none
#' 
#' @author Helena L. Crowell
NULL

.spi_show <- function(object) {
    dim <- paste(rev(dim(object)), collapse=" x ")
    str <- paste0(dim, " (width x height) ", class(object), "\n")
    cat(str)
    str <- imgSource(object)
    if (!is.na(str)) {
        if (nchar(str) > 80) {
            ss <- strsplit(str, "")[[1]]
            ss <- split(ss, ceiling(seq_along(ss)/80))
            str <- paste(lapply(ss, paste, collapse=""), collapse="\n  ")
        }
        cat("imgSource():\n ", str, "\n")
    }
}

#' @rdname SpatialImage-misc
setMethod("show", "VirtualSpatialImage", .spi_show)

# imgData methods --------------------------------------------------------------

#' @export
setGeneric("imgData", function(x) standardGeneric("imgData"))

#' @export
setGeneric("imgData<-", function(x, value) standardGeneric("imgData<-"))

#' @export
setGeneric("imgRaster", function(x, ...) standardGeneric("imgRaster"))

#' @export
setGeneric("imgRaster<-", function(x, value) standardGeneric("imgRaster<-"))

#' @export
setGeneric("imgSource", function(x, ...) standardGeneric("imgSource"))

#' @export
setGeneric("imgSource<-", function(x, value) standardGeneric("imgSource<-"))

#' @export
setGeneric("getImg", function(x, ...) standardGeneric("getImg"))

#' @export
setGeneric("addImg", function(x, ...) standardGeneric("addImg"))

#' @export
setGeneric("rmvImg", function(x, ...) standardGeneric("rmvImg"))

#' @export
setGeneric("rotateImg", function(x, ...) standardGeneric("rotateImg"))

#' @export
setGeneric("mirrorImg", function(x, ...) standardGeneric("mirrorImg"))

# SpatialExperiment methods ----------------------------------------------------

#' @export
setGeneric("spatialData", function(x, ...) standardGeneric("spatialData"))

#' @export
setGeneric("spatialData<-", function(x, value) standardGeneric("spatialData<-"))

#' @export
setGeneric("spatialDataNames", function(x) standardGeneric("spatialDataNames"))

#' @export
setGeneric("spatialDataNames<-", function(x, value) standardGeneric("spatialDataNames<-"))

#' @export
setGeneric("spatialCoords", function(x, ...) standardGeneric("spatialCoords"))

#' @export
setGeneric("spatialCoords<-", function(x, value) standardGeneric("spatialCoords<-"))

#' @export
setGeneric("spatialCoordsNames", function(x) standardGeneric("spatialCoordsNames"))

#' @export
setGeneric("spatialCoordsNames<-", function(x, value) standardGeneric("spatialCoordsNames<-"))

#' @export
setGeneric("scaleFactors", function(x, ...) standardGeneric("scaleFactors"))

#' @export
setGeneric("molecules", function(x, ...) standardGeneric("molecules"))

#' @export
setGeneric("molecules<-", function(x, ..., value) standardGeneric("molecules<-"))

# SpatialExperiment methods to rotate/mirror coordinates -----------------------

#' @export
setGeneric("rotateCoords", function(x, ...) standardGeneric("rotateCoords"))

#' @export
setGeneric("mirrorCoords", function(x, ...) standardGeneric("mirrorCoords"))

#' @export
setGeneric("rotateObject", function(x, ...) standardGeneric("rotateObject"))

#' @export
setGeneric("mirrorObject", function(x, ...) standardGeneric("mirrorObject"))

#' @rdname readImgData
#' @title Read images & scale factors for 10x Genomics Visium
#'
#' @description
#' Function to read in images and scale factors for 10x Genomics Visium data,
#' and return as a valid \code{\link{imgData}} \code{DataFrame}.
#'
#' @param path a path where to find one or more images
#' @param sample_id the \code{sample_id} for the \code{\link{SpatialExperiment}}
#'   object
#' @param imageSources the images source path(s)
#' @param scaleFactors the .json file where to find the scale factors
#' @param load logical; should the image(s) be loaded into memory
#'   as a \code{grob}? If FALSE, will store the path/URL instead.
#'
#' @return a \code{\link{DataFrame}}
#'
#' @author Helena L. Crowell
#'
#' @examples
#' dir <- system.file(
#'   file.path("extdata", "10xVisium", "section1", "outs", "spatial"),
#'   package = "SpatialExperiment")
#'
#' # base directory contains
#' # - scale factors (scalefactors_json.json)
#' # - one image (tissue_lowres_image.png)
#' list.files(dir)
#'
#' # read in images & scale factors
#' # as valid 'imgData' 'DFrame'
#' readImgData(dir, sample_id = "foo")
#'
#' @importFrom rjson fromJSON
#' @importFrom magick image_read image_info
#' @export

# TODO: change 'as' to 'load = TRUE/FALSE' &
# support images to be supplied as path or URL

readImgData <- function(path=".", sample_id=names(path),
    imageSources=file.path(path, "tissue_lowres_image.png"),
    scaleFactors=file.path(path, "scalefactors_json.json"),
    load=TRUE) {

    # get sample identifiers
    if (is.null(sample_id))
        stop("'sample_id' mustn't be NULL")
    stopifnot(
        is.character(sample_id),
        length(unique(sample_id)) == length(path))
    names(path) <- names(scaleFactors) <- sample_id

    # put images into list with one element per sample
    images <- lapply(path, function(.)
        grep(., imageSources, value=TRUE, fixed=TRUE))

    dfs <- lapply(sample_id, function(sid)
    {
        sfs <- fromJSON(file=scaleFactors[sid])
        dfs <- lapply(images[[sid]], function(img)
        {
            # get image identifier
            img_nm <- gsub("\\..*", "", basename(img))
            iid <- switch(img_nm,
                tissue_lowres_image="lowres",
                tissue_hires_image="hires",
                detected_tissue_image="detected",
                aligned_fiducials="aligned")
            # get scale factor
            sf_nm <- switch(iid,
                lowres="tissue_lowres_scalef",
                "tissue_hires_scalef")
            sf <- sfs[[grep(sf_nm, names(sfs))]]
            # get 'imgData'
            .get_imgData(img, sf, sid, iid, load)
        })
        do.call(rbind, dfs)
    })
    do.call(rbind, dfs)
}

dir <- system.file(
    file.path("extdata", "10xVisium", "section1", "outs"),
    package = "SpatialExperiment")
fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
xyz <- read.csv(fnm, header = FALSE, col.names = c(
    "barcode", "in_tissue", "array_row", "array_col",
    "pxl_row_in_fullres", "pxl_col_in_fullres"))
img <- readImgData(
    path = file.path(dir, "spatial"),
    sample_id="sample01")
example(SingleCellExperiment, echo=FALSE)
sce <- sce[1:50, 1:50]

.spe <- "SpatialExperiment"

test_that("SingleCellExperiment AS SpatialExperiment case 1", {
    expect_s4_class(as(sce, .spe), class=.spe)
})

test_that("SingleCellExperiment AS SpatialExperiment case 2", {
    int_colData(sce)$spatialData <- DataFrame(xyz[,c(1:4)])
    int_colData(sce)$spatialCoords <- as.matrix(xyz[,c(5,6)])
    expect_s4_class(as(sce, .spe), class=.spe)
})

test_that("SingleCellExperiment AS SpatialExperiment case 3", {
    int_colData(sce)$spatialData <- DataFrame(xyz[,c(1:4)])
    int_colData(sce)$spatialCoords <- as.matrix(xyz[,c(5,6)])
    int_colData(sce)$imgData <- img
    expect_s4_class(as(sce, .spe), class=.spe)
})

test_that("SingleCellExperiment TO SpatialExperiment case 1" ,{
    # case 1: no arguments
    expect_s4_class(toSpatialExperiment(sce), .spe)
    expect_equal(toSpatialExperiment(sce), as(sce, .spe))
})


test_that("SingleCellExperiment TO SpatialExperiment case 2" ,{
    # case 2: passing "spatial arguments" on simple sce
    expect_s4_class(toSpatialExperiment(sce, imgData=img,
        spatialData=DataFrame(xyz),
        spatialCoordsNames=c("pxl_col_in_fullres", "pxl_row_in_fullres"),
        sample_id="sample01"), .spe)
})

test_that("SingleCellExperiment TO SpatialExperiment case 3" ,{
    # case 3: passing "spatial arguments" on populated sce
    # giving priority to "spatial args"
    
    int_colData(sce)$spatialData <- DataFrame(xyz[, c(1:4)])
    int_colData(sce)$spatialCoords <- as.matrix(xyz[, c(5,6)])
    xyz$in_tissue <- 1
    xyz$pxl_row_in_fullres <- 1
    spe <- toSpatialExperiment(sce, imgData=img,
       spatialData=DataFrame(xyz),
       spatialCoordsNames=c("pxl_col_in_fullres", "pxl_row_in_fullres"),
       sample_id="sample01")
    expect_s4_class(spe, .spe)
    expect_equal(spatialCoords(spe), as.matrix(xyz[, c(6,5)]))
    expect_equal(spatialData(spe), DataFrame(xyz[, c(1:4)]))
})

#' @rdname read10xVisium
#' 
#' @title Load data from a 10x Genomics Visium experiment
#' 
#' @description 
#' Creates a \code{\link{SpatialExperiment}} from the Space Ranger 
#' output directories for 10x Genomics Visium spatial gene expression data.
#' 
#' @param samples a character vector specifying one or more directories, 
#'   each corresponding to a 10x Genomics Visium sample (see Details);
#'   if provided, names will be used as sample identifiers
#' @param sample_id character string specifying unique sample identifiers,
#'   one for each directory specified via \code{samples}; 
#'   ignored if \code{!is.null(names(samples))}
#' @param type character string specifying 
#'   the type of format to read count data from
#'   (see \code{read10xCounts})
#' @param data character string specifying whether to read in
#'   filtered (spots mapped to tissue) or raw data (all spots).
#' @param images character vector specifying which images to include. 
#'   Valid values are \code{"lowres", "hires", "fullres", "detected", "aligned"}
#' @param load logical; should the image(s) be loaded into memory
#'   as a \code{grob}? If FALSE, will store the path/URL instead.
#'   
#' @details 
#' The constructor assumes data from each sample are located 
#' in a single output directory as returned by Space Ranger, 
#' thus having the following file organization (where "raw/filtered" 
#' refers to either "raw" or "filtered" to match the `data` argument.) 
#' The base directory "outs/" from Space Ranger can either be included 
#' manually in the paths provided in `samples`, or can be ignored; 
#' if ignored, it will be added automatically. The `.h5` files are 
#' used if `type = "HDF5"`. (Note that `tissue_positions.csv` was 
#' renamed in Space Ranger v2.0.0.)
#' 
#' sample \cr
#' · | — outs \cr
#' · · | — raw/filtered_feature_bc_matrix.h5 \cr
#' · · | — raw/filtered_feature_bc_matrix    \cr
#' · · · | — barcodes.tsv.gz \cr
#' · · · | — features.tsv.gz \cr
#' · · · | — matrix.mtx.gz   \cr
#' · · | — spatial \cr
#' · · · | — scalefactors_json.json    \cr
#' · · · | — tissue_lowres_image.png   \cr
#' · · · | — tissue_positions.csv \cr
#'
#' @return a \code{\link{SpatialExperiment}} object
#'
#' @author Helena L. Crowell
#'
#' @examples
#' dir <- system.file(
#'   file.path("extdata", "10xVisium"), 
#'   package = "SpatialExperiment")
#'   
#' sample_ids <- c("section1", "section2")
#' samples <- file.path(dir, sample_ids, "outs")
#'   
#' list.files(samples[1])
#' list.files(file.path(samples[1], "spatial"))
#' file.path(samples[1], "raw_feature_bc_matrix")
#' 
#' (spe <- read10xVisium(samples, sample_ids, 
#'   type = "sparse", data = "raw", 
#'   images = "lowres", load = FALSE))
#' 
#' # base directory 'outs/' from Space Ranger can also be omitted
#' samples2 <- file.path(dir, sample_ids)
#' (spe2 <- read10xVisium(samples2, sample_ids, 
#'   type = "sparse", data = "raw", 
#'   images = "lowres", load = FALSE))
#' 
#' # tabulate number of spots mapped to tissue
#' cd <- colData(spe)
#' table(
#'   in_tissue = cd$in_tissue, 
#'   sample_id = cd$sample_id)
#' 
#' # view available images
#' imgData(spe)
#' 
#' @importFrom rjson fromJSON
#' @importFrom methods as
#' @importFrom S4Vectors DataFrame 
#' @importFrom SummarizedExperiment assays rowData
#' @export
read10xVisium <- function(samples="",
    sample_id=paste0("sample", sprintf("%02d", seq_along(samples))),
    type=c("HDF5", "sparse"),
    data=c("filtered", "raw"),
    images="lowres",
    load=TRUE) {
    
    # check if DropletUtils is installed
    if (!requireNamespace("DropletUtils", quietly = TRUE)) {
        warning("DropletUtils package must be installed to use read10xVisium()")
    }
    
    # check validity of input arguments
    type <- match.arg(type)
    data <- match.arg(data)
    imgs <- c("lowres", "hires", "detected", "aligned")
    imgs <- match.arg(images, imgs, several.ok=TRUE)

    # check sample identifiers
    if (is.null(sids <- names(samples))) {
        if (is.null(sids <- sample_id)) {
            stop("'sample_id' mustn't be NULL when 'samples' are unnamed")
        } else if (!is.character(sample_id) 
            && length(unique(sample_id)) != length(samples))
            stop("'sample_id' should contain as many unique values as 'samples'")
    } else if (length(unique(sids)) != length(samples))
        stop("names of 'samples' should be unique")
    names(samples) <- sids
    
    # add "outs/" directory if not already included
    i <- basename(samples) != "outs"
    samples[i] <- file.path(samples[i], "outs")
    
    # setup file paths
    fns <- paste0(
        data, "_feature_bc_matrix", 
        switch(type, HDF5=".h5", ""))
    counts <- file.path(samples, fns)
    
    # TODO: check that these files exist & are of valid format
    # otherwise things will fail & give unhelpful error messages
    
    dir <- file.path(samples, "spatial")
    suffix <- c("", "_list")
    xyz <- file.path(
        rep(dir, each = length(suffix)), 
        sprintf(
            "tissue_positions%s.csv", 
            rep(suffix, length(sids))))
    xyz <- xyz[file.exists(xyz)]
    sfs <- file.path(dir, "scalefactors_json.json")
    names(xyz) <- names(sfs) <- sids
    
    # read image data
    img_fns <- list(
        lowres="tissue_lowres_image.png",
        hires="tissue_hires_image.png",
        detected="detected_tissue_image.jpg",
        aligned="aligned_fiducials.jpg")
    
    img_fns <- img_fns[imgs]
    img_fns <- lapply(dir, file.path, img_fns)
    img_fns <- unlist(img_fns)
    
    nan <- !file.exists(img_fns)
    if (all(nan)) {
        stop(sprintf(
            "No matching files found for 'images=c(%s)", 
            paste(dQuote(imgs), collapse=", ")))
    } else if (any(nan)) {
        message("Skipping missing images\n  ", 
            paste(img_fns[nan], collapse="\n  "))
        img_fns <- img_fns[!nan]
    }
    img <- readImgData(samples, sids, img_fns, sfs, load)
    
    # read spatial coordinates
    spel <- lapply(seq_along(counts), function(i) {
        # read count data as 'SingleCellExperiment'
        sce <- DropletUtils::read10xCounts(
            samples=counts[i], 
            sample.names=sids[i],
            col.names=TRUE)
        # read in spatial data
        spd <- .read_xyz(xyz[i])
        # match ordering
        obs <- intersect(
            colnames(sce), 
            rownames(spd))
        sce <- sce[, obs]
        spd <- spd[obs, ]
        # construct 'SpatialExperiment'
        SpatialExperiment(
            assays=assays(sce),
            rowData=DataFrame(symbol=rowData(sce)$Symbol),
            sample_id=sids[i],
            colData=DataFrame(spd),
            spatialCoordsNames=c("pxl_col_in_fullres", "pxl_row_in_fullres"))
    }) 
    spe <- do.call(cbind, spel)
    imgData(spe) <- img
    return(spe)
}

#' @importFrom S4Vectors DataFrame
#' @importFrom utils read.csv
.read_xyz <- function(x) {
    cnms <- c(
        "barcode", "in_tissue", "array_row", "array_col", 
        "pxl_row_in_fullres", "pxl_col_in_fullres")
    df <- lapply(seq_along(x), function(i) 
    {
        df <- read.csv(x[i], 
            header=!grepl("list", x[i]), 
            row.names=1, col.names=cnms)
        if (length(x) > 1) rownames(df) <- paste(i, rownames(df), sep="_")
        if (!is.null(names(x))) cbind(sample_id=names(x)[i], df)
        df
    })
    df <- do.call(rbind, df)
    df$in_tissue <- as.logical(df$in_tissue)
    return(df)
}

dir <- system.file(
    file.path("extdata", "10xVisium"), 
    package="SpatialExperiment")

sample_ids <- c("section1", "section2")
samples <- file.path(dir, sample_ids, "outs")

test_that("data are read correctly", {
    x <- read10xVisium(samples, sample_ids,
        type="sparse", data="raw", 
        images="lowres", load=FALSE)
    
    expect_is(x, "SpatialExperiment")
    expect_true(all(vapply(getImg(x, TRUE, TRUE), 
        function(.) is(., "VirtualSpatialImage"), logical(1))))
    
    cnms <- c(
        "barcode", "in_tissue", "array_row", "array_col", 
        "pxl_col_in_fullres", "pxl_row_in_fullres")
    xyz <- file.path(samples, "spatial", "tissue_positions_list.csv")
    xyz <- lapply(xyz, read.csv, header=FALSE, row.names=1, col.names=cnms)
    
    sids <- rep.int(sample_ids, vapply(xyz, nrow, numeric(1)))
    xyz <- data.frame(sample_id=sids, do.call(rbind, xyz))
    xyz$in_tissue <- as.logical(xyz$in_tissue)
    
    cd <- cbind(colData(x), spatialData(x))
    expect_identical(
        table(cd$sample_id, cd$in_tissue),
        table(xyz$sample_id, xyz$in_tissue))

    sfs <- file.path(samples, "spatial", "scalefactors_json.json")
    sfs <- lapply(sfs, function(.) fromJSON(file=.))
    sfs <- vapply(sfs, function(.) .[["tissue_lowres_scalef"]], numeric(1))
    expect_identical(imgData(x)$scaleFactor, sfs)
})

test_that("names of 'samples' are used as 'sample_id's", {
    names(samples) <- sample_ids
    x <- read10xVisium(samples, 
        type="sparse", data="raw", 
        images="lowres", load=FALSE)
    expect_identical(unique(x$sample_id), sample_ids)
})

test_that("'sample_id's are used when 'samples' are unnamed", {
    x <- read10xVisium(samples, sample_ids, 
        type="sparse", data="raw", 
        images="lowres", load=FALSE)
    expect_identical(unique(x$sample_id), sample_ids)
})

test_that("'load=TRUE' returns 'LoadedSpatialImage's", {
    x <- read10xVisium(samples, 
        type="sparse", data="raw", 
        images="lowres", load=TRUE)
    expect_true(all(vapply(getImg(x, TRUE, TRUE), 
        function(.) is(., "LoadedSpatialImage"), logical(1))))
})

test_that("adding 'outs/' directory works correctly for one or more samples", {
    samples2 <- samples3 <- file.path(dir, sample_ids)
    samples3[1] <- file.path(samples3[1], "outs")
    
    x1 <- read10xVisium(samples, sample_ids, type = "sparse", 
                        data = "raw", images = "lowres", load = FALSE)
    x2 <- read10xVisium(samples2, sample_ids, type = "sparse", 
                        data = "raw", images = "lowres", load = FALSE)
    x3 <- read10xVisium(samples3, sample_ids, type = "sparse", 
                        data = "raw", images = "lowres", load = FALSE)
    
    expect_identical(x1, x2)
    expect_identical(x1, x3)
})

test_that(paste0("tissue positions files are read in correct sample order and ", 
                 "spatial coordinates are in correct order in SPE object", 
                 "in datasets with multiple samples"), {
    # read in 4 samples and check spatial coordinates are in correct order
    # correct sample order is: section1, section2, section1, section2
    samples <- c(samples, samples)
    sample_ids <- c(sample_ids, paste0(sample_ids, "rep"))
    
    spatial_coords_1 <- spatialCoords(
      read10xVisium(samples[1], sample_ids[1], type = "sparse", 
                    data = "raw", images = "lowres", load = FALSE))
    spatial_coords_2 <- spatialCoords(
      read10xVisium(samples[2], sample_ids[2], type = "sparse", 
                    data = "raw", images = "lowres", load = FALSE))
    
    spatial_coords_multi <- spatialCoords(
      read10xVisium(samples, sample_ids, type = "sparse", 
                    data = "raw", images = "lowres", load = FALSE))
    
    # correct number of spatial locations
    expect_equal(
        nrow(spatial_coords_multi), 
        2 * nrow(spatial_coords_1) + 2 * nrow(spatial_coords_2))
    
    # spatial coordinates are in correct order
    expect_identical(
        spatial_coords_multi, 
        rbind(spatial_coords_1, spatial_coords_2, 
              spatial_coords_1, spatial_coords_2))
})

#' @name SpatialExperiment-subset
#' 
#' @title Subsetting SpatialExperiment objects
#' 
#' @aliases [,SpatialExperiment,ANY,ANY,ANY-method
#' 
#' @description
#' The subsetting method for \code{\link{SpatialExperiment}} objects ensures
#' that spatial data attributes (\code{\link{spatialCoords}} and
#' \code{\link{imgData}}) are subsetted correctly to match rows and columns with
#' the remainder of the object.
#' 
#' @section subset:
#' \describe{
#' \item{\code{[}:}{ subsetting method}
#' }
#' 
#' @param x a \code{\link{SpatialExperiment}} object
#' @param i row indices for subsetting
#' @param j column indices for subsetting
#' 
#' @return a \code{\link{SpatialExperiment}} object
#' 
#' @examples
#' example(read10xVisium)
#' 
#' dim(spe)
#' 
#' set.seed(123)
#' idx <- sample(ncol(spe), 10)
#' sub <- spe[, idx]
#' dim(sub)
#' colData(sub)
#' spatialCoords(sub)
NULL

# we overwrite the default subsetting method
# to assure that the 'imgData' and 'spatialData' are subsetted if columns/rows 
# are dropped

#' @importFrom methods callNextMethod
#' @export
setMethod("[",
    c("SpatialExperiment", "ANY", "ANY"),
    function(x, i, j, ..., drop=FALSE) {
        if (missing(i)) i <- TRUE
        if (missing(j)) j <- TRUE
        x <- callNextMethod()
        if ( !isEmpty(imgData(x)) ) {
            keep <- imgData(x)$sample_id %in% unique(x$sample_id)
            imgData(x) <- imgData(x)[keep, ]
        }
        return(x)
    }
)

#' @name SpatialExperiment-combine
#' 
#' @title Combining SpatialExperiment objects
#' 
#' @aliases cbind,SingleCellExperiment-method
#' 
#' @description
#' The \code{\link{SpatialExperiment}} class provides modified methods to
#' combine multiple \code{SpatialExperiment} objects by column, for example from
#' multiple samples. These methods ensure that all data fields remain
#' synchronized when samples are added or removed.
#' 
#' @section Combining:
#' The \code{...} argument is assumed to contain one or more
#' \code{\link{SpatialExperiment}} objects.
#' 
#' \describe{
#' \item{\code{cbind(..., deparse.level=1)}:}{ 
#' Returns a \code{SpatialExperiment} where all objects in \code{...} are
#' combined column-wise, i.e., columns in successive objects are appended to the
#' first object.
#' 
#' Each \code{SpatialExperiment} object in \code{...} must have the same
#' \code{colData} (with the same \code{\link{spatialCoords}}). If multiple
#' objects use the same \code{sample_id}, the method will proceed by assigning
#' unique \code{sample_id}s.
#' 
#' Additionally, the method combines \code{imgData} by row using \code{rbind}.
#' 
#' Refer to \code{?"\link{cbind,SingleCellExperiment-method}"} for details on
#' how metadata and other inherited attributes are combined in the output
#' object.
#' 
#' Refer to \code{?\link[base]{cbind}} for the interpretation of
#' \code{deparse.level}.
#' }
#' }
#' 
#' @param ... a list of \code{\link{SpatialExperiment}} objects
#' @param deparse.level refer to \code{?\link[base]{rbind}}
#' 
#' @return a combined \code{\link{SpatialExperiment}} object
#' 
#' @author
#' Dario Righelli
#' 
#' @examples
#' example(read10xVisium, echo = FALSE)
#'
#' # merging with duplicated 'sample_id's
#' # will automatically assign unique identifiers
#' spe1 <- spe2 <- spe
#' spe3 <- cbind(spe1, spe2)
#' unique(spe3$sample_id)
#'
#' # assign unique sample identifiers
#' spe1 <- spe2 <- spe
#' spe1$sample_id <- paste(spe1$sample_id, "sample1", sep = ".")
#' spe2$sample_id <- paste(spe2$sample_id, "sample2", sep = ".")
#' 
#' # combine into single object
#' spe <- cbind(spe1, spe2)
#' 
#' # view joint 'imgData'
#' imgData(spe)
#' 
#' # tabulate number of spots mapped to tissue
#' cd <- colData(spe)
#' table(
#'   in_tissue = cd$in_tissue, 
#'   sample_id = cd$sample_id)
NULL

#' @rdname SpatialExperiment-combine
#' @importFrom BiocGenerics rbind cbind
setMethod("cbind", "SpatialExperiment", function(..., deparse.level=1) {

    old <- S4Vectors:::disableValidity()
    if (!isTRUE(old)) {
        S4Vectors:::disableValidity(TRUE)
        on.exit(S4Vectors:::disableValidity(old))
    }
    args <- list(...)
    
    # check that 'sample_id's are unique;
    # otherwise make them by appending 
    # '.n' where n = sample number
    sids <- unlist(lapply(args, function(.) unique(.$sample_id)))
    if (length(sids) != length(unique(sids))) {
        message(
            "'sample_id's are duplicated across",
            " 'SpatialExperiment' objects to cbind;",
            " appending sample indices.")
        idx <- c(0, cumsum(vapply(args, ncol, numeric(1))))
        for (i in seq_along(args)) {
            old <- args[[i]]$sample_id
            new <- paste(old, i, sep = ".")
            args[[i]]$sample_id <- new
        }
    }
    
    # bind SPEs
    out <- do.call(
        callNextMethod, 
        c(args, list(deparse.level=1)))
    
    # merge 'imgData' from multiple samples
    if (!is.null(imgData(args[[1]]))) { 
        newimgdata <- do.call(rbind, lapply(args, imgData))
        int_metadata(out)[names(int_metadata(out)) == "imgData"] <- NULL
        int_metadata(out)$imgData <- newimgdata
    } 
        
    return(out)
})

#' @name SpatialExperiment-coercion
#' @title SpatialExperiment coercion methods
#' 
#' @description 
#' The \code{SpatialExperiment} class inherits from the
#' \code{SingleCellExperiment} class making it necessary to coerce between these
#' classes.
#' To do so, we designed two different methods: the traditional \code{as} method
#' and the \code{toSpatialExperiment} function (recommended).
#' The \code{as} method checks if the \code{SingleCellExperiment} object has
#' already populated \code{int_colData} with three elements:
#' \code{spatialData}, \code{spatialCoords}, and \code{imgData}.
#' It also checks if \code{colData} already contains a \code{sample_id}.
#' In case these checks pass the new \code{SpatialExperiment} will have the same
#' values as the \code{SingleCellExperiment} passed object.
#' Otherwise a \code{SpatialExperiment} with default values for these slots
#' will be created.
#' 
#' The \code{toSpatialExperiment} method expects a \code{SingleCellExperiment} object
#' and additional arguments as explained in the related section of this
#' documentation. In case the \code{SingleCellExperiment} object has already
#' populated \code{int_colData} with \code{spatialData} and/or
#' \code{spatialCoords} and/or \code{imgData}, these will be respectively
#' overwritten in case the arguments \code{spatialData}/\code{spatialDataNames} 
#' and/or \code{spatialCoords}/\code{spatialCoordsNames} and/or \code{imgData} 
#' are not \code{NULL}.
#' 
#' @param sce A \code{\link{SingleCellExperiment}} object.
#' @param sample_id A \code{character} sample identifier, which matches the
#'   \code{sample_id} in \code{\link{imgData}}. The \code{sample_id} will also
#'   be stored in a new column in \code{\link{colData}}, if not already present.
#'   Default = \code{sample01}.
#' @param spatialCoordsNames A \code{character} vector of column names from
#'   \code{\link{colData}} containing spatial coordinates, which will be
#'   accessible with \code{\link{spatialCoords}}. Alternatively, the
#'   \code{spatialCoords} argument may be provided. If both are provided,
#'   \code{spatialCoordsNames} is given precedence, and a warning is returned.
#'   Default = \code{c("x", "y")}.
#' @param spatialCoords A numeric matrix containing columns of spatial
#'   coordinates, which will be accessible with \code{\link{spatialCoords}}.
#'   Alternatively, \code{spatialCoordsNames} may be provided. If both are
#'   provided, \code{spatialCoordsNames} is given precedence, and a warning is
#'   returned.
#' @param scaleFactors Optional scale factors associated with the image(s). This
#'   can be provided as a numeric value, numeric vector, list, or file path to a
#'   JSON file for the 10x Genomics Visium platform. For 10x Genomics Visium,
#'   the correct scale factor will automatically be selected depending on the
#'   resolution of the image from \code{imageSources}. Default = \code{1}.
#' @param imgData Optional \code{\link{DataFrame}} containing the image data.
#'   Alternatively, this can be built from the arguments \code{imageSources} and
#'   \code{image_id} (see Details).
#' @param imageSources Optional file path(s) or URL(s) for one or more image
#'   sources.
#' @param image_id Optional character vector (same length as
#'   \code{imageSources}) containing unique image identifiers.
#' @param loadImage Logical indicating whether to load image into memory.
#'   Default = \code{FALSE}.
#' @param spatialDataNames (Deprecated) A \code{character} vector of column
#'   names from \code{\link{colData}} to include in \code{\link{spatialData}}.
#'   Alternatively, the \code{spatialData} argument may be provided. If both are
#'   provided, \code{spatialDataNames} is given precedence, and a warning is
#'   returned. (Note: \code{spatialData} and \code{spatialDataNames} have been
#'   deprecated; \code{colData} and \code{spatialCoords} should be used for all
#'   columns. The arguments have been retained for backward compatibility but
#'   may be removed in the future.)
#' @param spatialData (Deprecated) A \code{\link{DataFrame}} containing columns
#'   to store in \code{\link{spatialData}}, which must contain at least the
#'   columns of spatial coordinates. Alternatively, \code{spatialDataNames} may
#'   be provided. If both are provided, \code{spatialDataNames} is given
#'   precedence, and a warning is returned. (Note: \code{spatialData} and
#'   \code{spatialDataNames} have been deprecated; \code{colData} and
#'   \code{spatialCoords} should be used for all columns. The arguments have
#'   been retained for backward compatibility but may be removed in the future.)

#' @aliases 
#' coerce, SingleCellExperiment, SpatialExperiment-method
#' toSpatialExperiment
#' 
#' @examples 
#' dir <- system.file(
#'     file.path("extdata", "10xVisium", "section1", "outs"),
#'     package = "SpatialExperiment")
#' 
#' # read in counts
#' fnm <- file.path(dir, "raw_feature_bc_matrix")
#' sce <- DropletUtils::read10xCounts(fnm)
#' 
#' # read in spatial coordinates
#' fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
#' xyz <- read.csv(fnm, header = FALSE,
#'     col.names = c("barcode", "in_tissue", "array_row", "array_col",
#'     "pxl_row_in_fullres", "pxl_col_in_fullres"))
#' 
#' # read in image data
#' img <- readImgData(
#'     path = file.path(dir, "spatial"),
#'     sample_id = "sample01")
#' 
#' ## as method
#' (spe <- as(sce, "SpatialExperiment"))
#' 
#' colData(sce) <- DataFrame(xyz[,c(1:4)])
#' int_colData(sce)$spatialCoords <- as.matrix(xyz[,c(5,6)])
#' 
#' ## Coercing an sce without imgData
#' (spe <- as(sce, "SpatialExperiment"))
#' 
#' ## Coercing an sce with imgData
#' int_colData(sce)$imgData <- img
#' (spe <- as(sce, "SpatialExperiment"))
#' 
#' ## toSpatialExperiment method
#' colData(sce) <- DataFrame(xyz)
#' (spe <- toSpatialExperiment(sce,
#'     imgData = img,
#'     spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
#'     sample_id = "sample01"))
NULL


setAs(
    from="SingleCellExperiment", 
    to="SpatialExperiment", 
    function(from) {
        sample_id <- unique(from$sample_id)
        if (is.null(sample_id)) sample_id <- "sample01"
        icd <- int_colData(from)
        spe <- .sce_to_spe(from, 
            sample_id=sample_id,
            spatialCoords=icd$spatialCoords,
            imgData=icd$imgData,
            spatialData=icd$spatialData)
        return(spe)
    }
)

#' @export
toSpatialExperiment <- function(sce,
    sample_id="sample01", 
    spatialCoordsNames=NULL,
    spatialCoords=NULL,
    scaleFactors=1,
    imageSources=NULL,
    image_id=NULL,
    loadImage=TRUE,
    imgData=NULL,
    spatialDataNames=NULL,
    spatialData=NULL) {
    
    stopifnot(is(sce, "SingleCellExperiment"))
    
    ## giving priority to passed arguments
    if (all(is.null(spatialCoords), is.null(spatialCoordsNames))) {
        spatialCoords <- int_colData(sce)$spatialCoords
    }
    if (all(is.null(spatialData), is.null(spatialDataNames))) {
        spatialData <- int_colData(sce)$spatialData
    }
    if (is.null(imgData)) {
        imgData <- int_colData(sce)$imgData
    }
    spe <- .sce_to_spe(sce=sce,
        sample_id = sample_id,
        spatialCoordsNames = spatialCoordsNames,
        spatialCoords = spatialCoords,
        scaleFactors = scaleFactors,
        imageSources = imageSources,
        image_id = image_id,
        loadImage = loadImage,
        imgData = imgData,
        spatialDataNames = spatialDataNames,
        spatialData = spatialData)
    return(spe)
}

example(read10xVisium, echo = FALSE)

test_that("spatialData()", {
    spd <- spatialData(spe)
    expect_is(spd, "DFrame")
    expect_identical(spd, colData(spe)[spatialDataNames(spe)])
})

test_that("spatialData(),NULL", {
    tmp <- spe; spatialData(tmp) <- NULL
    spd <- spatialData(tmp)
    expect_equal(dim(spd), c(ncol(spe), 0))
    expect_identical(spatialDataNames(tmp), character())
    expect_identical(spd, colData(tmp)[spatialDataNames(tmp)])
})

test_that("spatialData<-,ANY", {
    mat <- matrix(0, ncol(spe), 2)
    expect_error(spatialData(spe) <- mat)
    df <- data.frame(mat)
    expect_error(spatialData(spe) <- mat)
})

test_that("spatialDataNames()", {
    expect_identical(
        spatialDataNames(spe), 
        int_metadata(spe)$spatialDataNames)
})

test_that("spatialDataNames()<-,character", {
    # invalid replacement (anything not in colData)
    expect_error(spatialDataNames(spe) <- "peter_pan")
    # valid replacement (anything in colData)
    i <- spatialDataNames(spe) <- sample(names(colData(spe)), 2)
    expect_identical(int_metadata(spe)$spatialDataNames, i)
})

test_that("spatialDataNames()<-,NULL", {
    cd <- colData(spe)
    old <- spatialDataNames(spe)
    spatialDataNames(spe) <- NULL
    new <- spatialDataNames(spe)
    # colData shouldn't be affected
    expect_identical(colData(spe), cd)
    expect_identical(new, character(0))
})

test_that("spatialCoordsNames()", {
    expect_identical(
        spatialCoordsNames(spe), 
        colnames(int_colData(spe)$spatialCoords))
})

test_that("spatialCoordsNames<-,character", {
    old <- spatialCoordsNames(spe)
    new <- sample(letters, length(old))
    spatialCoordsNames(spe) <- new
    expect_identical(spatialCoordsNames(spe), new)
    expect_identical(spatialCoordsNames(spe), 
        colnames(int_colData(spe)$spatialCoords))
})

test_that("spatialCoordsNames<-,NULL", {
    old <- spatialCoords(spe)
    spatialCoordsNames(spe) <- NULL
    expect_null(spatialCoordsNames(spe))
    expect_equivalent(spatialCoords(spe), old)
})

test_that("scaleFactors()", {
    sfs <- scaleFactors(spe, sample_id=TRUE, image_id=TRUE)
    expect_is(sfs, "numeric")
    expect_true(length(sfs) == nrow(imgData(spe)))
    expect_identical(sfs, imgData(spe)$scaleFactor)
})

example(read10xVisium, echo = FALSE)

test_that("duplicated sample_ids are made unique with a message", {
    expect_message(new <- cbind(spe, spe))
    expect_equal(
        length(unique(new$sample_id)), 
        2*length(unique(spe$sample_id)))
    expect_true(nrow(new) == nrow(spe))
    expect_true(ncol(new) == 2*ncol(spe))
    expect_identical(rownames(new), rownames(spe))
    expect_setequal(colnames(new), colnames(spe))
})

test_that("imgData are combined correctly", {
    spe1 <- spe; spe2 <- spe
    spe1$sample_id <- paste(spe1$sample_id, "A", sep=".")
    spe2$sample_id <- paste(spe2$sample_id, "B", sep=".")
    expect_silent(spe3 <- cbind(spe1, spe2))
    # imgData are kept only once
    expect_true(sum(grepl("imgData", names(int_metadata(spe3)))) == 1)
    # number of image entries should be doubled
    expect_equal(nrow(imgData(spe3)), 2*nrow(imgData(spe)))
    # sample_ids should be combined from input SPEs
    expect_setequal(
        unique(spe3$sample_id), 
        imgData(spe3)$sample_id)
    expect_setequal(
        unique(spe3$sample_id), 
        unique(c(spe1$sample_id, spe2$sample_id)))
    # imgData from each input SPE should be the same
    one <- seq(nrow(imgData(spe1)))
    two <- max(one)+seq(nrow(imgData(spe2)))
    expect_identical(imgData(spe3)[one, ], imgData(spe1))
    expect_identical(imgData(spe3)[two, ], imgData(spe2))
})

example(read10xVisium, echo = FALSE)

test_that("getImg/imgRaster/Source w/o imgData return NULL", {
    x <- spe
    imgData(x) <- NULL
    expect_null(getImg(x))
    expect_null(imgRaster(x))
    expect_null(imgSource(x))
})

# getImg -----------------------------------------------------------------------

test_that("getImg,sample_id=image_id='foo' throws error", {
    expect_error(getImg(spe, sample_id='foo', image_id='foo'))
})

test_that("getImg,sample_id=image_id=NULL returns a 'VirtualSpatialImage'", {
    x <- getImg(spe, sample_id=NULL, image_id=NULL)
    y <- imgData(spe)$data[[1]]
    expect_is(x, "VirtualSpatialImage")
    expect_identical(x, y)
})

test_that("getImg,sample_id=image_id=TRUE returns a list", {
    x <- getImg(spe, sample_id=TRUE, image_id=TRUE)
    y <- imgData(spe)$data
    expect_is(x, "list")
    expect_identical(x, y)
})

test_that("getImg handles non-character sample/image_id (#151)", {
    . <- (spe$sample_id <- factor(spe$sample_id))[1]
    expect_silent(getImg(spe, sample_id=.))
    . <- (spe$sample_id <- as.integer(spe$sample_id))[1]
    expect_silent(getImg(spe, sample_id=.))
    . <- imgData(spe)$image_id <- 1
    expect_silent(getImg(spe, image_id=.))
    expect_silent(getImg(spe, image_id=as.factor(.)))
})

# addImg -----------------------------------------------------------------------

test_that("addImg for existing sample_id,image_id throws error", {
    i <- sample(nrow(df <- imgData(spe)), 1)
    expect_error(addImg(spe, 
        imageSource=imgSource(spe), scaleFactor=NA_real_,
        sample_id=df$sample_id[i], image_id=df$image_id[i]))
})

# rmvImg -----------------------------------------------------------------------

test_that("rmvImg drops specified imgData entry", {
    i <- sample(nrow(df <- imgData(spe)), 1)
    x <- rmvImg(spe, sample_id=df$sample_id[i], image_id=df$image_id[i])
    expect_identical(imgData(x), imgData(spe)[-i, ])
})

# imgSource --------------------------------------------------------------------

test_that("imgSource,sample_id=image_id='foo' throws error", {
    expect_error(imgSource(spe, sample_id='foo', image_id='foo'))
})

test_that("imgSource,sample_id=image_id=NULL returns character", {
    x <- imgSource(spe, sample_id=NULL, image_id=NULL)
    y <- imgSource(imgData(spe)$data[[1]])
    expect_is(x, "character")
    expect_identical(x, y)
})

test_that("imgSource,sample_id=image_id=TRUE returns character vector", {
    x <- imgSource(spe, sample_id=TRUE, image_id=TRUE)
    y <- vapply(imgData(spe)$data, imgSource, character(1))
    expect_is(x, "character")
    expect_identical(x, y)
})

# imgRaster --------------------------------------------------------------------

test_that("imgRaster,sample_id=image_id='foo' throws error", {
    expect_error(imgRaster(spe, sample_id='foo', image_id='foo'))
})

test_that("imgRaster,sample_id=image_id=NULL returns character", {
    x <- imgRaster(spe, sample_id=NULL, image_id=NULL)
    y <- imgRaster(imgData(spe)$data[[1]])
    expect_is(x, "raster")
    expect_identical(x, y)
})

test_that("imgRaster,sample_id=image_id=TRUE returns raster list", {
    x <- imgRaster(spe, sample_id=TRUE, image_id=TRUE)
    y <- lapply(imgData(spe)$data, imgRaster)
    expect_is(x, "list")
    expect_true(all(vapply(x, class, character(1)) == "raster"))
    expect_identical(x, y)
})

example(read10xVisium, echo = FALSE)

test_that("colData()<-NULL retains only sample_id", {
    tmp <- spe
    tmp$foo <- "foo"
    colData(tmp) <- NULL
    expect_null(tmp$foo)
    expect_identical(tmp$sample_id, spe$sample_id)
    expect_identical(spatialDataNames(tmp), character())
})

test_that("valid colData<- without sample_id field protects sample_id", {
    tmp <- spe
    tmp$foo <- "foo"
    colData(tmp) <- DataFrame(x=seq(ncol(tmp)))
    expect_null(tmp$foo)
    expect_identical(tmp$sample_id, spe$sample_id)
})

test_that("colData<- with valid sample_id field passes", {
    old <- unique(spe$sample_id)
    new <- letters[seq_along(old)]
    new <- new[match(spe$sample_id, old)]
    cd <- DataFrame(sample_id=new)
    expect_silent(colData(spe) <- cd)
})

test_that("sample_id<- needs one-to-one mapping", {
    new <- spe$sample_id; new[1] <- "foo"
    expect_error(spe$sample_id <- new)
    expect_error(spe$sample_id <- sample(spe$sample_id))
})

test_that("valid sample_id<- updates imgData", {
    old <- unique(spe$sample_id)
    new <- paste0(old, "x")
    i <- match(spe$sample_id, old)
    tmp <- spe; tmp$sample_id <- new[i]
    for (i in seq_along(old))
        expect_equivalent(
            spe[, spe$sample_id == old[i]],
            tmp[, tmp$sample_id == new[i]])
    i <- match(imgData(spe)$sample_id, old)
    expect_identical(imgData(tmp)$sample_id, new[i])
})

example(read10xVisium, echo = FALSE)

test_that("molecules()/<- gets/sets assay(., 'molecules')", {
    tmp <- spe
    expect_identical(
        molecules(tmp) <- assay(spe),
        assay(tmp, "molecules") <- assay(spe))
    expect_identical(
        assayNames(tmp), 
        c(assayNames(spe), "molecules"))
})

example(read10xVisium, echo = FALSE)

test_that("missing i/j retains all", {
    expect_identical(spe, spe[, ])
    expect_identical(spe, spe[TRUE, ])
    expect_identical(spe, spe[, TRUE])
})

test_that("i=TRUE,j=TRUE retains all data", {
    expect_identical(spe, spe[TRUE, TRUE])
})

test_that("i=TRUE,j=FALSE drops all samples and imgData", {
    x <- spe[TRUE, FALSE]
    expect_true(ncol(x) == 0)
    expect_true(nrow(x) == nrow(spe))
    expect_true(isEmpty(imgData(x)))
})

test_that("i=FALSE,j=TRUE drops all features but keeps imgData", {
    x <- spe[FALSE, TRUE]
    expect_true(nrow(x) == 0)
    expect_true(ncol(x) == ncol(spe))
    expect_identical(imgData(x), imgData(spe))
})

test_that("j=sample_id keeps only specified sample", {
    id <- sample(unique(spe$sample_id), 1)
    x <- spe[, spe$sample_id == id]
    expect_true(all(x$sample_id == id))
    expect_true(all(imgData(x)$sample_id == id))
})

example(read10xVisium, echo = FALSE)

test_that("rotateCoords, non-null sample_id", {
    #   Subset followed by identity rotation should be equivalent to simply
    #   subsetting
    id <- unique(colData(spe)$sample_id)[1]
    x <- rotateCoords(spe, sample_id = id, degrees = 0, warn = FALSE)
    sub_spe <- spe[, colData(spe)$sample_id == id]
    expect_identical(sub_spe, x)
    
    #   Garbage value for 'sample_id' should throw an error
    expect_error(rotateCoords(spe, sample_id = "foo"))
})

test_that("mirrorCoords, identity mirror", {
    #   Mirroring twice vertically should do nothing
    x <- mirrorCoords(spe, sample_id = NULL, axis = "v", warn = FALSE)
    x <- mirrorCoords(x, sample_id = NULL, axis = "v", warn = FALSE)
    expect_identical(spe, x)
    
    #   Mirroring twice horizontally should do nothing
    x <- mirrorCoords(spe, sample_id = NULL, axis = "h", warn = FALSE)
    x <- mirrorCoords(x, sample_id = NULL, axis = "h", warn = FALSE)
    expect_identical(spe, x)
})

test_that("mirrorCoords, non-null sample_id", {
    #   Subset followed by mirror should be equivalent to mirror followed by
    #   subset
    id <- unique(colData(spe)$sample_id)[1]
    x1 <- mirrorCoords(spe, sample_id = id, axis = "h", warn = FALSE)
    x2 <- mirrorCoords(spe, sample_id = NULL, axis = "h", warn = FALSE)
    x2 <- x2[, colData(x2)$sample_id == id]
    expect_identical(x1, x2)
    
    #   Garbage value for 'sample_id' should throw an error
    expect_error(mirrorCoords(spe, sample_id = "foo", axis = "v"))
})

test_that("rotateObject, angles adding to 0", {
    #   Note that in the below tests, entire objects may not be identical
    #   since StoredSpatialImages may become LoadedSpatialImages with the same
    #   internal data (raster)
    
    #   Rotation by 0 degrees should do nothing
    x <- rotateObject(spe, sample_id = NULL, image_id = NULL, degrees = 0)
    expect_identical(spatialCoords(spe), spatialCoords(x))
    expect_identical(imgRaster(spe), imgRaster(x))
    
    #   Rotation by 180 degrees twice should do nothing
    x <- rotateObject(spe, sample_id = NULL, image_id = NULL, degrees = 180)
    x <- rotateObject(x, sample_id = NULL, image_id = NULL, degrees = 180)
    expect_identical(spatialCoords(spe), spatialCoords(x))
    expect_identical(imgRaster(spe), imgRaster(x))
    
    #   Rotation by 90 and then 270 degrees should do nothing
    x <- rotateObject(spe, sample_id = NULL, image_id = NULL, degrees = 90)
    x <- rotateObject(x, sample_id = NULL, image_id = NULL, degrees = 270)
    expect_identical(spatialCoords(spe), spatialCoords(x))
    expect_identical(imgRaster(spe), imgRaster(x))
})

test_that("mirrorObject, symmetric composition", {
    #   Note that in the below tests, entire objects may not be identical
    #   since StoredSpatialImages may become LoadedSpatialImages with the same
    #   internal data (raster)
    
    #   Order: mirrorCoords -> mirrorImg vs. mirrorImg -> mirrorCoords
    x1 <- mirrorObject(spe, sample_id = NULL, axis = "v")
    x2 <- mirrorCoords(spe, sample_id = NULL, axis = "v", warn = FALSE)
    x2 <- mirrorImg(x2, sample_id = TRUE, axis = "v")
    
    expect_identical(spatialCoords(x1), spatialCoords(x2))
    expect_identical(imgRaster(x1), imgRaster(x2))
    
    x1 <- mirrorObject(spe, sample_id = NULL, axis = "h")
    x2 <- mirrorCoords(spe, sample_id = NULL, axis = "h", warn = FALSE)
    x2 <- mirrorImg(x2, sample_id = TRUE, axis = "h")
    
    expect_identical(spatialCoords(x1), spatialCoords(x2))
    expect_identical(imgRaster(x1), imgRaster(x2))
})

test_that("mirrorObject, identity transformation", {
    #   Note that in the below tests, entire objects may not be identical
    #   since StoredSpatialImages may become LoadedSpatialImages with the same
    #   internal data (raster)
    
    #   Mirroring an object twice should do nothing
    x <- mirrorObject(spe, sample_id = NULL, axis = "h")
    x <- mirrorObject(x, sample_id = NULL, axis = "h")
    
    expect_identical(spatialCoords(x), spatialCoords(spe))
    expect_identical(imgRaster(x), imgRaster(spe))
    
    #   Mirroring an object twice should do nothing
    x <- mirrorObject(spe, sample_id = NULL, axis = "v")
    x <- mirrorObject(x, sample_id = NULL, axis = "v")
    
    expect_identical(spatialCoords(x), spatialCoords(spe))
    expect_identical(imgRaster(x), imgRaster(spe))
})

---
title: "Introduction to the SpatialExperiment class"
author: "Dario Righelli, Helena L. Crowell, Lukas M. Weber"
date: "`r format(Sys.Date(), '%b %d, %Y')`"
output:
    BiocStyle::html_document:
        toc: true
        number_sections: true
        toc_depth: 3
        toc_float:
            collapsed: true
vignette: >
    %\VignetteIndexEntry{Introduction to the SpatialExperiment class}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
editor_options: 
    chunk_output_type: inline
---

<style type="text/css"> .smaller { font-size: 10px } </style>

```{r setup, include = FALSE}
knitr::opts_chunk$set(cache = TRUE, autodep = TRUE, cache.lazy = FALSE)
```


# Class structure

## Introduction

The `SpatialExperiment` class is an R/Bioconductor S4 class for storing 
data from spatial -omics experiments. The class 
extends the `SingleCellExperiment` class for single-cell data to support 
storage and retrieval of additional information from spot-based and 
molecule-based platforms, including spatial coordinates, images, and 
image metadata. A specialized constructor function is included for data 
from the 10x Genomics Visium platform.

The following schematic illustrates the `SpatialExperiment` class 
structure.

```{r, echo=FALSE, out.width = "100%", fig.cap="Overview of the SpatialExperiment class structure."}
knitr::include_graphics("SPE.png")
```

As shown, an object consists of: (i) `assays` containing expression counts, 
(ii) `rowData` containing information on features, i.e. genes, (iii) 
`colData` containing information on spots or cells, including nonspatial 
and spatial metadata, (iv) `spatialCoords` containing spatial coordinates, 
and (v) `imgData` containing image data. For spot-based ST data (e.g. 10x 
Genomics Visium), a single `assay` named `counts` is used. For molecule-based 
ST data (e.g. seqFISH), two `assays` named `counts` and `molecules` can be used.

Additional details on the class structure are provided in our 
[preprint](https://www.biorxiv.org/content/10.1101/2021.01.27.428431v3).


## Load data

For demonstration of the general class structure, we load an example 
`SpatialExperiment` (abbreviated as SPE) object (variable `spe`):

```{r message = FALSE}
library(SpatialExperiment)
example(read10xVisium, echo = FALSE)
spe
```


## `spatialCoords`

In addition to observation metadata stored inside the `colData` slot, 
the `SpatialExperiment` class stores spatial coordinates as:

- `spatialCoords`, a numeric matrix of spatial coordinates (e.g. `x` and `y`)

`spatialCoords` are stored inside the `int_colData`, and are directly 
accessible via the corresponding accessor:

```{r}
head(spatialCoords(spe))
```

The corresponding column names can be also accessed with `spatialCoordsNames()`:

```{r}
spatialCoordsNames(spe)
```


## `imgData`

All image related data are stored inside the `int_metadata`'s 
`imgData` field as a `DataFrame` of the following structure: 

* each row corresponds to one image for a given sample  
and with a given unique image identifier (e.g. its resolutions)
* for each image, columns specify:
  * which `sample_id` the image belongs to
  * a unique `image_id` in order to accommodate multiple images  
  for a given sample (e.g. of different resolutions)
  * the image's `data` (a `SpatialImage` object)
  * the `scaleFactor` that adjusts pixel positions of the original,  
  full-resolution image to pixel positions in the image

The `imgData()` accessor can be used to retrieve 
the image data stored within the object:

```{r}
imgData(spe)
```


### The `SpatialImage` class

Images are stored inside the `data` field of the `imgData` as a list of 
`SpatialImage`s. Each image may be of one of the following sub-classes:

* `LoadedSpatialImage`
  * represents an image that is fully realized into memory as a `raster` object
  * `@image` contains a `raster` object: a matrix 
  of RGB colors for each pixel in the image
* `StoredSpatialImage`
  * represents an image that is stored in a local file (e.g., as  
  .png, .jpg or .tif), and loaded into memory only on request
  * `@path` specifies a local file from which to retrieve the image
* `RemoteSpatialImage`
  * represents an image that is remotely hosted  
  (under some URL), and retrieved only on request
  * `@url` specifies where to retrieve the image from

A `SpatialImage` can be accessed using `getImg()`, 
or retrieved directly from the `imgData()`:

```{r}
(spi <- getImg(spe))
identical(spi, imgData(spe)$data[[1]])
```

Data available in an object of class `SpatialImage` may be 
accessed via the `imgRaster()` and `imgSource()` accessors:

```{r fig.small = TRUE}
plot(imgRaster(spe))
```


### Adding or removing images

Image entries may be added or removed from a `SpatialExperiment`'s 
`imgData` `DataFrame` using `addImg()` and `rmvImg()`, respectively.

Besides a path or URL to source the image from and a numeric scale factor, 
`addImg()` requires specification of the `sample_id` the new image belongs to, 
and an `image_id` that is not yet in use for that sample:

```{r fig.small = TRUE, eval = TRUE}
url <- "https://i.redd.it/3pw5uah7xo041.jpg"
spe <- addImg(spe, 
    sample_id = "section1", 
    image_id = "pomeranian",
    imageSource = url, 
    scaleFactor = NA_real_, 
    load = TRUE)
img <- imgRaster(spe, 
    sample_id = "section1", 
    image_id = "pomeranian")
plot(img)
```

The `rmvImg()` function is more flexible in the specification 
of the `sample_id` and `image_id` arguments. Specifically:

- `TRUE` is equivalent to *all*, e.g.  
`sample_id = "<sample>"`, `image_id = TRUE`  
will drop all images for a given sample
- `NULL` defaults to the first entry available, e.g.  
`sample_id = "<sample>"`, `image_id = NULL`  
will drop the first image for a given sample

For example, `sample_id = TRUE`, `image_id = TRUE` will specify all images; 
`sample_id = NULL`, `image_id = NULL` corresponds to the first image entry in the `imgData`; 
`sample_id = TRUE`, `image_id = NULL` equals the first image for all samples; and 
`sample_id = NULL`, `image_id = TRUE` matches all images for the first sample.

Here, we remove `section1`'s `pomeranian` image added in the previous 
code chunk; the image is now completely gone from the `imgData`:

```{r}
imgData(spe <- rmvImg(spe, "section1", "pomeranian"))
```


# Object construction

## Manually

The `SpatialExperiment` constructor provides several arguments 
to give maximum flexibility to the user.

In particular, these include: 

- `spatialCoords`, a numeric `matrix` containing spatial coordinates
- `spatialCoordsNames`, a character vector specifying which  
`colData` fields correspond to spatial coordinates

`spatialCoords` can be supplied via `colData`
by specifying the column names that correspond to spatial coordinates 
with `spatialCoordsNames`:

```{r}
n <- length(z <- letters)
y <- matrix(nrow = n, ncol = n)
cd <- DataFrame(x = seq(n), y = seq(n), z)

spe1 <- SpatialExperiment(
    assay = y, 
    colData = cd, 
    spatialCoordsNames = c("x", "y"))
```

Alternatively, `spatialCoords` may be supplied separately
as a `matrix`, e.g.:

```{r}
xy <- as.matrix(cd[, c("x", "y")])

spe2 <- SpatialExperiment(
    assay = y, 
    colData = cd["z"], 
    spatialCoords = xy)
```

Importantly, both of the above `SpatialExperiment()` function calls 
lead to construction of the exact same object:

```{r}
identical(spe1, spe2)
```

Finally, `spatialCoords(Names)` are optional, i.e., 
we can construct a SPE using only a subset of the above arguments:

```{r}
spe <- SpatialExperiment(
    assays = y)
isEmpty(spatialCoords(spe))
```

In general, `spatialCoordsNames` takes precedence over `spatialCoords`,
i.e., if both are supplied, the latter will be ignored. In other words,
`spatialCoords` are preferentially extracted from the `DataFrame`
provided via `colData`. E.g., in the following function call, 
`spatialCoords` will be ignored, and xy-coordinates are instead extracted
from the input `colData` according to the specified `spatialCoordsNames`. 
In this case, a message is also provided:

```{r results = "hide"}
n <- 10; m <- 20
y <- matrix(nrow = n, ncol = m)
cd <- DataFrame(x = seq(m), y = seq(m))
xy <- matrix(nrow = m, ncol = 2)
colnames(xy) <- c("x", "y")

SpatialExperiment(
    assay = y, 
    colData = cd,
    spatialCoordsNames = c("x", "y"),
    spatialCoords = xy)
```


## Spot-based

When working with spot-based ST data, such as *10x Genomics Visium* or other 
platforms providing images, it is possible to store the image information 
in the dedicated `imgData` structure.

Also, the `SpatialExperiment` class stores a `sample_id` value in the
`colData` structure, which is possible to set with the `sample_id` 
argument (default is "sample_01").

Here we show how to load the default *Space Ranger* data files from a 
10x Genomics Visium experiment, and build a `SpatialExperiment` object.

In particular, the `readImgData()` function is used to build an `imgData`
`DataFrame` to be passed to the `SpatialExperiment` constructor.
The `sample_id` used to build the `imgData` object must be the same one 
used to build the `SpatialExperiment` object, otherwise an error is returned.

```{r}
dir <- system.file(
   file.path("extdata", "10xVisium", "section1", "outs"),
   package = "SpatialExperiment")

# read in counts
fnm <- file.path(dir, "raw_feature_bc_matrix")
sce <- DropletUtils::read10xCounts(fnm)

# read in image data
img <- readImgData(
    path = file.path(dir, "spatial"),
    sample_id = "foo")

# read in spatial coordinates
fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
xyz <- read.csv(fnm, header = FALSE,
    col.names = c(
        "barcode", "in_tissue", "array_row", "array_col",
        "pxl_row_in_fullres", "pxl_col_in_fullres"))

# construct observation & feature metadata
rd <- S4Vectors::DataFrame(
    symbol = rowData(sce)$Symbol)

# construct 'SpatialExperiment'
(spe <- SpatialExperiment(
    assays = list(counts = assay(sce)),
    rowData = rd, 
    colData = DataFrame(xyz), 
    spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
    imgData = img,
    sample_id = "foo"))
```

Alternatively, the `read10xVisium()` function facilitates the import of 
*10x Genomics Visium* data to handle one or more samples organized in
folders reflecting the default *Space Ranger* folder tree organization, 
as illustrated below (where "raw/filtered" refers to either "raw" or 
"filtered" to match the `data` argument). Note that the base directory 
"outs/" from Space Ranger can either be included manually in the paths 
provided in the `samples` argument, or can be ignored; if ignored, it will 
be added automatically. The `.h5` files are used if `type = "HDF5"`. (Note 
that `tissue_positions.csv` was renamed in Space Ranger v2.0.0.)

```{bash, eval = FALSE}
sample
 . | — outs
 · · | — raw/filtered_feature_bc_matrix.h5
 · · | — raw/filtered_feature_bc_matrix
 · · · | — barcodes.tsv.gz
 · · · | — features.tsv.gz
 · · · | — matrix.mtx.gz
 · · | — spatial
 · · · | — scalefactors_json.json
 · · · | — tissue_lowres_image.png
 · · · | — tissue_positions.csv
```

Using `read10xVisium()`, the above code to construct the same SPE is reduced to:

```{r}
dir <- system.file(
    file.path("extdata", "10xVisium"),
    package = "SpatialExperiment")

sample_ids <- c("section1", "section2")
samples <- file.path(dir, sample_ids, "outs")

(spe10x <- read10xVisium(samples, sample_ids,
    type = "sparse", data = "raw",
    images = "lowres", load = FALSE))
```

Or alternatively, omitting the base directory `outs/` from Space Ranger:

```{r}
samples2 <- file.path(dir, sample_ids)

(spe10x2 <- read10xVisium(samples2, sample_ids,
    type = "sparse", data = "raw",
    images = "lowres", load = FALSE))
```


## Molecule-based

To demonstrate how to accommodate molecule-based ST data 
(e.g. *seqFISH* platform) inside a `SpatialExperiment` object, 
we generate some mock data of 1000 molecule coordinates across 
50 genes and 20 cells. These should be formatted into a `data.frame` 
where each row corresponds to a molecule, and columns specify the 
xy-positions as well as which gene/cell the molecule has been assigned to: 

```{r message = FALSE, warning = FALSE}
n <- 1e3  # number of molecules
ng <- 50  # number of genes
nc <- 20  # number of cells
# sample xy-coordinates in [0, 1]
x <- runif(n)
y <- runif(n)
# assign each molecule to some gene-cell pair
gs <- paste0("gene", seq(ng))
cs <- paste0("cell", seq(nc))
gene <- sample(gs, n, TRUE)
cell <- sample(cs, n, TRUE)
# assure gene & cell are factors so that
# missing observations aren't dropped
gene <- factor(gene, gs)
cell <- factor(cell, cs)
# construct data.frame of molecule coordinates
df <- data.frame(gene, cell, x, y)
head(df)
```

Next, it is possible to re-shape the above table into a 
`r BiocStyle::Biocpkg("BumpyMatrix")` using `splitAsBumpyMatrix()`, which takes 
as input the xy-coordinates, as well as arguments specifying the row and column 
index of each observation:

```{r message = FALSE, warning = FALSE}
# construct 'BumpyMatrix'
library(BumpyMatrix)
mol <- splitAsBumpyMatrix(
    df[, c("x", "y")], 
    row = gene, col = cell)
```

Finally, it is possible to construct a `SpatialExperiment` object with two data 
slots: 

- The `counts` assay stores the number of molecules per gene and cell  
(equivalent to transcript counts in spot-based data)
- The `molecules` assay holds the spatial molecule positions (xy-coordinates)

Each entry in the `molecules` assay is a `DFrame` that contains the positions 
of all molecules from a given gene that have been assigned to a given cell. 

```{r message = FALSE, warning = FALSE}
# get count matrix
y <- with(df, table(gene, cell))
y <- as.matrix(unclass(y))
y[1:5, 1:5]
# construct SpatialExperiment
spe <- SpatialExperiment(
    assays = list(
        counts = y, 
        molecules = mol))
spe
```

The `BumpyMatrix` of molecule locations can be accessed 
using the dedicated `molecules()` accessor:

```{r message = FALSE, warning = FALSE}
molecules(spe)
```


# Common operations

## Subsetting

Subsetting objects is automatically defined to synchronize across 
all attributes, as for any other Bioconductor *Experiment* class.

For example, it is possible to `subset` by `sample_id` as follows:

```{r}
sub <- spe10x[, spe10x$sample_id == "section1"]
```

Or to retain only observations that map to tissue via:

```{r}
sub <- spe10x[, colData(spe10x)$in_tissue]
sum(colData(spe10x)$in_tissue) == ncol(sub)
```


## Combining samples

To work with multiple samples, the `SpatialExperiment` class provides the `cbind`
method, which assumes unique `sample_id`(s) are provided for each sample.

In case the `sample_id`(s) are duplicated across multiple samples, the `cbind`
method takes care of this by appending indices to create unique sample identifiers.

```{r}
spe1 <- spe2 <- spe
spe3 <- cbind(spe1, spe2)
unique(spe3$sample_id)
```

Alternatively (and preferentially), we can create unique 
`sample_id`(s) prior to `cbind`ing as follows:

```{r}
# make sample identifiers unique
spe1 <- spe2 <- spe
spe1$sample_id <- paste(spe1$sample_id, "A", sep = ".")
spe2$sample_id <- paste(spe2$sample_id, "B", sep = ".")

# combine into single object
spe3 <- cbind(spe1, spe2)
```


## Sample ID replacement

In particular, when trying to replace the `sample_id`(s) of a `SpatialExperiment`
object, these must map uniquely with the already existing ones, otherwise an 
error is returned.

```{r, error=TRUE}
new <- spe3$sample_id
new[1] <- "section2.A"
spe3$sample_id <- new
new[1] <- "third.one.of.two"
spe3$sample_id <- new
```

Importantly, the `sample_id` `colData` field is *protected*, i.e., 
it will be retained upon attempted removal (= replacement by `NULL`):

```{r}
# backup original sample IDs
tmp <- spe$sample_id
# try to remove sample IDs
spe$sample_id <- NULL
# sample IDs remain unchanged
identical(tmp, spe$sample_id)
```


## Image transformations

Both the `SpatialImage` (SpI) and `SpatialExperiment` (SpE) class currently support 
two basic image transformations, namely, rotation (via `rotateImg()`) and 
mirroring (via `mirrorImg()`). Specifically, for a SpI/E `x`:

* `rotateImg(x, degrees)` expects as `degrees` a single numeric in +/-[0,90,...,360].  
Here, a (negative) positive value corresponds to (counter-)clockwise rotation.
* `mirrorImg(x, axis)` expects as `axis` a character string specifying  
whether to mirror horizontally (`"h"`) or vertically (`"v"`).

Here, we apply various transformations using both a SpI (`spi`) and SpE (`spe`)
as input, and compare the resulting images to the original:


### Rotation

```{r}
# extract first image
spi <- getImg(spe10x)
# apply counter-/clockwise rotation
spi1 <- rotateImg(spi, -90)
spi2 <- rotateImg(spi, +90)
# visual comparison
par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))
```

```{r}
# specify sample & image identifier
sid <- "section1"
iid <- "lowres"
# counter-clockwise rotation
tmp <- rotateImg(spe10x, 
    sample_id = sid, 
    image_id = iid,
    degrees = -90)
# visual comparison
par(mfrow = c(1, 2))
plot(imgRaster(spe10x, sid, iid))
plot(imgRaster(tmp, sid, iid))
```


### Mirroring

```{r}
# extract first image
spi <- getImg(spe10x)
# mirror horizontally/vertically
spi1 <- mirrorImg(spi, "h")
spi2 <- mirrorImg(spi, "v")
# visual comparison
par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))
```

```{r}
# specify sample & image identifier
sid <- "section2"
iid <- "lowres"
# mirror horizontally
tmp <- mirrorImg(spe10x, 
    sample_id = sid, 
    image_id = iid,
    axis = "h")
# visual comparison
par(mfrow = c(1, 2))
plot(imgRaster(spe10x, sid, iid))
plot(imgRaster(tmp, sid, iid))
```


# Session Info {.smaller}

```{r tidy = TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show.R
\name{SpatialImage-misc}
\alias{SpatialImage-misc}
\alias{show,VirtualSpatialImage-method}
\title{Miscellaneous \code{SpatialImage} methods}
\usage{
\S4method{show}{VirtualSpatialImage}(object)
}
\arguments{
\item{object}{a \code{SpatialImage} object}
}
\value{
none
}
\description{
Miscellaneous methods for the \code{\link{SpatialImage}} class that do not
fit into any other documentation category such as, for example, show methods.
}
\author{
Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subset.R
\name{SpatialExperiment-subset}
\alias{SpatialExperiment-subset}
\alias{[,SpatialExperiment,ANY,ANY,ANY-method}
\title{Subsetting SpatialExperiment objects}
\arguments{
\item{x}{a \code{\link{SpatialExperiment}} object}

\item{i}{row indices for subsetting}

\item{j}{column indices for subsetting}
}
\value{
a \code{\link{SpatialExperiment}} object
}
\description{
The subsetting method for \code{\link{SpatialExperiment}} objects ensures
that spatial data attributes (\code{\link{spatialCoords}} and
\code{\link{imgData}}) are subsetted correctly to match rows and columns with
the remainder of the object.
}
\section{subset}{

\describe{
\item{\code{[}:}{ subsetting method}
}
}

\examples{
example(read10xVisium)

dim(spe)

set.seed(123)
idx <- sample(ncol(spe), 10)
sub <- spe[, idx]
dim(sub)
colData(sub)
spatialCoords(sub)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readImgData.R
\name{readImgData}
\alias{readImgData}
\title{Read images & scale factors for 10x Genomics Visium}
\usage{
readImgData(
  path = ".",
  sample_id = names(path),
  imageSources = file.path(path, "tissue_lowres_image.png"),
  scaleFactors = file.path(path, "scalefactors_json.json"),
  load = TRUE
)
}
\arguments{
\item{path}{a path where to find one or more images}

\item{sample_id}{the \code{sample_id} for the \code{\link{SpatialExperiment}}
object}

\item{imageSources}{the images source path(s)}

\item{scaleFactors}{the .json file where to find the scale factors}

\item{load}{logical; should the image(s) be loaded into memory
as a \code{grob}? If FALSE, will store the path/URL instead.}
}
\value{
a \code{\link{DataFrame}}
}
\description{
Function to read in images and scale factors for 10x Genomics Visium data,
and return as a valid \code{\link{imgData}} \code{DataFrame}.
}
\examples{
dir <- system.file(
  file.path("extdata", "10xVisium", "section1", "outs", "spatial"),
  package = "SpatialExperiment")

# base directory contains
# - scale factors (scalefactors_json.json)
# - one image (tissue_lowres_image.png)
list.files(dir)

# read in images & scale factors
# as valid 'imgData' 'DFrame'
readImgData(dir, sample_id = "foo")

}
\author{
Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialExperiment-colData.R
\name{SpatialExperiment-colData}
\alias{SpatialExperiment-colData}
\alias{colData}
\alias{colData<-}
\alias{colData<-,SpatialExperiment,DataFrame-method}
\alias{colData<-,SpatialExperiment,NULL-method}
\title{SpatialExperiment colData}
\usage{
\S4method{colData}{SpatialExperiment,DataFrame}(x) <- value

\S4method{colData}{SpatialExperiment,`NULL`}(x) <- value
}
\arguments{
\item{x}{a \code{\link{SpatialExperiment}}}

\item{value}{a \code{\link[S4Vectors]{DataFrame}}}
}
\value{
a \code{\link{SpatialExperiment}} object with updated \code{colData}
}
\description{
The \code{\link{SpatialExperiment}} class provides a modified \code{colData}
setter, which ensures that the \code{SpatialExperiment} object remains valid.
}
\details{
The \code{colData} setter performs several checks to ensure validity. If the
replacement \code{colData} does not contain a \code{sample_id} column, the
existing \code{sample_id}s will be retained. If the replacement
\code{colData} contains \code{sample_id}s, a check is performed to ensure the
number of unique \code{sample_id}s is the same, i.e. a one-to-one mapping is
possible. If the replacement is \code{NULL}, the \code{sample_id}s are
retained. In addition, checks are performed against the \code{sample_id}s in
\code{\link{imgData}}.
}
\examples{
example(read10xVisium)

# empty replacement retains sample identifiers
colData(spe) <- NULL
names(colData(spe))

# replacement of sample identifiers
# requires one-to-one mapping

## invalid replacement

tryCatch(
  spe$sample_id <- seq(ncol(spe)),
  error = function(e) message(e)) 
  
## valid replacement  
  
old <- c("section1", "section2")
new <- c("sample_A", "sample_B")
idx <- match(spe$sample_id, old)

tmp <- spe
tmp$sample_id <- new[idx]
table(spe$sample_id, tmp$sample_id)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read10xVisium.R
\name{read10xVisium}
\alias{read10xVisium}
\title{Load data from a 10x Genomics Visium experiment}
\usage{
read10xVisium(
  samples = "",
  sample_id = paste0("sample", sprintf("\%02d", seq_along(samples))),
  type = c("HDF5", "sparse"),
  data = c("filtered", "raw"),
  images = "lowres",
  load = TRUE
)
}
\arguments{
\item{samples}{a character vector specifying one or more directories, 
each corresponding to a 10x Genomics Visium sample (see Details);
if provided, names will be used as sample identifiers}

\item{sample_id}{character string specifying unique sample identifiers,
one for each directory specified via \code{samples}; 
ignored if \code{!is.null(names(samples))}}

\item{type}{character string specifying 
the type of format to read count data from
(see \code{read10xCounts})}

\item{data}{character string specifying whether to read in
filtered (spots mapped to tissue) or raw data (all spots).}

\item{images}{character vector specifying which images to include. 
Valid values are \code{"lowres", "hires", "fullres", "detected", "aligned"}}

\item{load}{logical; should the image(s) be loaded into memory
as a \code{grob}? If FALSE, will store the path/URL instead.}
}
\value{
a \code{\link{SpatialExperiment}} object
}
\description{
Creates a \code{\link{SpatialExperiment}} from the Space Ranger 
output directories for 10x Genomics Visium spatial gene expression data.
}
\details{
The constructor assumes data from each sample are located 
in a single output directory as returned by Space Ranger, 
thus having the following file organization (where "raw/filtered" 
refers to either "raw" or "filtered" to match the `data` argument.) 
The base directory "outs/" from Space Ranger can either be included 
manually in the paths provided in `samples`, or can be ignored; 
if ignored, it will be added automatically. The `.h5` files are 
used if `type = "HDF5"`. (Note that `tissue_positions.csv` was 
renamed in Space Ranger v2.0.0.)

sample \cr
· | — outs \cr
· · | — raw/filtered_feature_bc_matrix.h5 \cr
· · | — raw/filtered_feature_bc_matrix    \cr
· · · | — barcodes.tsv.gz \cr
· · · | — features.tsv.gz \cr
· · · | — matrix.mtx.gz   \cr
· · | — spatial \cr
· · · | — scalefactors_json.json    \cr
· · · | — tissue_lowres_image.png   \cr
· · · | — tissue_positions.csv \cr
}
\examples{
dir <- system.file(
  file.path("extdata", "10xVisium"), 
  package = "SpatialExperiment")
  
sample_ids <- c("section1", "section2")
samples <- file.path(dir, sample_ids, "outs")
  
list.files(samples[1])
list.files(file.path(samples[1], "spatial"))
file.path(samples[1], "raw_feature_bc_matrix")

(spe <- read10xVisium(samples, sample_ids, 
  type = "sparse", data = "raw", 
  images = "lowres", load = FALSE))

# base directory 'outs/' from Space Ranger can also be omitted
samples2 <- file.path(dir, sample_ids)
(spe2 <- read10xVisium(samples2, sample_ids, 
  type = "sparse", data = "raw", 
  images = "lowres", load = FALSE))

# tabulate number of spots mapped to tissue
cd <- colData(spe)
table(
  in_tissue = cd$in_tissue, 
  sample_id = cd$sample_id)

# view available images
imgData(spe)

}
\author{
Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/SpatialExperiment.R
\docType{class}
\name{SpatialExperiment-class}
\alias{SpatialExperiment-class}
\alias{SpatialExperiment}
\title{The SpatialExperiment class}
\arguments{
\item{...}{Arguments passed to the \code{\link{SingleCellExperiment}}
constructor to fill the slots of the base class.}

\item{sample_id}{A \code{character} sample identifier, which matches the
\code{sample_id} in \code{\link{imgData}}. The \code{sample_id} will also
be stored in a new column in \code{\link{colData}}, if not already present.
Default = \code{sample01}.}

\item{spatialCoordsNames}{A \code{character} vector of column names from
\code{\link{colData}} containing spatial coordinates, which will be
accessible with \code{\link{spatialCoords}}. Alternatively, the
\code{spatialCoords} argument may be provided. If both are provided,
\code{spatialCoordsNames} is given precedence, and a warning is returned.
Default = \code{c("x", "y")}.}

\item{spatialCoords}{A numeric matrix containing columns of spatial
coordinates, which will be accessible with \code{\link{spatialCoords}}.
Alternatively, \code{spatialCoordsNames} may be provided. If both are
provided, \code{spatialCoordsNames} is given precedence, and a warning is
returned.}

\item{scaleFactors}{Optional scale factors associated with the image(s). This
can be provided as a numeric value, numeric vector, list, or file path to a
JSON file for the 10x Genomics Visium platform. For 10x Genomics Visium,
the correct scale factor will automatically be selected depending on the
resolution of the image from \code{imageSources}. Default = \code{1}.}

\item{imgData}{Optional \code{\link{DataFrame}} containing the image data.
Alternatively, this can be built from the arguments \code{imageSources} and
\code{image_id} (see Details).}

\item{imageSources}{Optional file path(s) or URL(s) for one or more image
sources.}

\item{image_id}{Optional character vector (same length as
\code{imageSources}) containing unique image identifiers.}

\item{loadImage}{Logical indicating whether to load image into memory.
Default = \code{FALSE}.}

\item{spatialDataNames}{(Deprecated) A \code{character} vector of column
names from \code{\link{colData}} to include in \code{\link{spatialData}}.
Alternatively, the \code{spatialData} argument may be provided. If both are
provided, \code{spatialDataNames} is given precedence, and a warning is
returned. (Note: \code{spatialData} and \code{spatialDataNames} have been
deprecated; \code{colData} and \code{spatialCoords} should be used for all
columns. The arguments have been retained for backward compatibility but
may be removed in the future.)}

\item{spatialData}{(Deprecated) A \code{\link{DataFrame}} containing columns
to store in \code{\link{spatialData}}, which must contain at least the
columns of spatial coordinates. Alternatively, \code{spatialDataNames} may
be provided. If both are provided, \code{spatialDataNames} is given
precedence, and a warning is returned. (Note: \code{spatialData} and
\code{spatialDataNames} have been deprecated; \code{colData} and
\code{spatialCoords} should be used for all columns. The arguments have
been retained for backward compatibility but may be removed in the future.)}
}
\value{
A \code{SpatialExperiment} object.
}
\description{
The \code{SpatialExperiment} class is designed to represent spatially
resolved transcriptomics (ST) data. It inherits from the
\code{\link{SingleCellExperiment}} class and is used in the same manner. In
addition, the class supports storage of spatial information via
\code{\link{spatialCoords}} and storage of images via \code{\link{imgData}}.
}
\details{
In this class, rows represent genes, and columns represent spots (for
spot-based ST platforms) or cells (for molecule-based ST platforms). As for
\code{\link{SingleCellExperiment}}, \code{counts} and \code{logcounts} can be
stored in the \code{\link{assays}} slot, and row and column metadata in
\code{\link{rowData}} and \code{\link{colData}}. For molecule-based ST data,
the additional measurements per molecule per cell can be stored in a
\code{BumpyMatrix}-formatted \code{assay} named \code{\link{molecules}}.

The additional arguments in the constructor documented above (e.g.
\code{spatialCoords}, \code{imgData}, and others) represent the extensions to
the \code{\link{SingleCellExperiment}} class to store associated spatial and
imaging information for ST data.

The constructor expects \code{colData} to contain a column named
\code{sample_id}. If this is not present, it will assign the value from the
\code{sample_id} argument. If the \code{imgData} argument is provided, the
constructor expects the \code{\link{imgData}} \code{\link{DataFrame}} to
already be built. Otherwise, it will build it from the \code{imageSources}
and (optional) \code{image_id} arguments. If \code{image_id} is not provided,
this will be assumed from \code{sample_id} and \code{imageSources} instead.
To combine multiple samples within a single object, see
\code{\link{combine}}.

For 10x Genomics Visium datasets, the function \code{\link{read10xVisium}}
can be used to load data and create a \code{SpatialExperiment} object
directly from Space Ranger output files.
}
\examples{
#########################################################
# Example 1: Spot-based ST (10x Visium) using constructor
#########################################################

dir <- system.file(
    file.path("extdata", "10xVisium", "section1", "outs"),
    package = "SpatialExperiment")

# read in counts
fnm <- file.path(dir, "raw_feature_bc_matrix")
sce <- DropletUtils::read10xCounts(fnm)

# read in image data
img <- readImgData(
    path = file.path(dir, "spatial"),
    sample_id="foo")

# read in spatial coordinates
fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
xyz <- read.csv(fnm, header = FALSE,
    col.names = c(
        "barcode", "in_tissue", "array_row", "array_col",
        "pxl_row_in_fullres", "pxl_col_in_fullres"))
    
# construct observation & feature metadata
rd <- S4Vectors::DataFrame(
    symbol = rowData(sce)$Symbol)
  
# construct 'SpatialExperiment'
(spe <- SpatialExperiment(
    assays = list(counts = assay(sce)),
    rowData = rd,
    colData = DataFrame(xyz),
    spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
    imgData = img,
    sample_id = "foo"))
    
#############################################################
# Example 2: Spot-based ST (10x Visium) using 'read10xVisium'
#############################################################

# see ?read10xVisium for details
example(read10xVisium)

##############################
# Example 3: Molecule-based ST
##############################

# create simulated data
n <- 1000; ng <- 50; nc <- 20
# sample xy-coordinates in [0,1]
x <- runif(n)
y <- runif(n)
# assign each molecule to some gene-cell pair
gs <- paste0("gene", seq(ng))
cs <- paste0("cell", seq(nc))
gene <- sample(gs, n, TRUE)
cell <- sample(cs, n, TRUE)
# construct data.frame of molecule coordinates
df <- data.frame(gene, cell, x, y)

# (assure gene & cell are factor so that
# missing observations aren't dropped)
df$gene <- factor(df$gene, gs)
df$cell <- factor(df$cell, cs)

# construct BumpyMatrix
mol <- BumpyMatrix::splitAsBumpyMatrix(
    df[, c("x", "y")],
    row = df$gene, column = df$cell)

# get count matrix
y <- with(df, table(gene, cell))
y <- as.matrix(unclass(y))

# construct SpatialExperiment
(spe_mol <- SpatialExperiment(
    assays = list(
        counts = y, 
        molecules = mol)))
}
\seealso{
\code{?"\link{SpatialExperiment-methods}"}, which includes:
\code{\link{spatialCoords}}, \code{\link{spatialCoordsNames}},
\code{\link{imgData}}, \code{\link{scaleFactors}}

\code{?"\link{SpatialExperiment-assays}"}, which includes:
\code{\link{molecules}}

\code{?"\link{SpatialExperiment-colData}"}

\code{?"\link{SpatialExperiment-combine}"}

\code{?"\link{SpatialExperiment-subset}"}

\code{?"\link{SpatialExperiment-misc}"}

\code{\link{readImgData}}

\code{?"\link{imgData-methods}"}

\code{\link{SpatialImage}}

\code{\link{read10xVisium}}
}
\author{
Dario Righelli and Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/imgData-methods.R
\name{imgData-methods}
\alias{imgData-methods}
\alias{getImg}
\alias{addImg}
\alias{rmvImg}
\alias{getImg,SpatialExperiment-method}
\alias{addImg,SpatialExperiment-method}
\alias{rmvImg,SpatialExperiment-method}
\alias{imgRaster,SpatialExperiment-method}
\alias{imgSource,SpatialExperiment-method}
\alias{rotateImg,SpatialExperiment-method}
\alias{mirrorImg,SpatialExperiment-method}
\title{Methods for handling image-related data}
\usage{
\S4method{getImg}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL)

\S4method{addImg}{SpatialExperiment}(x, imageSource, scaleFactor, sample_id, image_id, load = TRUE)

\S4method{rmvImg}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL)

\S4method{imgSource}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL, path = FALSE)

\S4method{imgRaster}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL)

\S4method{rotateImg}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL, degrees = 90)

\S4method{mirrorImg}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL, axis = c("h", "v"))
}
\arguments{
\item{x}{a \code{\link{SpatialExperiment}}}

\item{sample_id}{character string, \code{TRUE} or \code{NULL} specifying 
sample/image identifier(s); here, \code{TRUE} is equivalent to all 
samples/images and \code{NULL} specifies the first available entry (see details)}

\item{image_id}{see \code{sample_id}}

\item{imageSource}{a character string specifying an image file name 
(.png, .jpg or .tif) or URL to source the image from}

\item{scaleFactor}{single numeric scale factor used to rescale spatial 
coordinates according to the image's resolution}

\item{load}{logical; should the image(s) be 
loaded into memory as a \code{raster} object?
if \code{FALSE}, will store the path/URL instead}

\item{path}{logical; for \code{RemoteSpatialImage}s, TRUE 
returns the path to the image's cached file, and FALSE its URL. 
For \code{Stored/LoadedSpatialImage}s, a path/NA is returned, 
irrespective of \code{path}.}

\item{degrees}{single numeric 
in +/-[0,90,...,360] specifying how many degrees to rotate.
A negative/positive value corresponds to counter-/clockwise rotation}

\item{axis}{character string specifying whether to mirror 
horizontally (\code{"h"}) or vertically (\code{"v"})}
}
\value{
\code{getImg()} returns a single or list of \code{SpatialImage}(s).

\code{add/rmvImg()} return a \code{\link{SpatialExperiment}} 
with modified \code{imgData}; specifically, they create/remove 
an image entry (row) in the \code{imgData} \code{DataFrame}.

\code{imgRaster/Source()} access relevant data in the 
\code{SpatialImage}(s) stored inside the \code{imgData}'s \code{data} 
field. Depending on whether or not multiple entries are accessed,
a character string or vector is returned by \code{imgSource()}, and a 
single or list of \code{raster} object(s) is returned by \code{imgRaster()}.

\code{rotate/mirrorImg()} return a \code{Loaded\link{SpatialImage}}
with modified a \code{raster} matrix.
}
\description{
The set of functions described below is designed to handle 
the image-related data stored inside a \code{SpatialExperiment}'s 
\code{imgData} \code{int_metadata} field. These include:

\itemize{
\item \code{getImg}, \code{addImg}, \code{rmvImg}
  to retrieve/add/remove an image entry to/from 
  the \code{imgData} \code{DataFrame}
\item \code{imgSource}, \code{imgRaster}
  to retrieve the path/URL and \code{raster} object,
  respectively, associated with an image or set of images
}
}
\examples{
example(read10xVisium)

# 'SpatialImage' accession
(spi <- getImg(spe))
plot(imgRaster(spi))

# remove an image
imgData(spe)
spe <- rmvImg(spe,
  sample_id = "section1",
  image_id = "lowres")
imgData(spe)

# add an image
url <- "https://i.redd.it/3pw5uah7xo041.jpg"
spe <- addImg(spe,
  sample_id = "section1",
  image_id = "pomeranian",
  imageSource = url,
  scaleFactor = NA_real_,
  load = FALSE)

# extract image
img <- imgRaster(spe,
  sample_id = "section1",
  image_id = "pomeranian")
plot(img)

###################
# transformations #
###################

# clockwise rotation
spe1 <- rotateImg(spe, 
  degrees = 90) # first image
  
spe2 <- rotateImg(spe, 
  sample_id = TRUE,
  image_id = TRUE, 
  degrees = 90) # all images

par(mfrow = c(1, 3))
plot(imgRaster(spe))
plot(imgRaster(spe1))
plot(imgRaster(spe2))

# horizontal/vertical mirroring
spe1 <- mirrorImg(spe, axis = "h")
spe2 <- mirrorImg(spe, axis = "v")

par(mfrow = c(1, 3))
plot(imgRaster(spe))
plot(imgRaster(spe1))
plot(imgRaster(spe2))
  
}
\author{
Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialExperiment-combine.R
\name{SpatialExperiment-combine}
\alias{SpatialExperiment-combine}
\alias{cbind,SingleCellExperiment-method}
\alias{cbind,SpatialExperiment-method}
\title{Combining SpatialExperiment objects}
\usage{
\S4method{cbind}{SpatialExperiment}(..., deparse.level = 1)
}
\arguments{
\item{...}{a list of \code{\link{SpatialExperiment}} objects}

\item{deparse.level}{refer to \code{?\link[base]{rbind}}}
}
\value{
a combined \code{\link{SpatialExperiment}} object
}
\description{
The \code{\link{SpatialExperiment}} class provides modified methods to
combine multiple \code{SpatialExperiment} objects by column, for example from
multiple samples. These methods ensure that all data fields remain
synchronized when samples are added or removed.
}
\section{Combining}{

The \code{...} argument is assumed to contain one or more
\code{\link{SpatialExperiment}} objects.

\describe{
\item{\code{cbind(..., deparse.level=1)}:}{ 
Returns a \code{SpatialExperiment} where all objects in \code{...} are
combined column-wise, i.e., columns in successive objects are appended to the
first object.

Each \code{SpatialExperiment} object in \code{...} must have the same
\code{colData} (with the same \code{\link{spatialCoords}}). If multiple
objects use the same \code{sample_id}, the method will proceed by assigning
unique \code{sample_id}s.

Additionally, the method combines \code{imgData} by row using \code{rbind}.

Refer to \code{?"\link{cbind,SingleCellExperiment-method}"} for details on
how metadata and other inherited attributes are combined in the output
object.

Refer to \code{?\link[base]{cbind}} for the interpretation of
\code{deparse.level}.
}
}
}

\examples{
example(read10xVisium, echo = FALSE)

# merging with duplicated 'sample_id's
# will automatically assign unique identifiers
spe1 <- spe2 <- spe
spe3 <- cbind(spe1, spe2)
unique(spe3$sample_id)

# assign unique sample identifiers
spe1 <- spe2 <- spe
spe1$sample_id <- paste(spe1$sample_id, "sample1", sep = ".")
spe2$sample_id <- paste(spe2$sample_id, "sample2", sep = ".")

# combine into single object
spe <- cbind(spe1, spe2)

# view joint 'imgData'
imgData(spe)

# tabulate number of spots mapped to tissue
cd <- colData(spe)
table(
  in_tissue = cd$in_tissue, 
  sample_id = cd$sample_id)
}
\author{
Dario Righelli
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialExperiment-rotate-mirror.R
\name{SpatialExperiment-rotate-mirror}
\alias{SpatialExperiment-rotate-mirror}
\alias{rotateCoords}
\alias{mirrorCoords}
\alias{rotateObject}
\alias{mirrorObject}
\alias{rotateCoords,SpatialExperiment-method}
\alias{mirrorCoords,SpatialExperiment-method}
\alias{rotateObject,SpatialExperiment-method}
\alias{mirrorObject,SpatialExperiment-method}
\title{Methods for spatial attributes}
\usage{
\S4method{rotateCoords}{SpatialExperiment}(x, sample_id = NULL, degrees = 90, warn = TRUE)

\S4method{mirrorCoords}{SpatialExperiment}(x, sample_id = NULL, axis = c("h", "v"), warn = TRUE)

\S4method{rotateObject}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL, degrees = 90)

\S4method{mirrorObject}{SpatialExperiment}(x, sample_id = NULL, image_id = NULL, axis = c("h", "v"))
}
\arguments{
\item{x}{A \code{\link{SpatialExperiment}} object.}

\item{sample_id}{Logical value or character vector specifying sample
identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all samples).}

\item{degrees}{single numeric 
in +/-[0,90,...,360] specifying how many degrees to rotate.
A negative/positive value corresponds to counter-/clockwise rotation.
Applicable for \code{rotateCoords} and \code{rotateObject} methods.}

\item{warn}{Logical value indicating whether to print a warning about
mismatches between coordinates and images, possible with the spatialCoords
transformation methods \code{rotateCoords} and \code{mirrorCoords}.}

\item{axis}{character string specifying whether to mirror 
horizontally (\code{"h"}) or vertically (\code{"v"}). Applicable for
\code{mirrorCoords} and \code{mirrorObject} methods.}

\item{image_id}{Logical value or character vector specifying image
identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all images).}
}
\value{
Return value varies depending on method, as described below.
}
\description{
The \code{\link{SpatialExperiment}} class provides methods to rotate and
mirror \code{\link{SpatialExperiment}} objects and their
\code{spatialCoords}.
}
\details{
Additional details for each type of data attribute are provided below.
}
\section{spatialCoords transformation methods}{

\describe{
\item{\code{rotateCoords(x, sample_id, degrees, warn)}: }{
  Apply a rotation to the \code{spatialCoords} of \code{x}, potentially
  subsetted to sample \code{sample_id} (or without subsetting if
  \code{sample_id} is \code{NULL}), by the specified number of \code{degrees}
  clockwise. Warn about mismatches with images if \code{warn}.}
\item{\code{mirrorCoords(x, sample_id, axis, warn)}: }{
  Reflect the \code{spatialCoords} of \code{x} across either the horizontal
  or vertical axis, specified by supplying "h" or "v" to the \code{axis}
  argument, respectively. Subset \code{x} to just the sample
  \code{sample_id}, if not \code{NULL}. Warn about mismatches with images if
  \code{warn}.}
}
}

\section{SpatialExperiment transformation wrapper methods}{

\describe{
\item{\code{rotateObject(x, sample_id, image_id, degrees)}: }{
  Apply a rotation to the \code{\link{spatialCoords}} and
  \code{\link{imgData}} of
  \code{x}, potentially subsetted to sample \code{sample_id} (or without
  subsetting if \code{sample_id} is \code{NULL}), by the specified number of
  \code{degrees} clockwise. Wrapper around \code{rotateCoords} and
  \code{rotateImg}.}
\item{\code{mirrorObject(x, sample_id, image_id, axis)}: }{
  Reflect the \code{\link{spatialCoords}} and \code{\link{imgData}} of \code{x} across
  either the horizontal or vertical axis, specified by supplying "h" or "v"
  to the \code{axis} argument, respectively. Subset \code{x} to just the
  sample \code{sample_id}, if not \code{NULL}. Wrapper around
  \code{mirrorCoords} and \code{mirrorImg}.}
}
}

\examples{
example(read10xVisium)

# rotateCoords(), mirrorCoords(), rotateObject(), and mirrorObject() return a
# SpatialExperiment, potentially subsetted by sample.

# Subset to just "section1"; rotate coordinates 90 degrees clockwise followed
# by a reflection across the vertical axis
spe_coords <- rotateCoords(spe, sample_id = "section1", degrees = 90)
spe_coords <- mirrorCoords(spe_coords, axis = "v")

# Subset to just "section2"; transform both the imgData() and spatialCoords()
# by a 180-degree rotation then reflection across the vertical axis
spe_wrapper <- rotateObject(spe, sample_id = "section2", degrees = 180)
spe_wrapper <- mirrorObject(spe_wrapper, axis = "v")
}
\author{
Nicholas J. Eagles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialExperiment-assays.R
\name{SpatialExperiment-assays}
\alias{SpatialExperiment-assays}
\alias{molecules}
\alias{molecules<-}
\alias{molecules,SpatialExperiment-method}
\alias{molecules<-,SpatialExperiment-method}
\title{Methods for named assays}
\description{
The \code{\link{SpatialExperiment}} class provides methods for getting or
setting named \code{\link{assays}}. For example, \code{molecules(spe)} will
get or set an \code{assay} named \code{molecules} from object \code{spe},
equivalent to \code{assay(spe, i = "molecules")}. This provides a convenient
interface for users and encourages standardization of assay names across
packages.
}
\section{Available methods}{

In the following code, \code{spe} is a \code{\link{SpatialExperiment}}
object, \code{value} is a \code{BumpyMatrix}-like object with the same
dimensions as \code{spe}, and \code{...} are further arguments passed to
\code{\link{assay}} (for the getter) or \code{\link{assay<-}} (for the
setter).

\describe{
\item{\code{molecules(x, ...)}, \code{molecules(x, ...) <- value}:}{
Get or set an assay named \code{molecules}, which is usually assumed to be a
\code{BumpyMatrix}-formatted object containing spatial coordinates (and any
other information) of the individual molecules per gene per cell.
}
}
}

\examples{
example(SpatialExperiment)
molecules(spe_mol)
}
\seealso{
\code{\link{assay}} and \code{\link{assay<-}}
}
\author{
Dario Righelli
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialImage.R
\name{SpatialImage-class}
\alias{SpatialImage-class}
\alias{SpatialImage}
\alias{VirtualSpatialImage-class}
\alias{LoadedSpatialImage-class}
\alias{StoredSpatialImage-class}
\alias{RemoteSpatialImage-class}
\alias{dim,VirtualSpatialImage-method}
\alias{dim,StoredSpatialImage-method}
\alias{imgRaster}
\alias{imgRaster,LoadedSpatialImage-method}
\alias{imgRaster,StoredSpatialImage-method}
\alias{imgRaster,RemoteSpatialImage-method}
\alias{imgRaster<-}
\alias{imgRaster<-,LoadedSpatialImage-method}
\alias{imgSource}
\alias{imgSource,LoadedSpatialImage-method}
\alias{imgSource,StoredSpatialImage-method}
\alias{imgSource,RemoteSpatialImage-method}
\alias{imgSource<-}
\alias{imgSource<-,StoredSpatialImage,character-method}
\alias{imgSource<-,RemoteSpatialImage,character-method}
\alias{coerce,VirtualSpatialImage,LoadedSpatialImage-method}
\alias{coerce,RemoteSpatialImage,StoredSpatialImage-method}
\alias{rotateImg}
\alias{rotateImg,VirtualSpatialImage-method}
\alias{rotateImg,LoadedSpatialImage-method}
\alias{mirrorImg}
\alias{mirrorImg,VirtualSpatialImage-method}
\alias{mirrorImg,LoadedSpatialImage-method}
\title{The \code{SpatialImage} class}
\description{
The \code{SpatialImage} class hierarchy provides representations of images
from a variety of sources. It is used by the \linkS4class{SpatialExperiment}
class to manage the loading of images across multiple studies.
}
\section{Constructor}{

\code{SpatialImage(x, is.url)} will return a \code{SpatialImage} object.
The class of the object depends on the type of \code{x}:
\itemize{
\item If \code{x} is a raster object, a \code{LoadedSpatialImage} is 
  returned. This represents an image that is fully realized into memory, 
  where the raster representation is stored inside the output object.
\item If \code{x} is a string and \code{is.url=TRUE} or it starts with 
  \code{"http://"}, \code{"http://"} or \code{"ftp://"}, 
  a \code{RemoteSpatialImage} is returned. This represents an image 
  that is remotely hosted and retrieved only on request.
\item If \code{x} is a string and \code{is.url=TRUE} or it does not 
  start with a URL-like prefix, a \code{StoredSpatialImage} is returned.
  This represents an image that is stored in a local file 
  and is loaded into memory only on request.
}
}

\section{Getting the raster image}{

For a \code{SpatialImage} object \code{x}, \code{imgRaster(x, ...)} 
will return a raster object (see \code{?\link{as.raster}}).
This is effectively a matrix of RGB colors for each pixel in the image.

For a \code{StoredSpatialImage} object \code{x}, additional arguments 
in \code{...} are passed to \code{\link{image_read}}.
This controls how the image is read into memory.

For a \code{RemoteSpatialImage} object \code{x}, the image file is first
downloaded before the raster is returned. Here, \code{...} may contain an
extra \code{cache} argument, which should be a \code{BiocFileCache} object 
(from the \pkg{BiocFileCache} package) specifying the file cache location. 
The default location is determined by 
\code{options("SpatialExperiment.remote.cache.path")},
otherwise it defaults to a subdirectory in the R temporary directory.
Any further named arguments in \code{...} are passed to \code{image_read}.

\code{as.raster(x, ...)} is the same as \code{imgRaster(x, ...)}.
}

\section{In-memory caching}{

For \code{StoredSpatialImage} and \code{RemoteSpatialImage} objects, 
loading the image with \code{imgRaster} will automatically 
store the loaded raster object in an in-memory cache.
Any subsequent \code{imgRaster} call will retrieve the raster 
from the cache, avoiding costly retrieval from the file system.

The cache policy is to evict the least recently used images when 
a new image would be added that exceeds the maximum cache size.
If the new image by itself exceeds the maximum cache size, all images are 
evicted from the cache to trigger garbage collection and free up memory.

By default, the maximum size of the cache is 4 GB. This can be 
modified by setting \code{options("SpatialExperiment.cache.size")} 
to some number of bytes, e.g., \code{2^32}.
}

\section{Transformations}{

Two basic image transformations are currently 
supported for any \code{SpatialImage} \code{x}, namely,
\code{rotateImg(x, degrees)} for clockwise (\code{degrees > 0}) and 
counter-clockwise (\code{degrees < 0}) rotation, and 
\code{mirrorImg(x, axis)} for horizontal (\code{axis = "h"}) and 
vertical (\code{axis = "v"}) mirroring.

Note that, both \code{rotateImg()} and \code{mirrorImg()} operate
on the \code{raster} matrix of the input \code{SpatialImage}. 
Thus, any \code{SpatialImage} will automatically be coerced 
into a \code{LoadedSpatialImage} upon rotation/mirroring.
}

\section{Other methods}{

\code{dim(x)} will return an integer vector of length 2, 
containing the width and height of the image in pixels.
Note that this calls \code{imgRaster} under the hood and thus 
may interact with the file and memory caches as described above.

For any \code{SpatialImage x}, \code{as(x, "LoadedSpatialImage")} will
create a \code{LoadedSpatialImage} containing an in-memory raster object.

For a \code{RemoteSpatialImage x}, \code{as(x, "StoredSpatialImage")} will
create a \code{StoredSpatialImage} pointing to the file cache location.
}

\examples{
path <- system.file(
  "extdata", "10xVisium", "section1", "outs", "spatial", 
  "tissue_lowres_image.png", package="SpatialExperiment")

spi <- SpatialImage(path)
plot(imgRaster(spi))

# the following operations all use the cache 
# so there is no need to reload the image
nrow(spi)
ncol(spi)
plot(as.raster(spi)) 

# coercing to an explicitly in-memory raster
spi <- as(spi, "LoadedSpatialImage")
plot(as.raster(spi))

###################
# transformations #
###################

# (counter-)clockwise rotation
spi1 <- rotateImg(spi, degrees = +90)
spi2 <- rotateImg(spi, degrees = -90)

par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))

# horizontal/vertical mirroring
spi1 <- mirrorImg(spi, axis = "h")
spi2 <- mirrorImg(spi, axis = "v")

par(mfrow = c(1, 3))
plot(as.raster(spi))
plot(as.raster(spi1))
plot(as.raster(spi2))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SpatialExperiment-methods.R, R/imgData.R
\name{SpatialExperiment-methods}
\alias{SpatialExperiment-methods}
\alias{spatialData}
\alias{spatialData<-}
\alias{spatialDataNames}
\alias{spatialDataNames<-}
\alias{spatialCoords}
\alias{spatialCoords<-}
\alias{spatialCoordsNames}
\alias{spatialCoordsNames<-}
\alias{imgData}
\alias{imgData<-}
\alias{scaleFactors}
\alias{spatialData,SpatialExperiment-method}
\alias{spatialData<-,SpatialExperiment,DFrame-method}
\alias{spatialData<-,SpatialExperiment,NULL-method}
\alias{spatialDataNames,SpatialExperiment-method}
\alias{spatialDataNames<-,SpatialExperiment,character-method}
\alias{spatialDataNames<-,SpatialExperiment,NULL-method}
\alias{spatialCoords,SpatialExperiment-method}
\alias{spatialCoords<-,SpatialExperiment,matrix-method}
\alias{spatialCoords<-,SpatialExperiment,NULL-method}
\alias{spatialCoordsNames,SpatialExperiment-method}
\alias{spatialCoordsNames<-,SpatialExperiment,character-method}
\alias{spatialCoordsNames<-,SpatialExperiment,NULL-method}
\alias{scaleFactors,SpatialExperiment-method}
\alias{$,SpatialExperiment-method}
\alias{imgData,SpatialExperiment-method}
\alias{imgData<-,SpatialExperiment,DataFrame-method}
\alias{imgData<-,SpatialExperiment,NULL-method}
\title{Methods for spatial attributes}
\usage{
\S4method{spatialData}{SpatialExperiment}(x)

\S4method{spatialData}{SpatialExperiment,DFrame}(x) <- value

\S4method{spatialData}{SpatialExperiment,`NULL`}(x) <- value

\S4method{spatialDataNames}{SpatialExperiment}(x)

\S4method{spatialDataNames}{SpatialExperiment,character}(x) <- value

\S4method{spatialDataNames}{SpatialExperiment,`NULL`}(x) <- value

\S4method{spatialCoords}{SpatialExperiment}(x)

\S4method{spatialCoords}{SpatialExperiment,matrix}(x) <- value

\S4method{spatialCoords}{SpatialExperiment,`NULL`}(x) <- value

\S4method{spatialCoordsNames}{SpatialExperiment}(x)

\S4method{spatialCoordsNames}{SpatialExperiment,character}(x) <- value

\S4method{spatialCoordsNames}{SpatialExperiment,`NULL`}(x) <- value

\S4method{scaleFactors}{SpatialExperiment}(x, sample_id = TRUE, image_id = TRUE)

\S4method{$}{SpatialExperiment}(x, name)

\S4method{imgData}{SpatialExperiment}(x)

\S4method{imgData}{SpatialExperiment,DataFrame}(x) <- value

\S4method{imgData}{SpatialExperiment,`NULL`}(x) <- value
}
\arguments{
\item{x}{A \code{\link{SpatialExperiment}} object.}

\item{value}{Replacement value for replacement methods.}

\item{sample_id}{Logical value or character vector specifying sample
identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all samples).}

\item{image_id}{Logical value or character vector specifying image
identifier(s) for \code{scaleFactors}. Default = \code{TRUE} (all images).}

\item{name}{The name of the \code{colData} column to extract.}
}
\value{
Return value varies depending on method, as described below.
}
\description{
The \code{\link{SpatialExperiment}} class provides a family of methods to get
and set spatial data attributes in \code{\link{SpatialExperiment}} objects.
Spatial attributes include \code{spatialCoords}, \code{imgData}, and
\code{scaleFactors}, as well as methods to rotate and mirror
SpatialExperiment objects and their spatial coordinates.
}
\details{
Additional details for each type of data attribute are provided below.

Note: \code{\link{spatialData}} and \code{\link{spatialDataNames}}
(previously used to store a subset of columns from \code{\link{colData}})
have been deprecated. All columns should be stored in either
\code{\link{spatialCoords}} (numeric matrix containing spatial coordinates)
or \code{\link{colData}} (all other columns). The
\code{spatialData}/\code{spatialDataNames} functionality has been retained
for backward compatibility but may be removed in the future.

See \code{\link{rotateCoords}}, \code{\link{mirrorCoords}},
\code{\link{rotateObject}}, or \code{\link{mirrorObject}} for details on
methods to rotate and mirror SpatialExperiment objects and their
\code{spatialCoords}.
}
\section{spatialData and spatialCoords methods}{

\describe{
\item{\code{spatialData(x) <- value}: }{
  The \code{spatialData} setter expects a \code{DataFrame}. 
  If the input does not contain an \code{in_tissue} column, 
  this will be included with a default value of \code{1}.}
\item{\code{spatialCoords(x)}: }{
  Getter for numeric matrix of spatial coordinates.}
\item{\code{spatialCoords(x) <- value}: }{
  Setter for numeric matrix of spatial coordinates.}
}
}

\section{spatialDataNames and spatialCoordsNames methods}{

\describe{
\item{\code{spatialDataNames(x)}: }{
  Returns the names of the \code{colData} associated with the 
  spatial information, which are stored in the \code{int_metadata}.}
\item{\code{spatialDataNames(x) <- value}: }{
  Setter to replace column names
  in the \code{spatialData} \code{DataFrame}.}
\item{\code{spatialCoordsNames(x)}: }{
  Returns the defined names of the
  spatial coordinates (e.g. \code{c("x", "y")}).}
\item{\code{spatialCoordsNames(x) <- value}: }{
  Setter to define the names of the spatial coordinate columns.}
}
}

\section{imgData methods}{

\describe{
\item{\code{imgData(x)}: }{
  Getter to return the \code{imgData} \code{DataFrame}.}
\item{\code{imgData(x) <- value}: }{
  Setter to provide a \code{DataFrame} object as 
  \code{imgData} of the \code{SpatialExperiment} object.}
}
}

\section{Other methods}{

\describe{
\item{\code{scaleFactors(x, sample_id, image_id)}: }{
  Getter to return the scale factors associated with the 
  \code{sample_id}(s) and \code{image_id}(s) provided. 
  This is related to the stored image(s) in the \code{SpatialExperiment} 
  \code{imgData} structure. See argument descriptions for further details.}
}
}

\examples{
example(read10xVisium)

# spatialCoords returns a numeric matrix
head(spatialCoords(spe))

# change spatial coordinate names
spatialCoordsNames(spe)
spatialCoordsNames(spe) <- c("x", "y")
head(spatialCoords(spe))

# imgData and scale factors
imgData(spe)
scaleFactors(spe)

# tabulate number of spots mapped to tissue
cd <- colData(spe)
table(
  in_tissue = cd$in_tissue, 
  sample_id = cd$sample_id)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show.R
\name{SpatialExperiment-misc}
\alias{SpatialExperiment-misc}
\alias{show,SpatialExperiment-method}
\title{Miscellaneous SpatialExperiment methods}
\usage{
\S4method{show}{SpatialExperiment}(object)
}
\arguments{
\item{object}{a \code{\link{SpatialExperiment}} object}
}
\value{
Returns NULL
}
\description{
Miscellaneous methods for the \code{\link{SpatialExperiment}} class and its
descendants that do not fit into any other documentation category such as,
for example, show methods.
}
\examples{
example(read10xVisium)
spe
}
\author{
Dario Righelli and Helena L. Crowell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coerce.R
\name{SpatialExperiment-coercion}
\alias{SpatialExperiment-coercion}
\alias{coerce,}
\alias{SingleCellExperiment,}
\alias{SpatialExperiment-method}
\alias{toSpatialExperiment}
\title{SpatialExperiment coercion methods}
\arguments{
\item{sce}{A \code{\link{SingleCellExperiment}} object.}

\item{sample_id}{A \code{character} sample identifier, which matches the
\code{sample_id} in \code{\link{imgData}}. The \code{sample_id} will also
be stored in a new column in \code{\link{colData}}, if not already present.
Default = \code{sample01}.}

\item{spatialCoordsNames}{A \code{character} vector of column names from
\code{\link{colData}} containing spatial coordinates, which will be
accessible with \code{\link{spatialCoords}}. Alternatively, the
\code{spatialCoords} argument may be provided. If both are provided,
\code{spatialCoordsNames} is given precedence, and a warning is returned.
Default = \code{c("x", "y")}.}

\item{spatialCoords}{A numeric matrix containing columns of spatial
coordinates, which will be accessible with \code{\link{spatialCoords}}.
Alternatively, \code{spatialCoordsNames} may be provided. If both are
provided, \code{spatialCoordsNames} is given precedence, and a warning is
returned.}

\item{scaleFactors}{Optional scale factors associated with the image(s). This
can be provided as a numeric value, numeric vector, list, or file path to a
JSON file for the 10x Genomics Visium platform. For 10x Genomics Visium,
the correct scale factor will automatically be selected depending on the
resolution of the image from \code{imageSources}. Default = \code{1}.}

\item{imgData}{Optional \code{\link{DataFrame}} containing the image data.
Alternatively, this can be built from the arguments \code{imageSources} and
\code{image_id} (see Details).}

\item{imageSources}{Optional file path(s) or URL(s) for one or more image
sources.}

\item{image_id}{Optional character vector (same length as
\code{imageSources}) containing unique image identifiers.}

\item{loadImage}{Logical indicating whether to load image into memory.
Default = \code{FALSE}.}

\item{spatialDataNames}{(Deprecated) A \code{character} vector of column
names from \code{\link{colData}} to include in \code{\link{spatialData}}.
Alternatively, the \code{spatialData} argument may be provided. If both are
provided, \code{spatialDataNames} is given precedence, and a warning is
returned. (Note: \code{spatialData} and \code{spatialDataNames} have been
deprecated; \code{colData} and \code{spatialCoords} should be used for all
columns. The arguments have been retained for backward compatibility but
may be removed in the future.)}

\item{spatialData}{(Deprecated) A \code{\link{DataFrame}} containing columns
to store in \code{\link{spatialData}}, which must contain at least the
columns of spatial coordinates. Alternatively, \code{spatialDataNames} may
be provided. If both are provided, \code{spatialDataNames} is given
precedence, and a warning is returned. (Note: \code{spatialData} and
\code{spatialDataNames} have been deprecated; \code{colData} and
\code{spatialCoords} should be used for all columns. The arguments have
been retained for backward compatibility but may be removed in the future.)}
}
\description{
The \code{SpatialExperiment} class inherits from the
\code{SingleCellExperiment} class making it necessary to coerce between these
classes.
To do so, we designed two different methods: the traditional \code{as} method
and the \code{toSpatialExperiment} function (recommended).
The \code{as} method checks if the \code{SingleCellExperiment} object has
already populated \code{int_colData} with three elements:
\code{spatialData}, \code{spatialCoords}, and \code{imgData}.
It also checks if \code{colData} already contains a \code{sample_id}.
In case these checks pass the new \code{SpatialExperiment} will have the same
values as the \code{SingleCellExperiment} passed object.
Otherwise a \code{SpatialExperiment} with default values for these slots
will be created.

The \code{toSpatialExperiment} method expects a \code{SingleCellExperiment} object
and additional arguments as explained in the related section of this
documentation. In case the \code{SingleCellExperiment} object has already
populated \code{int_colData} with \code{spatialData} and/or
\code{spatialCoords} and/or \code{imgData}, these will be respectively
overwritten in case the arguments \code{spatialData}/\code{spatialDataNames} 
and/or \code{spatialCoords}/\code{spatialCoordsNames} and/or \code{imgData} 
are not \code{NULL}.
}
\examples{
dir <- system.file(
    file.path("extdata", "10xVisium", "section1", "outs"),
    package = "SpatialExperiment")

# read in counts
fnm <- file.path(dir, "raw_feature_bc_matrix")
sce <- DropletUtils::read10xCounts(fnm)

# read in spatial coordinates
fnm <- file.path(dir, "spatial", "tissue_positions_list.csv")
xyz <- read.csv(fnm, header = FALSE,
    col.names = c("barcode", "in_tissue", "array_row", "array_col",
    "pxl_row_in_fullres", "pxl_col_in_fullres"))

# read in image data
img <- readImgData(
    path = file.path(dir, "spatial"),
    sample_id = "sample01")

## as method
(spe <- as(sce, "SpatialExperiment"))

colData(sce) <- DataFrame(xyz[,c(1:4)])
int_colData(sce)$spatialCoords <- as.matrix(xyz[,c(5,6)])

## Coercing an sce without imgData
(spe <- as(sce, "SpatialExperiment"))

## Coercing an sce with imgData
int_colData(sce)$imgData <- img
(spe <- as(sce, "SpatialExperiment"))

## toSpatialExperiment method
colData(sce) <- DataFrame(xyz)
(spe <- toSpatialExperiment(sce,
    imgData = img,
    spatialCoordsNames = c("pxl_col_in_fullres", "pxl_row_in_fullres"),
    sample_id = "sample01"))
}
